-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.0
-- //
-- //===========================================================================
-- //
--
-- For testing SPEC parser and tree-printer
--

import qualified SEQ.UPL_Parser (pSeqProg)
import qualified SEQ.UPLSQL_Parser (pSeqProg)
import SEQ_tree (dispSeqProg)
import LITEScanner.Scanner
import qualified TYPE.Scannerspec
import qualified EXPR.Scannerspec
import qualified STMT.Scannerspec
import qualified SEQ.Scannerspec
import UU.Parsing 
import UU.Scanner(Token(..),Pos(..))
import ParserStuff
import TestStuff


logFile :: Maybe String
logFile = Nothing
--logFile = Just "./testlogs/SEQ_parseprinting.testlog"

scanner = fileScanner 
		(ss_MERGE 
		  [TYPE.Scannerspec.scannerspec,
		   EXPR.Scannerspec.scannerspec,
		   STMT.Scannerspec.scannerspec,
		   SEQ.Scannerspec.scannerspec])

data ParsingMode =
	  UPL
	| UPLSQL
	deriving Show

parser mode input =  parseFile NoCorrection scanner pProg input
	where
	pProg = case mode of
		UPL    -> SEQ.UPL_Parser.pSeqProg
		UPLSQL -> SEQ.UPLSQL_Parser.pSeqProg

--
-- Show tree, surpressed typing info
--
showTree = dispSeqProg False

putSTR_ s = putSTR logFile s

test mode inputs = do
	{ putSTR_ "\n>\n>Testing SEQ parser. Resulting tree is echoed.\n>" ;
	  putSTR_ (show mode ++ " mode\n>") ;
	  testParser (parser mode) showError showTree logFile inputs 
	}
	where
	showError = showParsingError ShowErrorMode_1

runTest = do 
	{initializeLogFile logFile 
	 ; test UPL testfiles1 
	 ; test UPLSQL testfiles2 
	}

testfilesDir = "./testfiles/"

testfiles1 = map (testfilesDir ++)
  	["1.seq" ]

testfiles2 = map (testfilesDir ++)
  	["1.seq",
	 "2.seq" 
	]


