-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.0
-- //
-- //===========================================================================
-- //
--
-- For testing SPEC parser and tree-printer
--
import Lang.SEQ.PCKG
import Lang.SEQ.Parsers
import MechScanner.PCKG
import UU.Pretty
import SupportLib.MoreParser
import SupportLib.MoreIO
import DevTest.ParserTestLib
import Configuration.Lang

logFile :: Maybe String
--logFile = Nothing
logFile = Just "./testlogs/SEQ_parseprinting.testlog"

scanner = fileScanner scannerspec

data ParsingMode =
	  PL
	| QL
	deriving Show

parser mode input =  parseFile scanner pSeq_ input
	where
	pSeq_ = case mode of
		PL   -> pSeqProg_PL 
		QL   -> pSeqProg_QL 

showErrorMode = ShowErrorMode_SOME 1

test mode inputs = do
	{ println ""
	; println "Testing SEQ parser in " 
	; print (show mode ++ " mode. Resulting tree is echoed:") 
	; testParser (parser mode) showErrorMode (ppSeqProgTree False) logFile inputs 
	; println ""
        ; println "Now with pretty printing:" 
	; testParser (parser mode) showErrorMode pp logFile inputs
	; println "" 
	}
	where
	print   s = logStr logFile s
	println s = print ('\n' : s) 

runTest = do 
	{initializeLogFile logFile 
	 ; test PL testfiles1
	 ; test QL testfiles2
	}

testfilesDir = "./testfiles/"

testfiles1 = map (testfilesDir ++)
  	["1.seq" ]

testfiles2 = map (testfilesDir ++)
  	["1.seq",
	 "2.seq" 
	]


