-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.0
-- //
-- //===========================================================================
-- //

import Lang.STMT.PCKG
import Lang.STMT.Parsers
import MechScanner.PCKG
import UU.Pretty
import SupportLib.MoreParser
import SupportLib.MoreIO
import DevTest.ParserTestLib
import Configuration.Lang

logFile :: Maybe String
--logFile = Nothing
logFile = Just "./testlogs/STMT_parseprinting.testlog"

scanner = stringScanner scannerspec

data ParsingMode =
	  PL
	| QL
	deriving Show

parser mode input =  parseString scanner pStmt_ input
	where
	pStmt_ = case mode of
		PL   -> pStmt_PL 
		QL   -> pStmt_QL 

showErrorMode = ShowErrorMode_SOME 1

test mode inputs = do
	{ println ""
	; println "Testing STMT parser in " 
	; print (show mode ++ " mode. Resulting tree is echoed:") 
	; testParser (parser mode) showErrorMode (ppStmtTree False) logFile inputs 
	; println ""
        ; println "Now with pretty printing:" 
	; testParser (parser mode) showErrorMode pp logFile inputs
	; println "" 
	}
	where
	print   s = logStr logFile s
	println s = print ('\n' : s) 

runTest = do 
	{initializeLogFile logFile 
	 ; test PL testdata 
	 ; test QL testdata 
	}

testdata =
	["skip",
	 "x:=x+1",
	 "x.Name := \"Foo\"",

-- current parse cannot handle this (go into infinite repair loop):
--	 "x.Flag := (!i :- i from 0 to #a -: (a[i]).Val = 0)",

	 "x[i+a[i]] := 0",
	 "(x[i][j+1]).Name := \"Foo\"",
	 "query := select {Id = s.Id, Name = s.Name} from s<-personelDb where somecondition"
	]




