-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.0
-- //
-- //===========================================================================
-- //
--
-- For testing TYPE parser and pretty-printers
--

import Lang.TYPE.PCKG
import Lang.TYPE.Parsers
import MechScanner.PCKG
import UU.Pretty
import SupportLib.MoreParser
import SupportLib.MoreIO
import DevTest.ParserTestLib


logFile = Nothing
--logFile = Just "./testlogs/TYPE_parseprint.testlog"

scanner = stringScanner scannerspec

data ParsingMode =
	  FULL
	| CONCRETE
	| POLYLIST
	deriving Show

parser mode input =  parseString scanner pType_ input
	where
	pType_ = case mode of
			FULL		-> pType
			CONCRETE	-> pConcreteType
			POLYLIST	-> pType_PolyL

showErrorMode = ShowErrorMode_SOME 1

test mode inputs = do
	{ println ""
	; println "Parsing TYPE in " 
	; print (show mode ++ " mode. Echoing parse tree.") 
	; println ""
	; testParser (parser mode) showErrorMode (text . show) logFile inputs 
	; println ""
	; println "Now with pretty printing..." 
	; println ""
	; testParser (parser mode) showErrorMode pp logFile inputs 
	}
	where
	print   s = logStr logFile s
	println s = print ('\n' : s) 

runTest = do 
	{initializeLogFile logFile 
	 ; test FULL testdata 
	 ; test CONCRETE testdata 
	 ; test POLYLIST testdata
	}


testdata =
	["Int",
	 "MyType",
	 "Int->Int", 
	 "Int[]->(a->b)->c[]",	
	 "[Int]",
	 "Record { FirstName,LastName::String; Address::Address; Notes::String[] }",
 	 "Record { Name::String; Address :: Record {City::String; PostCode::String} }" 
	]

