-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.0
-- //
-- //===========================================================================
-- //
--
-- For testing SEQ level type checker
--

import Lang.SEQ.PCKG
import Lang.SEQ.Parsers
import MechScanner.PCKG
import UU.Pretty
import SupportLib.MoreParser
import SupportLib.MoreIO
import DevTest.TCTestLib
import Configuration.Lang

logFile :: Maybe String
--logFile = Nothing
logFile = Just "./testlogs/SEQ_typechecker.testlog"

scanner = fileScanner scannerspec

data ParsingMode =
	  PL
	| QL
	deriving Show

parser mode input =  parseFile scanner pSeq_ input
	where
	pSeq_ = case mode of
		PL   -> pSeqProg_PL 
		QL   -> pSeqProg_QL 

showErrorMode = ShowErrorMode_SOME 1

test mode inputs = do
	{ println ""
	; println "Testing SEQ type checker in " 
	; print (show mode ++ " mode.") 
	; testTC (parser mode) showErrorMode logFile inputs 
	; println ""
	}
	where
	print   s = logStr logFile s
	println s = print ('\n' : s) 

runTest = do 
	{initializeLogFile logFile 
	 ; test PL testfiles1
	 ; test QL testfiles2
	}

testfilesDir = "./testfiles/"

testfiles1 = map (testfilesDir ++)
  	["1.seq" ]

testfiles2 = map (testfilesDir ++)
  	["1.seq"
	,"2.seq"
	]
