(* //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.1
-- //
-- //======================================================================== *)
(* // *)
open Parse HolKernel boolLib bossLib integerTheory x_StdConstTheory

val _ = new_theory "dflag" ;

val isRed_def    = Define `isRed x   = (x=0)` ;
val isWhite_def  = Define `isWhite x = (x=1)` ;
val isBlue_def   = Define `isBlue x  = (x=2)` ;

val allRWB_def   = Define
	`allRWB a = !i. 0<= i /\ i < arraySize a 
			==>
			(isRed (a ArrayApp i) \/
			 isWhite (a ArrayApp i) \/
			 isBlue (a ArrayApp i) )` ;

val cntRed_def   = Define 
	`cntRed a   
	 = 
	 & (LENGTH (FILTER isRed (ArrayDom a 0 (arraySize a))))` ;

val cntWhite_def = Define 
	`cntWhite a 
	 = 
	 & (LENGTH (FILTER isWhite (ArrayDom a 0 (arraySize a))))` ;

val cntBlue_def  = Define 
	`cntBlue a  
	 = 
	 & (LENGTH (FILTER isBlue (ArrayDom a 0 (arraySize a))))` ;

val dutchSorted_def
	=
	Define `dutchSorted a
		=
		(?b r. 0<=b /\ b<=r /\ r<= arraySize a /\
			(!i. 0<=i /\ i<b ==>  isBlue (a ArrayApp i)) /\
			(!i. b<=i /\ i<r ==>  isWhite (a ArrayApp i)) /\
			(!i. r<=i /\ i<arraySize a ==>  isRed (a ArrayApp i)) 
		)` ;

val _ = export_theory() ; 

