signature dflagTheory =
sig
  type thm = Thm.thm
  
  (*  Definitions  *)
    val allRWB_def : thm
    val cntBlue_def : thm
    val cntRed_def : thm
    val cntWhite_def : thm
    val dutchSorted_def : thm
    val isBlue_def : thm
    val isRed_def : thm
    val isWhite_def : thm
  
  val dflag_grammars : type_grammar.grammar * term_grammar.grammar
(*
   [x_StdConst] Parent theory of "dflag"
   
   [allRWB_def]  Definition
      
      |- !a.
           allRWB a =
           !i.
             0 <= i /\ i < arraySize a ==>
             isRed (a ArrayApp i) \/ isWhite (a ArrayApp i) \/
             isBlue (a ArrayApp i)
   
   [cntBlue_def]  Definition
      
      |- !a.
           cntBlue a =
           & (LENGTH (FILTER isBlue (ArrayDom a 0 (arraySize a))))
   
   [cntRed_def]  Definition
      
      |- !a.
           cntRed a =
           & (LENGTH (FILTER isRed (ArrayDom a 0 (arraySize a))))
   
   [cntWhite_def]  Definition
      
      |- !a.
           cntWhite a =
           & (LENGTH (FILTER isWhite (ArrayDom a 0 (arraySize a))))
   
   [dutchSorted_def]  Definition
      
      |- !a.
           dutchSorted a =
           ?b r.
             0 <= b /\ b <= r /\ r <= arraySize a /\
             (!i. 0 <= i /\ i < b ==> isBlue (a ArrayApp i)) /\
             (!i. b <= i /\ i < r ==> isWhite (a ArrayApp i)) /\
             !i. r <= i /\ i < arraySize a ==> isRed (a ArrayApp i)
   
   [isBlue_def]  Definition
      
      |- !x. isBlue x = (x = 2)
   
   [isRed_def]  Definition
      
      |- !x. isRed x = (x = 0)
   
   [isWhite_def]  Definition
      
      |- !x. isWhite x = (x = 1)
   
   
*)
end
