structure dflagTheory :> dflagTheory =
struct
  open Type Term Thm
  infixr -->
  fun C s t ty = mk_thy_const{Name=s,Thy=t,Ty=ty}
  fun T s t A = mk_thy_type{Tyop=s, Thy=t,Args=A}
  fun V s q = mk_var(s,q)
  val U     = mk_vartype
  
  (*  Parents *)
  local open x_StdConstTheory
  in end;
  val _ = Theory.link_parents
          ("dflag",11519182,0)
          [("x_StdConst",11519139,0)];
  val _ = Theory.incorporate_types "dflag" [];
  val _ = Theory.incorporate_consts "dflag"
     [("allRWB",((T"ARRAY" "x_StdConst" [T"int" "integer" []] --> bool))),
      ("cntWhite",
       ((T"ARRAY" "x_StdConst" [T"int" "integer" []] -->
         T"int" "integer" []))),
      ("isBlue",((T"int" "integer" [] --> bool))),
      ("isWhite",((T"int" "integer" [] --> bool))),
      ("cntRed",
       ((T"ARRAY" "x_StdConst" [T"int" "integer" []] -->
         T"int" "integer" []))),
      ("cntBlue",
       ((T"ARRAY" "x_StdConst" [T"int" "integer" []] -->
         T"int" "integer" []))),
      ("dutchSorted",
       ((T"ARRAY" "x_StdConst" [T"int" "integer" []] --> bool))),
      ("isRed",((T"int" "integer" [] --> bool)))];
  
  local
  val share_table = Vector.fromList
  [C"!" "bool" (((T"int" "integer" [] --> bool) --> bool)),
   V"x" (T"int" "integer" []), C"=" "min" ((bool --> (bool --> bool))),
   C"isRed" "dflag" ((T"int" "integer" [] --> bool)),
   C"=" "min" ((T"int" "integer" [] --> (T"int" "integer" [] --> bool))),
   C"int_of_num" "integer" ((T"num" "num" [] --> T"int" "integer" [])),
   C"0" "num" (T"num" "num" []),
   C"isWhite" "dflag" ((T"int" "integer" [] --> bool)),
   C"NUMERAL" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"NUMERAL_BIT1" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"ALT_ZERO" "arithmetic" (T"num" "num" []),
   C"isBlue" "dflag" ((T"int" "integer" [] --> bool)),
   C"NUMERAL_BIT2" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"!" "bool"
    (((T"ARRAY" "x_StdConst" [T"int" "integer" []] --> bool) --> bool)),
   V"a" (T"ARRAY" "x_StdConst" [T"int" "integer" []]),
   C"allRWB" "dflag"
    ((T"ARRAY" "x_StdConst" [T"int" "integer" []] --> bool)),
   V"i" (T"int" "integer" []), C"==>" "min" ((bool --> (bool --> bool))),
   C"/\\" "bool" ((bool --> (bool --> bool))),
   C"int_le" "integer"
    ((T"int" "integer" [] --> (T"int" "integer" [] --> bool))),
   C"int_lt" "integer"
    ((T"int" "integer" [] --> (T"int" "integer" [] --> bool))),
   C"arraySize" "x_StdConst"
    ((T"ARRAY" "x_StdConst" [T"int" "integer" []] -->
      T"int" "integer" [])), C"\\/" "bool" ((bool --> (bool --> bool))),
   C"ArrayApp" "x_StdConst"
    ((T"ARRAY" "x_StdConst" [T"int" "integer" []] -->
      (T"int" "integer" [] --> T"int" "integer" []))),
   C"cntRed" "dflag"
    ((T"ARRAY" "x_StdConst" [T"int" "integer" []] -->
      T"int" "integer" [])),
   C"LENGTH" "list"
    ((T"list" "list" [T"int" "integer" []] --> T"num" "num" [])),
   C"FILTER" "list"
    (((T"int" "integer" [] --> bool) -->
      (T"list" "list" [T"int" "integer" []] -->
       T"list" "list" [T"int" "integer" []]))),
   C"ArrayDom" "x_StdConst"
    ((T"ARRAY" "x_StdConst" [T"int" "integer" []] -->
      (T"int" "integer" [] -->
       (T"int" "integer" [] --> T"list" "list" [T"int" "integer" []])))),
   C"cntWhite" "dflag"
    ((T"ARRAY" "x_StdConst" [T"int" "integer" []] -->
      T"int" "integer" [])),
   C"cntBlue" "dflag"
    ((T"ARRAY" "x_StdConst" [T"int" "integer" []] -->
      T"int" "integer" [])),
   C"dutchSorted" "dflag"
    ((T"ARRAY" "x_StdConst" [T"int" "integer" []] --> bool)),
   C"?" "bool" (((T"int" "integer" [] --> bool) --> bool)),
   V"b" (T"int" "integer" []), V"r" (T"int" "integer" [])]
  val DT = Thm.disk_thm share_table
  in
  val isRed_def =
    DT("", [], `(%0 (\%1. ((%2 (%3 $0)) ((%4 $0) (%5 %6)))))`)
  val isWhite_def =
    DT("", [], `(%0 (\%1. ((%2 (%7 $0)) ((%4 $0) (%5 (%8 (%9 %10)))))))`)
  val isBlue_def =
    DT("", [], `(%0 (\%1. ((%2 (%11 $0)) ((%4 $0) (%5 (%8 (%12 %10)))))))`)
  val allRWB_def =
    DT("", [],
       `(%13 (\%14. ((%2 (%15 $0)) (%0 (\%16. ((%17 ((%18 ((%19 (%5 %6))
       $0)) ((%20 $0) (%21 $1)))) ((%22 (%3 ((%23 $1) $0))) ((%22 (%7 ((%23
       $1) $0))) (%11 ((%23 $1) $0))))))))))`)
  val cntRed_def =
    DT("", [],
       `(%13 (\%14. ((%4 (%24 $0)) (%5 (%25 ((%26 %3) (((%27 $0) (%5 %6))
       (%21 $0))))))))`)
  val cntWhite_def =
    DT("", [],
       `(%13 (\%14. ((%4 (%28 $0)) (%5 (%25 ((%26 %7) (((%27 $0) (%5 %6))
       (%21 $0))))))))`)
  val cntBlue_def =
    DT("", [],
       `(%13 (\%14. ((%4 (%29 $0)) (%5 (%25 ((%26 %11) (((%27 $0) (%5 %6))
       (%21 $0))))))))`)
  val dutchSorted_def =
    DT("", [],
       `(%13 (\%14. ((%2 (%30 $0)) (%31 (\%32. (%31 (\%33. ((%18 ((%19 (%5
       %6)) $1)) ((%18 ((%19 $1) $0)) ((%18 ((%19 $0) (%21 $2))) ((%18 (%0
       (\%16. ((%17 ((%18 ((%19 (%5 %6)) $0)) ((%20 $0) $2))) (%11 ((%23
       $3) $0)))))) ((%18 (%0 (\%16. ((%17 ((%18 ((%19 $2) $0)) ((%20 $0)
       $1))) (%7 ((%23 $3) $0)))))) (%0 (\%16. ((%17 ((%18 ((%19 $1) $0))
       ((%20 $0) (%21 $3)))) (%3 ((%23 $3) $0)))))))))))))))))`)
  end
  val _ = DB.bindl "dflag"
  [("isRed_def",isRed_def,DB.Def), ("isWhite_def",isWhite_def,DB.Def),
   ("isBlue_def",isBlue_def,DB.Def), ("allRWB_def",allRWB_def,DB.Def),
   ("cntRed_def",cntRed_def,DB.Def), ("cntWhite_def",cntWhite_def,DB.Def),
   ("cntBlue_def",cntBlue_def,DB.Def),
   ("dutchSorted_def",dutchSorted_def,DB.Def)]
  
  local open Portable GrammarSpecials Parse
  in
  val _ = mk_local_grms [("x_StdConstTheory.x_StdConst_grammars",
                          x_StdConstTheory.x_StdConst_grammars)]
  val _ = List.app (update_grms reveal) []
  val _ = update_grms
       (temp_overload_on_by_nametype "isRed")
        {Name = "isRed", Thy = "dflag"}
  val _ = update_grms
       (temp_overload_on_by_nametype "isWhite")
        {Name = "isWhite", Thy = "dflag"}
  val _ = update_grms
       (temp_overload_on_by_nametype "isBlue")
        {Name = "isBlue", Thy = "dflag"}
  val _ = update_grms
       (temp_overload_on_by_nametype "allRWB")
        {Name = "allRWB", Thy = "dflag"}
  val _ = update_grms
       (temp_overload_on_by_nametype "cntRed")
        {Name = "cntRed", Thy = "dflag"}
  val _ = update_grms
       (temp_overload_on_by_nametype "cntWhite")
        {Name = "cntWhite", Thy = "dflag"}
  val _ = update_grms
       (temp_overload_on_by_nametype "cntBlue")
        {Name = "cntBlue", Thy = "dflag"}
  val _ = update_grms
       (temp_overload_on_by_nametype "dutchSorted")
        {Name = "dutchSorted", Thy = "dflag"}
  val dflag_grammars = Parse.current_lgrms()
  end
  
  
  val _ = computeLib.add_funs [isRed_def];  
  
  val _ = computeLib.add_funs [isWhite_def];  
  
  val _ = computeLib.add_funs [isBlue_def];  
  
  val _ = computeLib.add_funs [allRWB_def];  
  
  val _ = computeLib.add_funs [cntRed_def];  
  
  val _ = computeLib.add_funs [cntWhite_def];  
  
  val _ = computeLib.add_funs [cntBlue_def];  
  
  val _ = computeLib.add_funs [dutchSorted_def];  
end
