(* //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.1
-- //
-- //======================================================================== *)
(* // *)
open Parse HolKernel boolLib integerTheory

val _ = new_theory "xgcd" ;

val _ = new_constant ("gcd", Type `:int->int->int`) ;

val gcd_ora1 = 
	let
	val asm = [--`x>0`--]
	val thm  = mk_oracle_thm 
			(Tag.read "gcd_ora1")
			(asm,--`gcd x x = x`--)
	in
	save_thm ("gcd_ora1",thm)
	end ;

val gcd_ora2 = 
	let
	val asm = [--`x>0`--, --`y>x`--]
	val thm  = mk_oracle_thm 
			(Tag.read "gcd_ora2")
			(asm,--`gcd x (y-x) = gcd x y`--)
	in
	save_thm ("gcd_ora2",thm)
	end ;

val gcd_ora3 = 
	let
	val asm = [--`y>0`--, --`x>y`--]
	val thm  = mk_oracle_thm 
			(Tag.read "gcd_ora3")
			(asm,--`gcd (x-y) y = gcd x y`--)
	in
	save_thm ("gcd_ora3",thm)
	end ;

val _ = export_theory() ; 

