structure xgcdTheory :> xgcdTheory =
struct
  open Type Term Thm
  infixr -->
  fun C s t ty = mk_thy_const{Name=s,Thy=t,Ty=ty}
  fun T s t A = mk_thy_type{Tyop=s, Thy=t,Args=A}
  fun V s q = mk_var(s,q)
  val U     = mk_vartype
  
  (*  Parents *)
  local open integerTheory
  in end;
  val _ = Theory.link_parents ("xgcd",11519170,0) [("integer",6038418,0)];
  val _ = Theory.incorporate_types "xgcd" [];
  val _ = Theory.incorporate_consts "xgcd"
     [("gcd",
       ((T"int" "integer" [] -->
         (T"int" "integer" [] --> T"int" "integer" []))))];
  
  local
  val share_table = Vector.fromList
  [C"=" "min" ((T"int" "integer" [] --> (T"int" "integer" [] --> bool))),
   C"gcd" "xgcd"
    ((T"int" "integer" [] -->
      (T"int" "integer" [] --> T"int" "integer" []))),
   V"x" (T"int" "integer" []),
   C"int_gt" "integer"
    ((T"int" "integer" [] --> (T"int" "integer" [] --> bool))),
   C"int_of_num" "integer" ((T"num" "num" [] --> T"int" "integer" [])),
   C"0" "num" (T"num" "num" []),
   C"int_sub" "integer"
    ((T"int" "integer" [] -->
      (T"int" "integer" [] --> T"int" "integer" []))),
   V"y" (T"int" "integer" [])]
  val DT = Thm.disk_thm share_table
  in
  val gcd_ora1 =
    DT("gcd_ora1", [`((%3 %2) (%4 %5))`], `((%0 ((%1 %2) %2)) %2)`)
  val gcd_ora2 =
    DT("gcd_ora2", [`((%3 %2) (%4 %5))`, `((%3 %7) %2)`],
       `((%0 ((%1 %2) ((%6 %7) %2))) ((%1 %2) %7))`)
  val gcd_ora3 =
    DT("gcd_ora3", [`((%3 %2) %7)`, `((%3 %7) (%4 %5))`],
       `((%0 ((%1 ((%6 %2) %7)) %7)) ((%1 %2) %7))`)
  end
  val _ = DB.bindl "xgcd"
  [("gcd_ora1",gcd_ora1,DB.Thm), ("gcd_ora2",gcd_ora2,DB.Thm),
   ("gcd_ora3",gcd_ora3,DB.Thm)]
  
  local open Portable GrammarSpecials Parse
  in
  val _ = mk_local_grms [("integerTheory.integer_grammars",
                          integerTheory.integer_grammars)]
  val _ = List.app (update_grms reveal) []
  val _ = update_grms
       (temp_overload_on_by_nametype "gcd")
        {Name = "gcd", Thy = "xgcd"}
  val xgcd_grammars = Parse.current_lgrms()
  end
  
end
