(* //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.1
-- //
-- //======================================================================== *)
(* // *)
open Parse HolKernel boolLib bossLib stringTheory integerTheory x_StdConstTheory

val _ = new_theory "sde" ;

val _ = Hol_datatype `Account = <| Id : string; AccountNr : string; Saldo : int |>` ;

val deleteById_def 
	= 
	Define 
	`deleteById i db = FILTER (\r. ~(r.Id = i)) db` ;


val sumOfPositiveSaldo_def
	=
	Define
	`sumOfPositiveSaldo customer db
	 =
	 (SUM_ 
		o MAP (\r. r.Saldo)
		o FILTER (\r. (r.Id = customer) /\ (r.Saldo > 0))) db` ;

val _ = export_theory();
