structure sdeTheory :> sdeTheory =
struct
  open Type Term Thm
  infixr -->
  fun C s t ty = mk_thy_const{Name=s,Thy=t,Ty=ty}
  fun T s t A = mk_thy_type{Tyop=s, Thy=t,Args=A}
  fun V s q = mk_var(s,q)
  val U     = mk_vartype
  
  (*  Parents *)
  local open stringTheory x_StdConstTheory
  in end;
  val _ = Theory.link_parents
          ("sde",11519196,0)
          [("string",6037964,0), ("x_StdConst",11519139,0)];
  val _ = Theory.incorporate_types "sde" [("Account",0)];
  val _ = Theory.incorporate_consts "sde"
     [("Account_size",((T"Account" "sde" [] --> T"num" "num" []))),
      ("mk_Account",
       ((T"recspace" "ind_type"
          [T"prod" "pair"
            [T"string" "string" [],
             T"prod" "pair" [T"string" "string" [], T"int" "integer" []]]]
         --> T"Account" "sde" []))),
      ("deleteById",
       ((T"string" "string" [] -->
         (T"list" "list" [T"Account" "sde" []] -->
          T"list" "list" [T"Account" "sde" []])))),
      ("Account_Saldo_fupd",
       (((T"int" "integer" [] --> T"int" "integer" []) -->
         (T"Account" "sde" [] --> T"Account" "sde" [])))),
      ("sde0",
       ((T"string" "string" [] -->
         (T"string" "string" [] -->
          (T"int" "integer" [] --> T"Account" "sde" []))))),
      ("sumOfPositiveSaldo",
       ((T"string" "string" [] -->
         (T"list" "list" [T"Account" "sde" []] --> T"int" "integer" [])))),
      ("Account_AccountNr_update",
       ((T"string" "string" [] -->
         (T"Account" "sde" [] --> T"Account" "sde" [])))),
      ("Account_Id_fupd",
       (((T"string" "string" [] --> T"string" "string" []) -->
         (T"Account" "sde" [] --> T"Account" "sde" [])))),
      ("Account_Saldo_update",
       ((T"int" "integer" [] -->
         (T"Account" "sde" [] --> T"Account" "sde" [])))),
      ("Account_Saldo",((T"Account" "sde" [] --> T"int" "integer" []))),
      ("Account_Id_update",
       ((T"string" "string" [] -->
         (T"Account" "sde" [] --> T"Account" "sde" [])))),
      ("dest_Account",
       ((T"Account" "sde" [] -->
         T"recspace" "ind_type"
          [T"prod" "pair"
            [T"string" "string" [],
             T"prod" "pair"
              [T"string" "string" [], T"int" "integer" []]]]))),
      ("Account_case",
       (((T"string" "string" [] -->
          (T"string" "string" [] --> (T"int" "integer" [] --> alpha))) -->
         (T"Account" "sde" [] --> alpha)))),
      ("Account",
       ((T"string" "string" [] -->
         (T"string" "string" [] -->
          (T"int" "integer" [] --> T"Account" "sde" []))))),
      ("Account_AccountNr_fupd",
       (((T"string" "string" [] --> T"string" "string" []) -->
         (T"Account" "sde" [] --> T"Account" "sde" [])))),
      ("Account_AccountNr",
       ((T"Account" "sde" [] --> T"string" "string" []))),
      ("Account_Id",((T"Account" "sde" [] --> T"string" "string" [])))];
  
  local
  val share_table = Vector.fromList
  [C"?" "bool"
    ((((T"Account" "sde" [] -->
        T"recspace" "ind_type"
         [T"prod" "pair"
           [T"string" "string" [],
            T"prod" "pair" [T"string" "string" [], T"int" "integer" []]]])
       --> bool) --> bool)),
   V"rep"
    ((T"Account" "sde" [] -->
      T"recspace" "ind_type"
       [T"prod" "pair"
         [T"string" "string" [],
          T"prod" "pair" [T"string" "string" [], T"int" "integer" []]]])),
   C"TYPE_DEFINITION" "bool"
    (((T"recspace" "ind_type"
        [T"prod" "pair"
          [T"string" "string" [],
           T"prod" "pair" [T"string" "string" [], T"int" "integer" []]]]
       --> bool) -->
      ((T"Account" "sde" [] -->
        T"recspace" "ind_type"
         [T"prod" "pair"
           [T"string" "string" [],
            T"prod" "pair" [T"string" "string" [], T"int" "integer" []]]])
       --> bool))),
   V"a0'"
    (T"recspace" "ind_type"
      [T"prod" "pair"
        [T"string" "string" [],
         T"prod" "pair" [T"string" "string" [], T"int" "integer" []]]]),
   C"!" "bool"
    ((((T"recspace" "ind_type"
         [T"prod" "pair"
           [T"string" "string" [],
            T"prod" "pair" [T"string" "string" [], T"int" "integer" []]]]
        --> bool) --> bool) --> bool)),
   V"'Account'"
    ((T"recspace" "ind_type"
       [T"prod" "pair"
         [T"string" "string" [],
          T"prod" "pair" [T"string" "string" [], T"int" "integer" []]]] -->
      bool)), C"==>" "min" ((bool --> (bool --> bool))),
   C"!" "bool"
    (((T"recspace" "ind_type"
        [T"prod" "pair"
          [T"string" "string" [],
           T"prod" "pair" [T"string" "string" [], T"int" "integer" []]]]
       --> bool) --> bool)),
   C"?" "bool" (((T"string" "string" [] --> bool) --> bool)),
   V"a0" (T"string" "string" []), V"a1" (T"string" "string" []),
   C"?" "bool" (((T"int" "integer" [] --> bool) --> bool)),
   V"a2" (T"int" "integer" []),
   C"=" "min"
    ((T"recspace" "ind_type"
       [T"prod" "pair"
         [T"string" "string" [],
          T"prod" "pair" [T"string" "string" [], T"int" "integer" []]]] -->
      (T"recspace" "ind_type"
        [T"prod" "pair"
          [T"string" "string" [],
           T"prod" "pair" [T"string" "string" [], T"int" "integer" []]]]
       --> bool))),
   C"CONSTR" "ind_type"
    ((T"num" "num" [] -->
      (T"prod" "pair"
        [T"string" "string" [],
         T"prod" "pair" [T"string" "string" [], T"int" "integer" []]] -->
       ((T"num" "num" [] -->
         T"recspace" "ind_type"
          [T"prod" "pair"
            [T"string" "string" [],
             T"prod" "pair" [T"string" "string" [], T"int" "integer" []]]])
        -->
        T"recspace" "ind_type"
         [T"prod" "pair"
           [T"string" "string" [],
            T"prod" "pair"
             [T"string" "string" [], T"int" "integer" []]]])))),
   C"0" "num" (T"num" "num" []),
   C"," "pair"
    ((T"string" "string" [] -->
      (T"prod" "pair" [T"string" "string" [], T"int" "integer" []] -->
       T"prod" "pair"
        [T"string" "string" [],
         T"prod" "pair" [T"string" "string" [], T"int" "integer" []]]))),
   C"," "pair"
    ((T"string" "string" [] -->
      (T"int" "integer" [] -->
       T"prod" "pair" [T"string" "string" [], T"int" "integer" []]))),
   V"n" (T"num" "num" []),
   C"BOTTOM" "ind_type"
    (T"recspace" "ind_type"
      [T"prod" "pair"
        [T"string" "string" [],
         T"prod" "pair" [T"string" "string" [], T"int" "integer" []]]]),
   C"/\\" "bool" ((bool --> (bool --> bool))),
   C"!" "bool" (((T"Account" "sde" [] --> bool) --> bool)),
   V"a" (T"Account" "sde" []),
   C"=" "min" ((T"Account" "sde" [] --> (T"Account" "sde" [] --> bool))),
   C"mk_Account" "sde"
    ((T"recspace" "ind_type"
       [T"prod" "pair"
         [T"string" "string" [],
          T"prod" "pair" [T"string" "string" [], T"int" "integer" []]]] -->
      T"Account" "sde" [])),
   C"dest_Account" "sde"
    ((T"Account" "sde" [] -->
      T"recspace" "ind_type"
       [T"prod" "pair"
         [T"string" "string" [],
          T"prod" "pair" [T"string" "string" [], T"int" "integer" []]]])),
   V"r"
    (T"recspace" "ind_type"
      [T"prod" "pair"
        [T"string" "string" [],
         T"prod" "pair" [T"string" "string" [], T"int" "integer" []]]]),
   C"=" "min" ((bool --> (bool --> bool))),
   C"=" "min"
    (((T"string" "string" [] -->
       (T"string" "string" [] -->
        (T"int" "integer" [] --> T"Account" "sde" []))) -->
      ((T"string" "string" [] -->
        (T"string" "string" [] -->
         (T"int" "integer" [] --> T"Account" "sde" []))) --> bool))),
   C"sde0" "sde"
    ((T"string" "string" [] -->
      (T"string" "string" [] -->
       (T"int" "integer" [] --> T"Account" "sde" [])))),
   C"Account" "sde"
    ((T"string" "string" [] -->
      (T"string" "string" [] -->
       (T"int" "integer" [] --> T"Account" "sde" [])))),
   C"!" "bool"
    ((((T"string" "string" [] -->
        (T"string" "string" [] --> (T"int" "integer" [] --> alpha))) -->
       bool) --> bool)),
   V"f"
    ((T"string" "string" [] -->
      (T"string" "string" [] --> (T"int" "integer" [] --> alpha)))),
   C"!" "bool" (((T"string" "string" [] --> bool) --> bool)),
   C"!" "bool" (((T"int" "integer" [] --> bool) --> bool)),
   C"=" "min" ((alpha --> (alpha --> bool))),
   C"Account_case" "sde"
    (((T"string" "string" [] -->
       (T"string" "string" [] --> (T"int" "integer" [] --> alpha))) -->
      (T"Account" "sde" [] --> alpha))),
   C"=" "min" ((T"num" "num" [] --> (T"num" "num" [] --> bool))),
   C"Account_size" "sde" ((T"Account" "sde" [] --> T"num" "num" [])),
   C"+" "arithmetic"
    ((T"num" "num" [] --> (T"num" "num" [] --> T"num" "num" []))),
   C"NUMERAL" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"NUMERAL_BIT1" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"ALT_ZERO" "arithmetic" (T"num" "num" []),
   C"STRLEN" "string" ((T"string" "string" [] --> T"num" "num" [])),
   V"s" (T"string" "string" []), V"s0" (T"string" "string" []),
   V"i" (T"int" "integer" []),
   C"=" "min"
    ((T"string" "string" [] --> (T"string" "string" [] --> bool))),
   C"Account_Id" "sde" ((T"Account" "sde" [] --> T"string" "string" [])),
   C"Account_AccountNr" "sde"
    ((T"Account" "sde" [] --> T"string" "string" [])),
   C"=" "min" ((T"int" "integer" [] --> (T"int" "integer" [] --> bool))),
   C"Account_Saldo" "sde" ((T"Account" "sde" [] --> T"int" "integer" [])),
   V"s1" (T"string" "string" []),
   C"Account_Id_update" "sde"
    ((T"string" "string" [] -->
      (T"Account" "sde" [] --> T"Account" "sde" []))),
   C"Account_AccountNr_update" "sde"
    ((T"string" "string" [] -->
      (T"Account" "sde" [] --> T"Account" "sde" []))),
   V"i0" (T"int" "integer" []),
   C"Account_Saldo_update" "sde"
    ((T"int" "integer" [] -->
      (T"Account" "sde" [] --> T"Account" "sde" []))),
   C"!" "bool"
    ((((T"string" "string" [] --> T"string" "string" []) --> bool) -->
      bool)), V"f" ((T"string" "string" [] --> T"string" "string" [])),
   V"x" (T"Account" "sde" []),
   C"Account_Id_fupd" "sde"
    (((T"string" "string" [] --> T"string" "string" []) -->
      (T"Account" "sde" [] --> T"Account" "sde" []))),
   C"Account_AccountNr_fupd" "sde"
    (((T"string" "string" [] --> T"string" "string" []) -->
      (T"Account" "sde" [] --> T"Account" "sde" []))),
   C"!" "bool"
    ((((T"int" "integer" [] --> T"int" "integer" []) --> bool) --> bool)),
   V"f" ((T"int" "integer" [] --> T"int" "integer" [])),
   C"Account_Saldo_fupd" "sde"
    (((T"int" "integer" [] --> T"int" "integer" []) -->
      (T"Account" "sde" [] --> T"Account" "sde" []))),
   V"i" (T"string" "string" []),
   C"!" "bool"
    (((T"list" "list" [T"Account" "sde" []] --> bool) --> bool)),
   V"db" (T"list" "list" [T"Account" "sde" []]),
   C"=" "min"
    ((T"list" "list" [T"Account" "sde" []] -->
      (T"list" "list" [T"Account" "sde" []] --> bool))),
   C"deleteById" "sde"
    ((T"string" "string" [] -->
      (T"list" "list" [T"Account" "sde" []] -->
       T"list" "list" [T"Account" "sde" []]))),
   C"FILTER" "list"
    (((T"Account" "sde" [] --> bool) -->
      (T"list" "list" [T"Account" "sde" []] -->
       T"list" "list" [T"Account" "sde" []]))), V"r" (T"Account" "sde" []),
   C"~" "bool" ((bool --> bool)), V"customer" (T"string" "string" []),
   C"sumOfPositiveSaldo" "sde"
    ((T"string" "string" [] -->
      (T"list" "list" [T"Account" "sde" []] --> T"int" "integer" []))),
   C"o" "combin"
    (((T"list" "list" [T"int" "integer" []] --> T"int" "integer" []) -->
      ((T"list" "list" [T"Account" "sde" []] -->
        T"list" "list" [T"int" "integer" []]) -->
       (T"list" "list" [T"Account" "sde" []] --> T"int" "integer" [])))),
   C"SUM_" "x_StdConst"
    ((T"list" "list" [T"int" "integer" []] --> T"int" "integer" [])),
   C"o" "combin"
    (((T"list" "list" [T"Account" "sde" []] -->
       T"list" "list" [T"int" "integer" []]) -->
      ((T"list" "list" [T"Account" "sde" []] -->
        T"list" "list" [T"Account" "sde" []]) -->
       (T"list" "list" [T"Account" "sde" []] -->
        T"list" "list" [T"int" "integer" []])))),
   C"MAP" "list"
    (((T"Account" "sde" [] --> T"int" "integer" []) -->
      (T"list" "list" [T"Account" "sde" []] -->
       T"list" "list" [T"int" "integer" []]))),
   C"int_gt" "integer"
    ((T"int" "integer" [] --> (T"int" "integer" [] --> bool))),
   C"int_of_num" "integer" ((T"num" "num" [] --> T"int" "integer" [])),
   V"x" (T"string" "string" []), V"A" (T"Account" "sde" []),
   V"x" (T"int" "integer" []), V"val" (T"string" "string" []),
   V"val" (T"int" "integer" []), V"x2" (T"string" "string" []),
   V"x1" (T"string" "string" []), V"x2" (T"int" "integer" []),
   V"x1" (T"int" "integer" []), V"z" (T"string" "string" []),
   V"y" (T"string" "string" []), V"r1" (T"Account" "sde" []),
   V"r2" (T"Account" "sde" []), V"y" (T"int" "integer" []),
   V"A1" (T"Account" "sde" []), V"A2" (T"Account" "sde" []),
   C"ARB" "bool" (T"Account" "sde" []), V"a0'" (T"string" "string" []),
   V"a1'" (T"string" "string" []), V"a2'" (T"int" "integer" []),
   V"M" (T"Account" "sde" []), V"M'" (T"Account" "sde" []),
   V"f'"
    ((T"string" "string" [] -->
      (T"string" "string" [] --> (T"int" "integer" [] --> alpha)))),
   C"?" "bool" ((((T"Account" "sde" [] --> alpha) --> bool) --> bool)),
   V"fn" ((T"Account" "sde" [] --> alpha)),
   C"!" "bool" ((((T"Account" "sde" [] --> bool) --> bool) --> bool)),
   V"P" ((T"Account" "sde" [] --> bool))]
  val DT = Thm.disk_thm share_table
  in
  val Account_TY_DEF =
    DT("", [],
       `(%0 (\%1. ((%2 (\%3. (%4 (\%5. ((%6 (%7 (\%3. ((%6 (%8 (\%9. (%8
       (\%10. (%11 (\%12. ((%13 $3) ((((\%9. (\%10. (\%12. (((%14 %15)
       ((%16 $2) ((%17 $1) $0))) (\%18. %19))))) $2) $1) $0))))))))) ($1
       $0))))) ($0 $1)))))) $0)))`)
  val Account_repfns =
    DT("", [],
       `((%20 (%21 (\%22. ((%23 (%24 (%25 $0))) $0)))) (%7 (\%26. ((%27
       ((\%3. (%4 (\%5. ((%6 (%7 (\%3. ((%6 (%8 (\%9. (%8 (\%10. (%11
       (\%12. ((%13 $3) ((((\%9. (\%10. (\%12. (((%14 %15) ((%16 $2) ((%17
       $1) $0))) (\%18. %19))))) $2) $1) $0))))))))) ($1 $0))))) ($0
       $1))))) $0)) ((%13 (%25 (%24 $0))) $0)))))`)
  val sde0_def =
    DT("", [],
       `((%28 %29) (\%9. (\%10. (\%12. (%24 ((((\%9. (\%10. (\%12. (((%14
       %15) ((%16 $2) ((%17 $1) $0))) (\%18. %19))))) $2) $1) $0))))))`)
  val Account = DT("", [], `((%28 %30) %29)`)
  val Account_case_def =
    DT("", [],
       `(%31 (\%32. (%33 (\%9. (%33 (\%10. (%34 (\%12. ((%35 ((%36 $3)
       (((%30 $2) $1) $0))) ((($3 $2) $1) $0))))))))))`)
  val Account_size_def =
    DT("", [],
       `(%33 (\%9. (%33 (\%10. (%34 (\%12. ((%37 (%38 (((%30 $2) $1) $0)))
       ((%39 (%40 (%41 %42))) ((%39 (%43 $2)) (%43 $1))))))))))`)
  val Account_Id =
    DT("", [],
       `(%33 (\%44. (%33 (\%45. (%34 (\%46. ((%47 (%48 (((%30 $2) $1) $0)))
       $2)))))))`)
  val Account_AccountNr =
    DT("", [],
       `(%33 (\%44. (%33 (\%45. (%34 (\%46. ((%47 (%49 (((%30 $2) $1) $0)))
       $1)))))))`)
  val Account_Saldo =
    DT("", [],
       `(%33 (\%44. (%33 (\%45. (%34 (\%46. ((%50 (%51 (((%30 $2) $1) $0)))
       $0)))))))`)
  val Account_Id_update =
    DT("", [],
       `(%33 (\%52. (%33 (\%44. (%33 (\%45. (%34 (\%46. ((%23 ((%53 $3)
       (((%30 $2) $1) $0))) (((%30 $3) $1) $0))))))))))`)
  val Account_AccountNr_update =
    DT("", [],
       `(%33 (\%52. (%33 (\%44. (%33 (\%45. (%34 (\%46. ((%23 ((%54 $3)
       (((%30 $2) $1) $0))) (((%30 $2) $3) $0))))))))))`)
  val Account_Saldo_update =
    DT("", [],
       `(%34 (\%55. (%33 (\%44. (%33 (\%45. (%34 (\%46. ((%23 ((%56 $3)
       (((%30 $2) $1) $0))) (((%30 $2) $1) $3))))))))))`)
  val Account_Id_fupd =
    DT("", [],
       `(%57 (\%58. (%21 (\%59. ((%23 ((%60 $1) $0)) ((%53 ($1 (%48 $0)))
       $0))))))`)
  val Account_AccountNr_fupd =
    DT("", [],
       `(%57 (\%58. (%21 (\%59. ((%23 ((%61 $1) $0)) ((%54 ($1 (%49 $0)))
       $0))))))`)
  val Account_Saldo_fupd =
    DT("", [],
       `(%62 (\%63. (%21 (\%59. ((%23 ((%64 $1) $0)) ((%56 ($1 (%51 $0)))
       $0))))))`)
  val deleteById_def =
    DT("", [],
       `(%33 (\%65. (%66 (\%67. ((%68 ((%69 $1) $0)) ((%70 (\%71. (%72
       ((%47 (%48 $0)) $2)))) $0))))))`)
  val sumOfPositiveSaldo_def =
    DT("", [],
       `(%33 (\%73. (%66 (\%67. ((%50 ((%74 $1) $0)) (((%75 %76) ((%77 (%78
       (\%71. (%51 $0)))) (%70 (\%71. ((%20 ((%47 (%48 $0)) $2)) ((%79 (%51
       $0)) (%80 %15))))))) $0))))))`)
  val Account_accessors =
    DT("", [],
       `((%20 (%33 (\%44. (%33 (\%45. (%34 (\%46. ((%47 (%48 (((%30 $2) $1)
       $0))) $2)))))))) ((%20 (%33 (\%44. (%33 (\%45. (%34 (\%46. ((%47
       (%49 (((%30 $2) $1) $0))) $1)))))))) (%33 (\%44. (%33 (\%45. (%34
       (\%46. ((%50 (%51 (((%30 $2) $1) $0))) $0)))))))))`)
  val Account_updates =
    DT("", [],
       `((%20 (%33 (\%52. (%33 (\%44. (%33 (\%45. (%34 (\%46. ((%23 ((%53
       $3) (((%30 $2) $1) $0))) (((%30 $3) $1) $0))))))))))) ((%20 (%33
       (\%52. (%33 (\%44. (%33 (\%45. (%34 (\%46. ((%23 ((%54 $3) (((%30
       $2) $1) $0))) (((%30 $2) $3) $0))))))))))) (%34 (\%55. (%33 (\%44.
       (%33 (\%45. (%34 (\%46. ((%23 ((%56 $3) (((%30 $2) $1) $0))) (((%30
       $2) $1) $3))))))))))))`)
  val Account_fn_updates =
    DT("", [],
       `((%20 (%57 (\%58. (%21 (\%59. ((%23 ((%60 $1) $0)) ((%53 ($1 (%48
       $0))) $0))))))) ((%20 (%57 (\%58. (%21 (\%59. ((%23 ((%61 $1) $0))
       ((%54 ($1 (%49 $0))) $0))))))) (%62 (\%63. (%21 (\%59. ((%23 ((%64
       $1) $0)) ((%56 ($1 (%51 $0))) $0))))))))`)
  val Account_accupds =
    DT("", [],
       `((%20 (%33 (\%81. (%21 (\%82. ((%47 (%48 ((%54 $1) $0))) (%48
       $0))))))) ((%20 (%34 (\%83. (%21 (\%82. ((%47 (%48 ((%56 $1) $0)))
       (%48 $0))))))) ((%20 (%33 (\%81. (%21 (\%82. ((%47 (%49 ((%53 $1)
       $0))) (%49 $0))))))) ((%20 (%34 (\%83. (%21 (\%82. ((%47 (%49 ((%56
       $1) $0))) (%49 $0))))))) ((%20 (%33 (\%81. (%21 (\%82. ((%50 (%51
       ((%53 $1) $0))) (%51 $0))))))) ((%20 (%33 (\%81. (%21 (\%82. ((%50
       (%51 ((%54 $1) $0))) (%51 $0))))))) ((%20 (%33 (\%81. (%21 (\%82.
       ((%47 (%48 ((%53 $1) $0))) $1)))))) ((%20 (%33 (\%81. (%21 (\%82.
       ((%47 (%49 ((%54 $1) $0))) $1)))))) (%34 (\%83. (%21 (\%82. ((%50
       (%51 ((%56 $1) $0))) $1)))))))))))))`)
  val Account_accfupds =
    DT("", [],
       `((%20 (%57 (\%58. (%21 (\%82. ((%47 (%48 ((%61 $1) $0))) (%48
       $0))))))) ((%20 (%62 (\%63. (%21 (\%82. ((%47 (%48 ((%64 $1) $0)))
       (%48 $0))))))) ((%20 (%57 (\%58. (%21 (\%82. ((%47 (%49 ((%60 $1)
       $0))) (%49 $0))))))) ((%20 (%62 (\%63. (%21 (\%82. ((%47 (%49 ((%64
       $1) $0))) (%49 $0))))))) ((%20 (%57 (\%58. (%21 (\%82. ((%50 (%51
       ((%60 $1) $0))) (%51 $0))))))) ((%20 (%57 (\%58. (%21 (\%82. ((%50
       (%51 ((%61 $1) $0))) (%51 $0))))))) ((%20 (%57 (\%58. (%21 (\%82.
       ((%47 (%48 ((%60 $1) $0))) ($1 (%48 $0)))))))) ((%20 (%57 (\%58.
       (%21 (\%82. ((%47 (%49 ((%61 $1) $0))) ($1 (%49 $0)))))))) (%62
       (\%63. (%21 (\%82. ((%50 (%51 ((%64 $1) $0))) ($1 (%51
       $0)))))))))))))))`)
  val Account_updaccs =
    DT("", [],
       `((%20 (%21 (\%82. ((%23 ((%53 (%48 $0)) $0)) $0)))) ((%20 (%21
       (\%82. ((%23 ((%54 (%49 $0)) $0)) $0)))) (%21 (\%82. ((%23 ((%56
       (%51 $0)) $0)) $0)))))`)
  val Account_cupdaccs =
    DT("", [],
       `((%20 (%33 (\%84. (%21 (\%82. ((%6 ((%47 $1) (%48 $0))) ((%23 ((%53
       $1) $0)) $0))))))) ((%20 (%33 (\%84. (%21 (\%82. ((%6 ((%47 $1) (%49
       $0))) ((%23 ((%54 $1) $0)) $0))))))) (%34 (\%85. (%21 (\%82. ((%6
       ((%50 $1) (%51 $0))) ((%23 ((%56 $1) $0)) $0))))))))`)
  val Account_updupds =
    DT("", [],
       `((%20 (%33 (\%86. (%33 (\%87. (%21 (\%82. ((%23 ((%53 $1) ((%53 $2)
       $0))) ((%53 $1) $0))))))))) ((%20 (%33 (\%86. (%33 (\%87. (%21
       (\%82. ((%23 ((%54 $1) ((%54 $2) $0))) ((%54 $1) $0))))))))) (%34
       (\%88. (%34 (\%89. (%21 (\%82. ((%23 ((%56 $1) ((%56 $2) $0))) ((%56
       $1) $0))))))))))`)
  val Account_updcanon =
    DT("", [],
       `((%20 (%33 (\%90. (%33 (\%81. (%21 (\%82. ((%23 ((%54 $1) ((%53 $2)
       $0))) ((%53 $2) ((%54 $1) $0)))))))))) ((%20 (%33 (\%90. (%34 (\%83.
       (%21 (\%82. ((%23 ((%56 $1) ((%53 $2) $0))) ((%53 $2) ((%56 $1)
       $0)))))))))) (%33 (\%90. (%34 (\%83. (%21 (\%82. ((%23 ((%56 $1)
       ((%54 $2) $0))) ((%54 $2) ((%56 $1) $0)))))))))))`)
  val Account_Id_update_semi11 =
    DT("", [],
       `(%33 (\%81. (%33 (\%91. (%21 (\%92. (%21 (\%93. ((%6 ((%23 ((%53
       $3) $1)) ((%53 $2) $0))) ((%47 $3) $2))))))))))`)
  val Account_AccountNr_update_semi11 =
    DT("", [],
       `(%33 (\%81. (%33 (\%91. (%21 (\%92. (%21 (\%93. ((%6 ((%23 ((%54
       $3) $1)) ((%54 $2) $0))) ((%47 $3) $2))))))))))`)
  val Account_Saldo_update_semi11 =
    DT("", [],
       `(%34 (\%83. (%34 (\%94. (%21 (\%92. (%21 (\%93. ((%6 ((%23 ((%56
       $3) $1)) ((%56 $2) $0))) ((%50 $3) $2))))))))))`)
  val Account_component_equality =
    DT("", [],
       `(%21 (\%95. (%21 (\%96. ((%27 ((%23 $1) $0)) ((%20 ((%47 (%48 $1))
       (%48 $0))) ((%20 ((%47 (%49 $1)) (%49 $0))) ((%50 (%51 $1)) (%51
       $0)))))))))`)
  val Account_updates_eq_literal =
    DT("", [],
       `(%33 (\%45. (%33 (\%44. (%34 (\%46. (%21 (\%82. ((%23 ((%53 $3)
       ((%54 $2) ((%56 $1) $0)))) ((%53 $3) ((%54 $2) ((%56 $1)
       %97))))))))))))`)
  val Account_11 =
    DT("", [],
       `(%33 (\%9. (%33 (\%10. (%34 (\%12. (%33 (\%98. (%33 (\%99. (%34
       (\%100. ((%27 ((%23 (((%30 $5) $4) $3)) (((%30 $2) $1) $0))) ((%20
       ((%47 $5) $2)) ((%20 ((%47 $4) $1)) ((%50 $3) $0))))))))))))))))`)
  val Account_case_cong =
    DT("", [],
       `(%21 (\%101. (%21 (\%102. (%31 (\%32. ((%6 ((%20 ((%23 $2) $1))
       (%33 (\%9. (%33 (\%10. (%34 (\%12. ((%6 ((%23 $4) (((%30 $2) $1)
       $0))) ((%35 ((($3 $2) $1) $0)) (((%103 $2) $1) $0))))))))))) ((%35
       ((%36 $0) $2)) ((%36 %103) $1)))))))))`)
  val Account_nchotomy =
    DT("", [],
       `(%21 (\%82. (%8 (\%44. (%8 (\%45. (%11 (\%46. ((%23 $3) (((%30 $2)
       $1) $0))))))))))`)
  val Account_Axiom =
    DT("", [],
       `(%31 (\%32. (%104 (\%105. (%33 (\%9. (%33 (\%10. (%34 (\%12. ((%35
       ($3 (((%30 $2) $1) $0))) ((($4 $2) $1) $0))))))))))))`)
  val Account_induction =
    DT("", [],
       `(%106 (\%107. ((%6 (%33 (\%44. (%33 (\%45. (%34 (\%46. ($3 (((%30
       $2) $1) $0))))))))) (%21 (\%82. ($1 $0))))))`)
  end
  val _ = DB.bindl "sde"
  [("Account_TY_DEF",Account_TY_DEF,DB.Def),
   ("Account_repfns",Account_repfns,DB.Def), ("sde0_def",sde0_def,DB.Def),
   ("Account",Account,DB.Def),
   ("Account_case_def",Account_case_def,DB.Def),
   ("Account_size_def",Account_size_def,DB.Def),
   ("Account_Id",Account_Id,DB.Def),
   ("Account_AccountNr",Account_AccountNr,DB.Def),
   ("Account_Saldo",Account_Saldo,DB.Def),
   ("Account_Id_update",Account_Id_update,DB.Def),
   ("Account_AccountNr_update",Account_AccountNr_update,DB.Def),
   ("Account_Saldo_update",Account_Saldo_update,DB.Def),
   ("Account_Id_fupd",Account_Id_fupd,DB.Def),
   ("Account_AccountNr_fupd",Account_AccountNr_fupd,DB.Def),
   ("Account_Saldo_fupd",Account_Saldo_fupd,DB.Def),
   ("deleteById_def",deleteById_def,DB.Def),
   ("sumOfPositiveSaldo_def",sumOfPositiveSaldo_def,DB.Def),
   ("Account_accessors",Account_accessors,DB.Thm),
   ("Account_updates",Account_updates,DB.Thm),
   ("Account_fn_updates",Account_fn_updates,DB.Thm),
   ("Account_accupds",Account_accupds,DB.Thm),
   ("Account_accfupds",Account_accfupds,DB.Thm),
   ("Account_updaccs",Account_updaccs,DB.Thm),
   ("Account_cupdaccs",Account_cupdaccs,DB.Thm),
   ("Account_updupds",Account_updupds,DB.Thm),
   ("Account_updcanon",Account_updcanon,DB.Thm),
   ("Account_Id_update_semi11",Account_Id_update_semi11,DB.Thm),
   ("Account_AccountNr_update_semi11",
    Account_AccountNr_update_semi11,
    DB.Thm),
   ("Account_Saldo_update_semi11",Account_Saldo_update_semi11,DB.Thm),
   ("Account_component_equality",Account_component_equality,DB.Thm),
   ("Account_updates_eq_literal",Account_updates_eq_literal,DB.Thm),
   ("Account_11",Account_11,DB.Thm),
   ("Account_case_cong",Account_case_cong,DB.Thm),
   ("Account_nchotomy",Account_nchotomy,DB.Thm),
   ("Account_Axiom",Account_Axiom,DB.Thm),
   ("Account_induction",Account_induction,DB.Thm)]
  
  local open Portable GrammarSpecials Parse
  in
  val _ = mk_local_grms [("stringTheory.string_grammars",
                          stringTheory.string_grammars),
                         ("x_StdConstTheory.x_StdConst_grammars",
                          x_StdConstTheory.x_StdConst_grammars)]
  val _ = List.app (update_grms reveal) []
  val _ = update_grms temp_add_type "Account"
  val _ = update_grms
       (temp_overload_on_by_nametype "mk_Account")
        {Name = "mk_Account", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype "dest_Account")
        {Name = "dest_Account", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype "sde0")
        {Name = "sde0", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype "Account")
        {Name = "Account", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype "Account_case")
        {Name = "Account_case", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype "Account_size")
        {Name = "Account_size", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype "Account_Id")
        {Name = "Account_Id", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype "Account_AccountNr")
        {Name = "Account_AccountNr", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype "Account_Saldo")
        {Name = "Account_Saldo", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype "Account_Id_update")
        {Name = "Account_Id_update", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype "Account_AccountNr_update")
        {Name = "Account_AccountNr_update", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype "Account_Saldo_update")
        {Name = "Account_Saldo_update", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype "Account_Id_fupd")
        {Name = "Account_Id_fupd", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype "Account_AccountNr_fupd")
        {Name = "Account_AccountNr_fupd", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype "Account_Saldo_fupd")
        {Name = "Account_Saldo_fupd", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype " _ record selectId")
        {Name = "Account_Id", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype " _ record selectAccountNr")
        {Name = "Account_AccountNr", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype " _ record selectSaldo")
        {Name = "Account_Saldo", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype "Id_update")
        {Name = "Account_Id_update", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype "AccountNr_update")
        {Name = "Account_AccountNr_update", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype "Saldo_update")
        {Name = "Account_Saldo_update", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype " _ record updateId")
        {Name = "Account_Id_update", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype " _ record updateAccountNr")
        {Name = "Account_AccountNr_update", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype " _ record updateSaldo")
        {Name = "Account_Saldo_update", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype "Id_fupd")
        {Name = "Account_Id_fupd", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype "AccountNr_fupd")
        {Name = "Account_AccountNr_fupd", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype "Saldo_fupd")
        {Name = "Account_Saldo_fupd", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype " _ record fupdateId")
        {Name = "Account_Id_fupd", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype " _ record fupdateAccountNr")
        {Name = "Account_AccountNr_fupd", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype " _ record fupdateSaldo")
        {Name = "Account_Saldo_fupd", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype "case")
        {Name = "Account_case", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype "deleteById")
        {Name = "deleteById", Thy = "sde"}
  val _ = update_grms
       (temp_overload_on_by_nametype "sumOfPositiveSaldo")
        {Name = "sumOfPositiveSaldo", Thy = "sde"}
  val sde_grammars = Parse.current_lgrms()
  end
  
  
  val _ =
     let open TypeBasePure 
         val tyinfo0 = mk_tyinfo
          {ax=ORIG Account_Axiom,
           case_def=Account_case_def,
           case_cong=Account_case_cong,
           induction=ORIG Account_induction,
           nchotomy=Account_nchotomy,
           size=SOME(Parse.Term`(Account_size) :Account -> num`,
                     ORIG Account_size_def),
           boolify = NONE,
  
           one_one=SOME Account_11,
           distinct=NONE}
     in
      TypeBase.write 
         (TypeBasePure.put_simpls ([Account_accessors, Account_updates, Account_updates_eq_literal, Account_updaccs, Account_accupds, Account_accfupds, Account_updupds, Account_fn_updates, Account_updcanon] @ TypeBasePure.simpls_of tyinfo0) tyinfo0);
      computeLib.write_datatype_info tyinfo0
     end;
  
  
  val _ = computeLib.add_funs [deleteById_def];  
  
  val _ = computeLib.add_funs [sumOfPositiveSaldo_def];  
end
