-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.2
-- //
-- //===========================================================================
-- //
-- do not edit; automatically generated by UU.AG
module EXPR_2HOL where

import PrimitiveConcepts.Position
import PrimitiveConcepts.Name
import PrimitiveConcepts.LC
import PrimitiveConcepts.ErrorMsg

import Lang.TYPE.PCKG
import Lang.EXPR.PCKG

import UU.Pretty
import SupportLib.MorePretty

import Configuration.Lang
import Configuration.Face

import Char
import List(find)

--
--Translate a non-empty list of expressions [e1,e2,...] to 
--(n, t1 /\ t2 /\ ...) where t1 /\ t2 /\ ... is 
--the corresponding HOL term, and n is the number of
--expressions in the list.
--

pp_exprlist2HOL exprlist = out
	where
	e      = case exprlist of
		 [] 	-> tt
		 _	-> foldr1 and_ exprlist

	pp_e   = fst (sem_Expr e)
	n      = (text . show . length) exprlist
	out    =  text "val from_mech =" 
		  >-<
		  indent std_indentWidth
		    (pp_parens (hlist_sp [n, text "," , pp_holterm_quote pp_e])
		     >#< 
		     text ";")

	pp_holterm_quote pp = text "--`" >|< pp >|< text "`--"

--
--Translate a single expression to (1,t), where 
--t is the corresponding HOL term.
--

pp_expr2HOL expr = fst (sem_Expr expr)

type PP_Docs2 = [PP_Doc2]

unimplemented_operator_error_msg op
	= 
	internalError
	("Unimplemented to-HOL traslation of " ++ op)
	"EXPR_2HOL_orphan.ag"

getName (Identifier name _ _ _) = name
pp_marker ms = hlist . insert_sep_enc "[" "]" "; " . map (text . show) $ ms


ppArrayUpdate _ [] pp_x = pp_x

ppArrayUpdate  pp_t (pp_i:pps) pp_x
		=
		vlist_indent_
		[ text "ArrayUpdate"	,
		  pp_t			,
		  pp_i			,		
		  pp_rec		]
	where
	pp_rec = ppArrayUpdate pp_t_i pps pp_x

	pp_t_i = pp_parens . vlist $
			[pp_parens pp_t		,
		         text "ArrayApp"	,   
		         pp_parens pp_i 	]


ppRecordUpdate _ [] pp_x = pp_x

ppRecordUpdate pp_r (field : the_rest) pp_x
	=
	vlist_ 	[ pp_r		,
		  text "with" 			,
		  text field >#< text ":=" >#< pp_rec ]
	where
	pp_rec = ppRecordUpdate pp_r_field the_rest pp_x

	pp_r_field = pp_parens . hlist $
			[pp_r 		,
		         text "."	,   
		         text field	]


mk_pplambda pp_bvar pp_e
	=
	pp_parens (text "\\" >|< pp_bvar >|< text "." >#< pp_e )

ppSQLSelect bvars tables pp_filter_pred pp_map_func
	=
	vlist_indent_
	[ ppmap_ 	,
	  vlist_indent_ [ppfilter_ 	,
	  		 pp_parens pptables_	]
	  ]

	where

	ppmap_    = text "MAP"    >#< mk_pplambda bvars_ pp_map_func
	ppfilter_ = text "FILTER" >#< mk_pplambda bvars_ pp_filter_pred

	bvars_ = foldr1 op bvars
	    where
	    op v r = pp_parens (v >|< text "," >|< r)

	pptables_ = foldr1 op tables 
	   where
	   op t r = pp_parens . hlist_sp $ [t, text "LPROD", r]


predef_consts = map f default_EXPR_constants 
	where
	f c = (lc_name c, lc_translation c)

get_hol_name name = case lookup name predef_consts of
	Just holname	-> holname
	_		-> name

pp_identname name ProgramVar  = text name
pp_identname name _           = text (get_hol_name name)

-- Expr --------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      pp                   : PP_Doc
      self                 : SELF

-}
{-
   local variables for Expr.App:
      self

-}
{-
   local variables for Expr.ArrayApp:
      self

-}
{-
   local variables for Expr.ArrayUpdate:
      self

-}
{-
   local variables for Expr.Binary:
      self

-}
{-
   local variables for Expr.Cond:
      self

-}
{-
   local variables for Expr.FromTo:
      self

-}
{-
   local variables for Expr.Ident:
      self

-}
{-
   local variables for Expr.List:
      self

-}
{-
   local variables for Expr.Lit:
      self

-}
{-
   local variables for Expr.Marker:
      self

-}
{-
   local variables for Expr.Quantor:
      domainConnector
      self

-}
{-
   local variables for Expr.Record:
      self

-}
{-
   local variables for Expr.RecordApp:
      self

-}
{-
   local variables for Expr.RecordUpdate:
      self

-}
{-
   local variables for Expr.SQLSelect:
      self

-}
{-
   local variables for Expr.Unary:
      self

-}
-- semantic domain
type T_Expr = ( (PP_Doc),(Expr))
-- cata
sem_Expr :: (Expr) ->
            (T_Expr)
sem_Expr ((App (_func) (_arg))) =
    (sem_Expr_App ((sem_Expr (_func))) ((sem_Expr (_arg))))
sem_Expr ((ArrayApp (_pos) (_array) (_element))) =
    (sem_Expr_ArrayApp (_pos) ((sem_Expr (_array))) ((sem_Expr (_element))))
sem_Expr ((ArrayUpdate (_target) (_at) (_with))) =
    (sem_Expr_ArrayUpdate ((sem_Expr (_target))) ((sem_ExprList (_at))) ((sem_Expr (_with))))
sem_Expr ((Binary (_op) (_arg1) (_arg2))) =
    (sem_Expr_Binary ((sem_Ident (_op))) ((sem_Expr (_arg1))) ((sem_Expr (_arg2))))
sem_Expr ((Cond (_pos) (_guard) (_val1) (_val2))) =
    (sem_Expr_Cond (_pos) ((sem_Expr (_guard))) ((sem_Expr (_val1))) ((sem_Expr (_val2))))
sem_Expr ((FromTo (_pos) (_ranger) (_left) (_right))) =
    (sem_Expr_FromTo (_pos) ((sem_Expr (_ranger))) ((sem_Expr (_left))) ((sem_Expr (_right))))
sem_Expr ((Ident (_ident))) =
    (sem_Expr_Ident ((sem_Ident (_ident))))
sem_Expr ((List (_pos) (_exprlist))) =
    (sem_Expr_List (_pos) ((sem_ExprList (_exprlist))))
sem_Expr ((Lit (_value))) =
    (sem_Expr_Lit ((sem_Literal (_value))))
sem_Expr ((Marker (_marker) (_expr))) =
    (sem_Expr_Marker ((sem_Marker (_marker))) ((sem_Expr (_expr))))
sem_Expr ((Quantor (_op) (_varl) (_domain) (_body))) =
    (sem_Expr_Quantor ((sem_Ident (_op))) ((sem_IdentList (_varl))) ((sem_Expr (_domain))) ((sem_Expr (_body))))
sem_Expr ((Record (_pos) (_fields))) =
    (sem_Expr_Record (_pos) ((sem_FieldAssignmentList (_fields))))
sem_Expr ((RecordApp (_pos) (_record) (_field))) =
    (sem_Expr_RecordApp (_pos) ((sem_Expr (_record))) (_field))
sem_Expr ((RecordUpdate (_target) (_at) (_with) (_ty))) =
    (sem_Expr_RecordUpdate ((sem_Expr (_target))) (_at) ((sem_Expr (_with))) (_ty))
sem_Expr ((SQLSelect (_pos) (_generators) (_filter) (_map))) =
    (sem_Expr_SQLSelect (_pos) ((sem_ListGeneratorList (_generators))) ((sem_Expr (_filter))) ((sem_Expr (_map))))
sem_Expr ((Unary (_op) (_arg))) =
    (sem_Expr_Unary ((sem_Ident (_op))) ((sem_Expr (_arg))))
sem_Expr_App :: (T_Expr) ->
                (T_Expr) ->
                (T_Expr)
sem_Expr_App (_func) (_arg) =
    let (_self) =
            App _func_self _arg_self
        ( _func_pp,_func_self) =
            (_func )
        ( _arg_pp,_arg_self) =
            (_arg )
    in  ( pp_parens . hlist_sp $
          [pp_parens _func_pp          ,
           pp_parens _arg_pp           ]
         ,_self
         )
sem_Expr_ArrayApp :: (Pos) ->
                     (T_Expr) ->
                     (T_Expr) ->
                     (T_Expr)
sem_Expr_ArrayApp (_pos) (_array) (_element) =
    let (_self) =
            ArrayApp _pos _array_self _element_self
        ( _array_pp,_array_self) =
            (_array )
        ( _element_pp,_element_self) =
            (_element )
    in  ( pp_parens . hlist_sp $
          [pp_parens _array_pp         ,
           text "ArrayApp"             ,
           pp_parens _element_pp       ]
         ,_self
         )
sem_Expr_ArrayUpdate :: (T_Expr) ->
                        (T_ExprList) ->
                        (T_Expr) ->
                        (T_Expr)
sem_Expr_ArrayUpdate (_target) (_at) (_with) =
    let (_self) =
            ArrayUpdate _target_self _at_self _with_self
        ( _target_pp,_target_self) =
            (_target )
        ( _at_pps,_at_self) =
            (_at )
        ( _with_pp,_with_self) =
            (_with )
    in  ( ppArrayUpdate
              _target_pp
              _at_pps
              _with_pp
         ,_self
         )
sem_Expr_Binary :: (T_Ident) ->
                   (T_Expr) ->
                   (T_Expr) ->
                   (T_Expr)
sem_Expr_Binary (_op) (_arg1) (_arg2) =
    let (_self) =
            Binary _op_self _arg1_self _arg2_self
        ( _op_pp,_op_self) =
            (_op )
        ( _arg1_pp,_arg1_self) =
            (_arg1 )
        ( _arg2_pp,_arg2_self) =
            (_arg2 )
    in  ( pp_parens . hv_sp $
          [_arg1_pp            ,
           _op_pp              ,
           _arg2_pp            ]
         ,_self
         )
sem_Expr_Cond :: (Pos) ->
                 (T_Expr) ->
                 (T_Expr) ->
                 (T_Expr) ->
                 (T_Expr)
sem_Expr_Cond (_pos) (_guard) (_val1) (_val2) =
    let (_self) =
            Cond _pos _guard_self _val1_self _val2_self
        ( _guard_pp,_guard_self) =
            (_guard )
        ( _val1_pp,_val1_self) =
            (_val1 )
        ( _val2_pp,_val2_self) =
            (_val2 )
    in  ( vlist_indent_
          [text "if"   >#< pp_parens _guard_pp  ,
           text "then" >#< pp_parens _val1_pp   ,
           text "else" >#< pp_parens _val2_pp   ]
         ,_self
         )
sem_Expr_FromTo :: (Pos) ->
                   (T_Expr) ->
                   (T_Expr) ->
                   (T_Expr) ->
                   (T_Expr)
sem_Expr_FromTo (_pos) (_ranger) (_left) (_right) =
    let (_self) =
            FromTo _pos _ranger_self _left_self _right_self
        ( _ranger_pp,_ranger_self) =
            (_ranger )
        ( _left_pp,_left_self) =
            (_left )
        ( _right_pp,_right_self) =
            (_right )
    in  ( vlist_indent_
          [ text "FromTo"              ,
            pp_parens _ranger_pp       ,
            pp_parens _left_pp         ,
            pp_parens _right_pp        ]
         ,_self
         )
sem_Expr_Ident :: (T_Ident) ->
                  (T_Expr)
sem_Expr_Ident (_ident) =
    let (_self) =
            Ident _ident_self
        ( _ident_pp,_ident_self) =
            (_ident )
    in  ( _ident_pp,_self)
sem_Expr_List :: (Pos) ->
                 (T_ExprList) ->
                 (T_Expr)
sem_Expr_List (_pos) (_exprlist) =
    let (_self) =
            List _pos _exprlist_self
        ( _exprlist_pps,_exprlist_self) =
            (_exprlist )
    in  ( hlist (insert_sep_enc "[" "]" "; " _exprlist_pps),_self)
sem_Expr_Lit :: (T_Literal) ->
                (T_Expr)
sem_Expr_Lit (_value) =
    let (_self) =
            Lit _value_self
        ( _value_pp,_value_self) =
            (_value )
    in  ( _value_pp,_self)
sem_Expr_Marker :: (T_Marker) ->
                   (T_Expr) ->
                   (T_Expr)
sem_Expr_Marker (_marker) (_expr) =
    let (_self) =
            Marker _marker_self _expr_self
        ( _marker_self) =
            (_marker )
        ( _expr_pp,_expr_self) =
            (_expr )
    in  ( pp_parens . vlist $
          [ text "MARKER" >#< pp_marker _marker,
            pp_parens _expr_pp ]
         ,_self
         )
sem_Expr_Quantor :: (T_Ident) ->
                    (T_IdentList) ->
                    (T_Expr) ->
                    (T_Expr) ->
                    (T_Expr)
sem_Expr_Quantor (_op) (_varl) (_domain) (_body) =
    let (_self) =
            Quantor _op_self _varl_self _domain_self _body_self
        (_domainConnector) =
            case getName _op_self of
             "!"  -> "==>"
             "?"  -> "/\\"
             n    -> error (unimplemented_operator_error_msg n)
        ( _op_pp,_op_self) =
            (_op )
        ( _varl_pps,_varl_self) =
            (_varl )
        ( _domain_pp,_domain_self) =
            (_domain )
        ( _body_pp,_body_self) =
            (_body )
    in  ( pp_parens . hlist_sp $
             [_op_pp >|< hlist_sp _varl_pps >#< text ".",
              hv_sp [_domain_pp,
                     text _domainConnector,
                     _body_pp  ]
             ]
         ,_self
         )
sem_Expr_Record :: (Pos) ->
                   (T_FieldAssignmentList) ->
                   (T_Expr)
sem_Expr_Record (_pos) (_fields) =
    let (_self) =
            Record _pos _fields_self
        ( _fields_pps,_fields_self) =
            (_fields )
    in  ( vlist (insert_sep_enc "<|" "|>" ";" _fields_pps),_self)
sem_Expr_RecordApp :: (Pos) ->
                      (T_Expr) ->
                      (String) ->
                      (T_Expr)
sem_Expr_RecordApp (_pos) (_record) (_field) =
    let (_self) =
            RecordApp _pos _record_self _field
        ( _record_pp,_record_self) =
            (_record )
    in  ( hlist
          [ pp_parens _record_pp       ,
            text "."                   ,
            text _field                ]
         ,_self
         )
sem_Expr_RecordUpdate :: (T_Expr) ->
                         (StringList) ->
                         (T_Expr) ->
                         (Type) ->
                         (T_Expr)
sem_Expr_RecordUpdate (_target) (_at) (_with) (_ty) =
    let (_self) =
            RecordUpdate _target_self _at _with_self _ty
        ( _target_pp,_target_self) =
            (_target )
        ( _with_pp,_with_self) =
            (_with )
    in  ( ppRecordUpdate
               _target_pp
               _at
               _with_pp
         ,_self
         )
sem_Expr_SQLSelect :: (Pos) ->
                      (T_ListGeneratorList) ->
                      (T_Expr) ->
                      (T_Expr) ->
                      (T_Expr)
sem_Expr_SQLSelect (_pos) (_generators) (_filter) (_map) =
    let (_self) =
            SQLSelect _pos _generators_self _filter_self _map_self
        ( _generators_pps2,_generators_self) =
            (_generators )
        ( _filter_pp,_filter_self) =
            (_filter )
        ( _map_pp,_map_self) =
            (_map )
    in  ( ppSQLSelect
                (map fst _generators_pps2)
                (map snd _generators_pps2)
                _filter_pp
                _map_pp
         ,_self
         )
sem_Expr_Unary :: (T_Ident) ->
                  (T_Expr) ->
                  (T_Expr)
sem_Expr_Unary (_op) (_arg) =
    let (_self) =
            Unary _op_self _arg_self
        ( _op_pp,_op_self) =
            (_op )
        ( _arg_pp,_arg_self) =
            (_arg )
    in  ( pp_parens (_op_pp >|< pp_parens _arg_pp),_self)
-- ExprList ----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      pps                  : PP_Docs
      self                 : SELF

-}
{-
   local variables for ExprList.Cons:
      self

-}
{-
   local variables for ExprList.Nil:
      self

-}
-- semantic domain
type T_ExprList = ( (PP_Docs),(ExprList))
-- cata
sem_ExprList :: (ExprList) ->
                (T_ExprList)
sem_ExprList (list) =
    (foldr (sem_ExprList_Cons) (sem_ExprList_Nil) ((map sem_Expr list)))
sem_ExprList_Cons :: (T_Expr) ->
                     (T_ExprList) ->
                     (T_ExprList)
sem_ExprList_Cons (_hd) (_tl) =
    let (_self) =
            (:) _hd_self _tl_self
        ( _hd_pp,_hd_self) =
            (_hd )
        ( _tl_pps,_tl_self) =
            (_tl )
    in  ( _hd_pp : _tl_pps,_self)
sem_ExprList_Nil :: (T_ExprList)
sem_ExprList_Nil  =
    let (_self) =
            []
    in  ( [],_self)
-- FieldAssignment ---------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      pp                   : PP_Doc
      self                 : SELF

-}
{-
   local variables for FieldAssignment.FieldAssignment:
      self

-}
-- semantic domain
type T_FieldAssignment = ( (PP_Doc),(FieldAssignment))
-- cata
sem_FieldAssignment :: (FieldAssignment) ->
                       (T_FieldAssignment)
sem_FieldAssignment ((FieldAssignment (_pos) (_field) (_value))) =
    (sem_FieldAssignment_FieldAssignment (_pos) (_field) ((sem_Expr (_value))))
sem_FieldAssignment_FieldAssignment :: (Pos) ->
                                       (String) ->
                                       (T_Expr) ->
                                       (T_FieldAssignment)
sem_FieldAssignment_FieldAssignment (_pos) (_field) (_value) =
    let (_self) =
            FieldAssignment _pos _field _value_self
        ( _value_pp,_value_self) =
            (_value )
    in  ( hlist_sp [text _field, text ":=", _value_pp],_self)
-- FieldAssignmentList -----------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      pps                  : PP_Docs
      self                 : SELF

-}
{-
   local variables for FieldAssignmentList.Cons:
      self

-}
{-
   local variables for FieldAssignmentList.Nil:
      self

-}
-- semantic domain
type T_FieldAssignmentList = ( (PP_Docs),(FieldAssignmentList))
-- cata
sem_FieldAssignmentList :: (FieldAssignmentList) ->
                           (T_FieldAssignmentList)
sem_FieldAssignmentList (list) =
    (foldr (sem_FieldAssignmentList_Cons) (sem_FieldAssignmentList_Nil) ((map sem_FieldAssignment list)))
sem_FieldAssignmentList_Cons :: (T_FieldAssignment) ->
                                (T_FieldAssignmentList) ->
                                (T_FieldAssignmentList)
sem_FieldAssignmentList_Cons (_hd) (_tl) =
    let (_self) =
            (:) _hd_self _tl_self
        ( _hd_pp,_hd_self) =
            (_hd )
        ( _tl_pps,_tl_self) =
            (_tl )
    in  ( _hd_pp : _tl_pps,_self)
sem_FieldAssignmentList_Nil :: (T_FieldAssignmentList)
sem_FieldAssignmentList_Nil  =
    let (_self) =
            []
    in  ( [],_self)
-- Ident -------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      pp                   : PP_Doc
      self                 : SELF

-}
{-
   local variables for Ident.Identifier:
      self

-}
-- semantic domain
type T_Ident = ( (PP_Doc),(Ident))
-- cata
sem_Ident :: (Ident) ->
             (T_Ident)
sem_Ident ((Identifier (_name) (_status) (_ty) (_pos))) =
    (sem_Ident_Identifier (_name) ((sem_IdentStatus (_status))) (_ty) (_pos))
sem_Ident_Identifier :: (String) ->
                        (T_IdentStatus) ->
                        (Type) ->
                        (Pos) ->
                        (T_Ident)
sem_Ident_Identifier (_name) (_status) (_ty) (_pos) =
    let (_self) =
            Identifier _name _status_self _ty _pos
        ( _status_self) =
            (_status )
    in  ( pp_identname _name _status,_self)
-- IdentList ---------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      pps                  : PP_Docs
      self                 : SELF

-}
{-
   local variables for IdentList.Cons:
      self

-}
{-
   local variables for IdentList.Nil:
      self

-}
-- semantic domain
type T_IdentList = ( (PP_Docs),(IdentList))
-- cata
sem_IdentList :: (IdentList) ->
                 (T_IdentList)
sem_IdentList (list) =
    (foldr (sem_IdentList_Cons) (sem_IdentList_Nil) ((map sem_Ident list)))
sem_IdentList_Cons :: (T_Ident) ->
                      (T_IdentList) ->
                      (T_IdentList)
sem_IdentList_Cons (_hd) (_tl) =
    let (_self) =
            (:) _hd_self _tl_self
        ( _hd_pp,_hd_self) =
            (_hd )
        ( _tl_pps,_tl_self) =
            (_tl )
    in  ( _hd_pp : _tl_pps,_self)
sem_IdentList_Nil :: (T_IdentList)
sem_IdentList_Nil  =
    let (_self) =
            []
    in  ( [],_self)
-- IdentStatus -------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for IdentStatus.LogicIdent:
      self

-}
{-
   local variables for IdentStatus.ProgramVar:
      self

-}
{-
   local variables for IdentStatus.UnknownIdentStatus:
      self

-}
-- semantic domain
type T_IdentStatus = ( (IdentStatus))
-- cata
sem_IdentStatus :: (IdentStatus) ->
                   (T_IdentStatus)
sem_IdentStatus ((LogicIdent )) =
    (sem_IdentStatus_LogicIdent )
sem_IdentStatus ((ProgramVar )) =
    (sem_IdentStatus_ProgramVar )
sem_IdentStatus ((UnknownIdentStatus )) =
    (sem_IdentStatus_UnknownIdentStatus )
sem_IdentStatus_LogicIdent :: (T_IdentStatus)
sem_IdentStatus_LogicIdent  =
    let (_self) =
            LogicIdent
    in  ( _self)
sem_IdentStatus_ProgramVar :: (T_IdentStatus)
sem_IdentStatus_ProgramVar  =
    let (_self) =
            ProgramVar
    in  ( _self)
sem_IdentStatus_UnknownIdentStatus :: (T_IdentStatus)
sem_IdentStatus_UnknownIdentStatus  =
    let (_self) =
            UnknownIdentStatus
    in  ( _self)
-- ListGenerator -----------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      pp2                  : PP_Doc2
      self                 : SELF

-}
{-
   local variables for ListGenerator.ListGenerator:
      self

-}
-- semantic domain
type T_ListGenerator = ( (PP_Doc2),(ListGenerator))
-- cata
sem_ListGenerator :: (ListGenerator) ->
                     (T_ListGenerator)
sem_ListGenerator ((ListGenerator (_pos) (_bvar) (_gen))) =
    (sem_ListGenerator_ListGenerator (_pos) ((sem_Ident (_bvar))) ((sem_Expr (_gen))))
sem_ListGenerator_ListGenerator :: (Pos) ->
                                   (T_Ident) ->
                                   (T_Expr) ->
                                   (T_ListGenerator)
sem_ListGenerator_ListGenerator (_pos) (_bvar) (_gen) =
    let (_self) =
            ListGenerator _pos _bvar_self _gen_self
        ( _bvar_pp,_bvar_self) =
            (_bvar )
        ( _gen_pp,_gen_self) =
            (_gen )
    in  ( (_bvar_pp, _gen_pp),_self)
-- ListGeneratorList -------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      pps2                 : PP_Docs2
      self                 : SELF

-}
{-
   local variables for ListGeneratorList.Cons:
      self

-}
{-
   local variables for ListGeneratorList.Nil:
      self

-}
-- semantic domain
type T_ListGeneratorList = ( (PP_Docs2),(ListGeneratorList))
-- cata
sem_ListGeneratorList :: (ListGeneratorList) ->
                         (T_ListGeneratorList)
sem_ListGeneratorList (list) =
    (foldr (sem_ListGeneratorList_Cons) (sem_ListGeneratorList_Nil) ((map sem_ListGenerator list)))
sem_ListGeneratorList_Cons :: (T_ListGenerator) ->
                              (T_ListGeneratorList) ->
                              (T_ListGeneratorList)
sem_ListGeneratorList_Cons (_hd) (_tl) =
    let (_self) =
            (:) _hd_self _tl_self
        ( _hd_pp2,_hd_self) =
            (_hd )
        ( _tl_pps2,_tl_self) =
            (_tl )
    in  ( _hd_pp2 : _tl_pps2,_self)
sem_ListGeneratorList_Nil :: (T_ListGeneratorList)
sem_ListGeneratorList_Nil  =
    let (_self) =
            []
    in  ( [],_self)
-- Literal -----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      pp                   : PP_Doc
      self                 : SELF

-}
{-
   local variables for Literal.LitBool:
      self

-}
{-
   local variables for Literal.LitChar:
      self

-}
{-
   local variables for Literal.LitInt:
      self

-}
{-
   local variables for Literal.LitString:
      self

-}
-- semantic domain
type T_Literal = ( (PP_Doc),(Literal))
-- cata
sem_Literal :: (Literal) ->
               (T_Literal)
sem_Literal ((LitBool (_value) (_pos))) =
    (sem_Literal_LitBool (_value) (_pos))
sem_Literal ((LitChar (_value) (_pos))) =
    (sem_Literal_LitChar (_value) (_pos))
sem_Literal ((LitInt (_value) (_pos))) =
    (sem_Literal_LitInt (_value) (_pos))
sem_Literal ((LitString (_value) (_pos))) =
    (sem_Literal_LitString (_value) (_pos))
sem_Literal_LitBool :: (Bool) ->
                       (Pos) ->
                       (T_Literal)
sem_Literal_LitBool (_value) (_pos) =
    let (_self) =
            LitBool _value _pos
    in  ( text (if _value then "T" else "F"),_self)
sem_Literal_LitChar :: (Char) ->
                       (Pos) ->
                       (T_Literal)
sem_Literal_LitChar (_value) (_pos) =
    let (_self) =
            LitChar _value _pos
    in  ( text "CHR ">#< show (ord _value),_self)
sem_Literal_LitInt :: (Int) ->
                      (Pos) ->
                      (T_Literal)
sem_Literal_LitInt (_value) (_pos) =
    let (_self) =
            LitInt _value _pos
    in  ( text (show _value),_self)
sem_Literal_LitString :: (String) ->
                         (Pos) ->
                         (T_Literal)
sem_Literal_LitString (_value) (_pos) =
    let (_self) =
            LitString _value _pos
    in  ( text (show _value),_self)
-- Marker ------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Marker.Cons:
      self

-}
{-
   local variables for Marker.Nil:
      self

-}
-- semantic domain
type T_Marker = ( (Marker))
-- cata
sem_Marker :: (Marker) ->
              (T_Marker)
sem_Marker (list) =
    (foldr (sem_Marker_Cons) (sem_Marker_Nil) (list))
sem_Marker_Cons :: (String) ->
                   (T_Marker) ->
                   (T_Marker)
sem_Marker_Cons (_hd) (_tl) =
    let (_self) =
            (:) _hd _tl_self
        ( _tl_self) =
            (_tl )
    in  ( _self)
sem_Marker_Nil :: (T_Marker)
sem_Marker_Nil  =
    let (_self) =
            []
    in  ( _self)

