-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.2
-- //
-- //===========================================================================
-- //
-- do not edit; automatically generated by UU.AG
module EXPR_renamebvars where

import PrimitiveConcepts.Position
import PrimitiveConcepts.Name
import Lang.TYPE.PCKG
import Lang.EXPR.PCKG
import List((\\))

rename_bvars collisionvars expr = fst (sem_Expr expr collisionvars [])

type RenamePairList = [(String,String)]

-- given a list of bvars names, and a list of names
-- the bvars should not collide, the function below
-- counstruct a list of renaming pairs so that there is
-- no collision.
--
mk_renamepairs bvars collisionvars 
	=
	map mk_rename . filter collision $ bvars

	where
	collision bvar = bvar `elem` collisionvars

	mk_rename bvar = (bvar,mk_newname bvar)
	
	mk_newname v = head (new_names \\ already_usednames)
		where
		new_names = map (\i-> v ++ "__" ++ show i) [(1::Integer)..]

	already_usednames = bvars ++ collisionvars
	
update_renamepairs new_renames old_renames
	=
	new_renames ++ filter p old_renames
	where
	p (name,newname) = name `elem` map fst new_renames
-- Expr --------------------------------------------------------
{-
   inherited attributes:
      collisionNames       : StringList
      renames              : RenamePairList

   chained attributes:

   synthesised attributes:
      result               : Expr
      self                 : SELF

-}
{-
   local variables for Expr.App:
      self

-}
{-
   local variables for Expr.ArrayApp:
      self

-}
{-
   local variables for Expr.ArrayUpdate:
      self

-}
{-
   local variables for Expr.Binary:
      self

-}
{-
   local variables for Expr.Cond:
      self

-}
{-
   local variables for Expr.FromTo:
      self

-}
{-
   local variables for Expr.Ident:
      self

-}
{-
   local variables for Expr.List:
      self

-}
{-
   local variables for Expr.Lit:
      self

-}
{-
   local variables for Expr.Marker:
      self

-}
{-
   local variables for Expr.Quantor:
      renames
      new_renames
      self

-}
{-
   local variables for Expr.Record:
      self

-}
{-
   local variables for Expr.RecordApp:
      self

-}
{-
   local variables for Expr.RecordUpdate:
      self

-}
{-
   local variables for Expr.SQLSelect:
      renames
      new_renames
      self

-}
{-
   local variables for Expr.Unary:
      self

-}
-- semantic domain
type T_Expr = (StringList) ->
              (RenamePairList) ->
              ( (Expr),(Expr))
-- cata
sem_Expr :: (Expr) ->
            (T_Expr)
sem_Expr ((App (_func) (_arg))) =
    (sem_Expr_App ((sem_Expr (_func))) ((sem_Expr (_arg))))
sem_Expr ((ArrayApp (_pos) (_array) (_element))) =
    (sem_Expr_ArrayApp (_pos) ((sem_Expr (_array))) ((sem_Expr (_element))))
sem_Expr ((ArrayUpdate (_target) (_at) (_with))) =
    (sem_Expr_ArrayUpdate ((sem_Expr (_target))) ((sem_ExprList (_at))) ((sem_Expr (_with))))
sem_Expr ((Binary (_op) (_arg1) (_arg2))) =
    (sem_Expr_Binary ((sem_Ident (_op))) ((sem_Expr (_arg1))) ((sem_Expr (_arg2))))
sem_Expr ((Cond (_pos) (_guard) (_val1) (_val2))) =
    (sem_Expr_Cond (_pos) ((sem_Expr (_guard))) ((sem_Expr (_val1))) ((sem_Expr (_val2))))
sem_Expr ((FromTo (_pos) (_ranger) (_left) (_right))) =
    (sem_Expr_FromTo (_pos) ((sem_Expr (_ranger))) ((sem_Expr (_left))) ((sem_Expr (_right))))
sem_Expr ((Ident (_ident))) =
    (sem_Expr_Ident ((sem_Ident (_ident))))
sem_Expr ((List (_pos) (_exprlist))) =
    (sem_Expr_List (_pos) ((sem_ExprList (_exprlist))))
sem_Expr ((Lit (_value))) =
    (sem_Expr_Lit ((sem_Literal (_value))))
sem_Expr ((Marker (_marker) (_expr))) =
    (sem_Expr_Marker ((sem_Marker (_marker))) ((sem_Expr (_expr))))
sem_Expr ((Quantor (_op) (_varl) (_domain) (_body))) =
    (sem_Expr_Quantor ((sem_Ident (_op))) ((sem_IdentList (_varl))) ((sem_Expr (_domain))) ((sem_Expr (_body))))
sem_Expr ((Record (_pos) (_fields))) =
    (sem_Expr_Record (_pos) ((sem_FieldAssignmentList (_fields))))
sem_Expr ((RecordApp (_pos) (_record) (_field))) =
    (sem_Expr_RecordApp (_pos) ((sem_Expr (_record))) (_field))
sem_Expr ((RecordUpdate (_target) (_at) (_with) (_ty))) =
    (sem_Expr_RecordUpdate ((sem_Expr (_target))) (_at) ((sem_Expr (_with))) (_ty))
sem_Expr ((SQLSelect (_pos) (_generators) (_filter) (_map))) =
    (sem_Expr_SQLSelect (_pos) ((sem_ListGeneratorList (_generators))) ((sem_Expr (_filter))) ((sem_Expr (_map))))
sem_Expr ((Unary (_op) (_arg))) =
    (sem_Expr_Unary ((sem_Ident (_op))) ((sem_Expr (_arg))))
sem_Expr_App :: (T_Expr) ->
                (T_Expr) ->
                (T_Expr)
sem_Expr_App (_func) (_arg) =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                App _func_self _arg_self
            ( _func_result,_func_self) =
                (_func (_lhs_collisionNames) (_lhs_renames))
            ( _arg_result,_arg_self) =
                (_arg (_lhs_collisionNames) (_lhs_renames))
        in  ( App
                    _func_result
                    _arg_result
             ,_self
             )
sem_Expr_ArrayApp :: (Pos) ->
                     (T_Expr) ->
                     (T_Expr) ->
                     (T_Expr)
sem_Expr_ArrayApp (_pos) (_array) (_element) =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                ArrayApp _pos _array_self _element_self
            ( _array_result,_array_self) =
                (_array (_lhs_collisionNames) (_lhs_renames))
            ( _element_result,_element_self) =
                (_element (_lhs_collisionNames) (_lhs_renames))
        in  ( ArrayApp
                    _pos
                    _array_result
                    _element_result
             ,_self
             )
sem_Expr_ArrayUpdate :: (T_Expr) ->
                        (T_ExprList) ->
                        (T_Expr) ->
                        (T_Expr)
sem_Expr_ArrayUpdate (_target) (_at) (_with) =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                ArrayUpdate _target_self _at_self _with_self
            ( _target_result,_target_self) =
                (_target (_lhs_collisionNames) (_lhs_renames))
            ( _at_results,_at_self) =
                (_at (_lhs_collisionNames) (_lhs_renames))
            ( _with_result,_with_self) =
                (_with (_lhs_collisionNames) (_lhs_renames))
        in  ( ArrayUpdate
                    _target_result
                    _at_results
                    _with_result
             ,_self
             )
sem_Expr_Binary :: (T_Ident) ->
                   (T_Expr) ->
                   (T_Expr) ->
                   (T_Expr)
sem_Expr_Binary (_op) (_arg1) (_arg2) =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                Binary _op_self _arg1_self _arg2_self
            ( _op_name,_op_result,_op_self) =
                (_op (_lhs_collisionNames) (_lhs_renames))
            ( _arg1_result,_arg1_self) =
                (_arg1 (_lhs_collisionNames) (_lhs_renames))
            ( _arg2_result,_arg2_self) =
                (_arg2 (_lhs_collisionNames) (_lhs_renames))
        in  ( Binary
                    _op_self
                    _arg1_result
                    _arg2_result
             ,_self
             )
sem_Expr_Cond :: (Pos) ->
                 (T_Expr) ->
                 (T_Expr) ->
                 (T_Expr) ->
                 (T_Expr)
sem_Expr_Cond (_pos) (_guard) (_val1) (_val2) =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                Cond _pos _guard_self _val1_self _val2_self
            ( _guard_result,_guard_self) =
                (_guard (_lhs_collisionNames) (_lhs_renames))
            ( _val1_result,_val1_self) =
                (_val1 (_lhs_collisionNames) (_lhs_renames))
            ( _val2_result,_val2_self) =
                (_val2 (_lhs_collisionNames) (_lhs_renames))
        in  ( Cond
                    _pos
                    _guard_result
                    _val1_result
                    _val2_result
             ,_self
             )
sem_Expr_FromTo :: (Pos) ->
                   (T_Expr) ->
                   (T_Expr) ->
                   (T_Expr) ->
                   (T_Expr)
sem_Expr_FromTo (_pos) (_ranger) (_left) (_right) =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                FromTo _pos _ranger_self _left_self _right_self
            ( _ranger_result,_ranger_self) =
                (_ranger (_lhs_collisionNames) (_lhs_renames))
            ( _left_result,_left_self) =
                (_left (_lhs_collisionNames) (_lhs_renames))
            ( _right_result,_right_self) =
                (_right (_lhs_collisionNames) (_lhs_renames))
        in  ( FromTo
                    _pos
                    _ranger_self
                    _left_self
                    _right_self
             ,_self
             )
sem_Expr_Ident :: (T_Ident) ->
                  (T_Expr)
sem_Expr_Ident (_ident) =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                Ident _ident_self
            ( _ident_name,_ident_result,_ident_self) =
                (_ident (_lhs_collisionNames) (_lhs_renames))
        in  ( Ident _ident_result,_self)
sem_Expr_List :: (Pos) ->
                 (T_ExprList) ->
                 (T_Expr)
sem_Expr_List (_pos) (_exprlist) =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                List _pos _exprlist_self
            ( _exprlist_results,_exprlist_self) =
                (_exprlist (_lhs_collisionNames) (_lhs_renames))
        in  ( List
                    _pos
                    _exprlist_results
             ,_self
             )
sem_Expr_Lit :: (T_Literal) ->
                (T_Expr)
sem_Expr_Lit (_value) =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                Lit _value_self
            ( _value_self) =
                (_value )
        in  ( Lit _value_self,_self)
sem_Expr_Marker :: (T_Marker) ->
                   (T_Expr) ->
                   (T_Expr)
sem_Expr_Marker (_marker) (_expr) =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                Marker _marker_self _expr_self
            ( _marker_self) =
                (_marker )
            ( _expr_result,_expr_self) =
                (_expr (_lhs_collisionNames) (_lhs_renames))
        in  ( Marker _marker_self _expr_result,_self)
sem_Expr_Quantor :: (T_Ident) ->
                    (T_IdentList) ->
                    (T_Expr) ->
                    (T_Expr) ->
                    (T_Expr)
sem_Expr_Quantor (_op) (_varl) (_domain) (_body) =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                Quantor _op_self _varl_self _domain_self _body_self
            (_new_renames) =
                mk_renamepairs _varl_names _lhs_collisionNames
            (_renames) =
                update_renamepairs _new_renames _lhs_renames
            ( _op_name,_op_result,_op_self) =
                (_op (_lhs_collisionNames) (_renames))
            ( _varl_names,_varl_results,_varl_self) =
                (_varl (_lhs_collisionNames) (_renames))
            ( _domain_result,_domain_self) =
                (_domain (_lhs_collisionNames) (_renames))
            ( _body_result,_body_self) =
                (_body (_lhs_collisionNames) (_renames))
        in  ( Quantor
                    _op_self
                    _varl_results
                    _domain_result
                    _body_result
             ,_self
             )
sem_Expr_Record :: (Pos) ->
                   (T_FieldAssignmentList) ->
                   (T_Expr)
sem_Expr_Record (_pos) (_fields) =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                Record _pos _fields_self
            ( _fields_results,_fields_self) =
                (_fields (_lhs_collisionNames) (_lhs_renames))
        in  ( Record
                    _pos
                    _fields_results
             ,_self
             )
sem_Expr_RecordApp :: (Pos) ->
                      (T_Expr) ->
                      (String) ->
                      (T_Expr)
sem_Expr_RecordApp (_pos) (_record) (_field) =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                RecordApp _pos _record_self _field
            ( _record_result,_record_self) =
                (_record (_lhs_collisionNames) (_lhs_renames))
        in  ( RecordApp
                    _pos
                    _record_result
                    _field
             ,_self
             )
sem_Expr_RecordUpdate :: (T_Expr) ->
                         (StringList) ->
                         (T_Expr) ->
                         (Type) ->
                         (T_Expr)
sem_Expr_RecordUpdate (_target) (_at) (_with) (_ty) =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                RecordUpdate _target_self _at _with_self _ty
            ( _target_result,_target_self) =
                (_target (_lhs_collisionNames) (_lhs_renames))
            ( _with_result,_with_self) =
                (_with (_lhs_collisionNames) (_lhs_renames))
        in  ( RecordUpdate
                    _target_result
                    _at
                    _with_result
                    _ty
             ,_self
             )
sem_Expr_SQLSelect :: (Pos) ->
                      (T_ListGeneratorList) ->
                      (T_Expr) ->
                      (T_Expr) ->
                      (T_Expr)
sem_Expr_SQLSelect (_pos) (_generators) (_filter) (_map) =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                SQLSelect _pos _generators_self _filter_self _map_self
            (_new_renames) =
                mk_renamepairs _generators_bvars _lhs_collisionNames
            (_renames) =
                update_renamepairs _new_renames _lhs_renames
            ( _generators_bvars,_generators_results,_generators_self) =
                (_generators (_lhs_collisionNames) (_lhs_renames))
            ( _filter_result,_filter_self) =
                (_filter (_lhs_collisionNames) (_renames))
            ( _map_result,_map_self) =
                (_map (_lhs_collisionNames) (_renames))
        in  ( SQLSelect
                    _pos
                    _generators_results
                    _filter_result
                    _map_result
             ,_self
             )
sem_Expr_Unary :: (T_Ident) ->
                  (T_Expr) ->
                  (T_Expr)
sem_Expr_Unary (_op) (_arg) =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                Unary _op_self _arg_self
            ( _op_name,_op_result,_op_self) =
                (_op (_lhs_collisionNames) (_lhs_renames))
            ( _arg_result,_arg_self) =
                (_arg (_lhs_collisionNames) (_lhs_renames))
        in  ( Unary
                    _op_self
                    _arg_result
             ,_self
             )
-- ExprList ----------------------------------------------------
{-
   inherited attributes:
      collisionNames       : StringList
      renames              : RenamePairList

   chained attributes:

   synthesised attributes:
      results              : ExprList
      self                 : SELF

-}
{-
   local variables for ExprList.Cons:
      self

-}
{-
   local variables for ExprList.Nil:
      self

-}
-- semantic domain
type T_ExprList = (StringList) ->
                  (RenamePairList) ->
                  ( (ExprList),(ExprList))
-- cata
sem_ExprList :: (ExprList) ->
                (T_ExprList)
sem_ExprList (list) =
    (foldr (sem_ExprList_Cons) (sem_ExprList_Nil) ((map sem_Expr list)))
sem_ExprList_Cons :: (T_Expr) ->
                     (T_ExprList) ->
                     (T_ExprList)
sem_ExprList_Cons (_hd) (_tl) =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                (:) _hd_self _tl_self
            ( _hd_result,_hd_self) =
                (_hd (_lhs_collisionNames) (_lhs_renames))
            ( _tl_results,_tl_self) =
                (_tl (_lhs_collisionNames) (_lhs_renames))
        in  ( _hd_result : _tl_results,_self)
sem_ExprList_Nil :: (T_ExprList)
sem_ExprList_Nil  =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                []
        in  ( [],_self)
-- FieldAssignment ---------------------------------------------
{-
   inherited attributes:
      collisionNames       : StringList
      renames              : RenamePairList

   chained attributes:

   synthesised attributes:
      result               : FieldAssignment
      self                 : SELF

-}
{-
   local variables for FieldAssignment.FieldAssignment:
      self

-}
-- semantic domain
type T_FieldAssignment = (StringList) ->
                         (RenamePairList) ->
                         ( (FieldAssignment),(FieldAssignment))
-- cata
sem_FieldAssignment :: (FieldAssignment) ->
                       (T_FieldAssignment)
sem_FieldAssignment ((FieldAssignment (_pos) (_field) (_value))) =
    (sem_FieldAssignment_FieldAssignment (_pos) (_field) ((sem_Expr (_value))))
sem_FieldAssignment_FieldAssignment :: (Pos) ->
                                       (String) ->
                                       (T_Expr) ->
                                       (T_FieldAssignment)
sem_FieldAssignment_FieldAssignment (_pos) (_field) (_value) =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                FieldAssignment _pos _field _value_self
            ( _value_result,_value_self) =
                (_value (_lhs_collisionNames) (_lhs_renames))
        in  ( FieldAssignment
                    _pos
                    _field
                    _value_result
             ,_self
             )
-- FieldAssignmentList -----------------------------------------
{-
   inherited attributes:
      collisionNames       : StringList
      renames              : RenamePairList

   chained attributes:

   synthesised attributes:
      results              : FieldAssignmentList
      self                 : SELF

-}
{-
   local variables for FieldAssignmentList.Cons:
      self

-}
{-
   local variables for FieldAssignmentList.Nil:
      self

-}
-- semantic domain
type T_FieldAssignmentList = (StringList) ->
                             (RenamePairList) ->
                             ( (FieldAssignmentList),(FieldAssignmentList))
-- cata
sem_FieldAssignmentList :: (FieldAssignmentList) ->
                           (T_FieldAssignmentList)
sem_FieldAssignmentList (list) =
    (foldr (sem_FieldAssignmentList_Cons) (sem_FieldAssignmentList_Nil) ((map sem_FieldAssignment list)))
sem_FieldAssignmentList_Cons :: (T_FieldAssignment) ->
                                (T_FieldAssignmentList) ->
                                (T_FieldAssignmentList)
sem_FieldAssignmentList_Cons (_hd) (_tl) =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                (:) _hd_self _tl_self
            ( _hd_result,_hd_self) =
                (_hd (_lhs_collisionNames) (_lhs_renames))
            ( _tl_results,_tl_self) =
                (_tl (_lhs_collisionNames) (_lhs_renames))
        in  ( _hd_result : _tl_results,_self)
sem_FieldAssignmentList_Nil :: (T_FieldAssignmentList)
sem_FieldAssignmentList_Nil  =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                []
        in  ( [],_self)
-- Ident -------------------------------------------------------
{-
   inherited attributes:
      collisionNames       : StringList
      renames              : RenamePairList

   chained attributes:

   synthesised attributes:
      name                 : String
      result               : Ident
      self                 : SELF

-}
{-
   local variables for Ident.Identifier:
      self

-}
-- semantic domain
type T_Ident = (StringList) ->
               (RenamePairList) ->
               ( (String),(Ident),(Ident))
-- cata
sem_Ident :: (Ident) ->
             (T_Ident)
sem_Ident ((Identifier (_name) (_status) (_ty) (_pos))) =
    (sem_Ident_Identifier (_name) ((sem_IdentStatus (_status))) (_ty) (_pos))
sem_Ident_Identifier :: (String) ->
                        (T_IdentStatus) ->
                        (Type) ->
                        (Pos) ->
                        (T_Ident)
sem_Ident_Identifier (_name) (_status) (_ty) (_pos) =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                Identifier _name _status_self _ty _pos
            ( _status_self) =
                (_status )
        in  ( _name
             ,case lookup _name _lhs_renames of
              Just newname  -> Identifier
                                    newname
                                    _status
                                    _ty
                                    _pos
              otherwise     -> _self
             ,_self
             )
-- IdentList ---------------------------------------------------
{-
   inherited attributes:
      collisionNames       : StringList
      renames              : RenamePairList

   chained attributes:

   synthesised attributes:
      names                : StringList
      results              : IdentList
      self                 : SELF

-}
{-
   local variables for IdentList.Cons:
      self

-}
{-
   local variables for IdentList.Nil:
      self

-}
-- semantic domain
type T_IdentList = (StringList) ->
                   (RenamePairList) ->
                   ( (StringList),(IdentList),(IdentList))
-- cata
sem_IdentList :: (IdentList) ->
                 (T_IdentList)
sem_IdentList (list) =
    (foldr (sem_IdentList_Cons) (sem_IdentList_Nil) ((map sem_Ident list)))
sem_IdentList_Cons :: (T_Ident) ->
                      (T_IdentList) ->
                      (T_IdentList)
sem_IdentList_Cons (_hd) (_tl) =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                (:) _hd_self _tl_self
            ( _hd_name,_hd_result,_hd_self) =
                (_hd (_lhs_collisionNames) (_lhs_renames))
            ( _tl_names,_tl_results,_tl_self) =
                (_tl (_lhs_collisionNames) (_lhs_renames))
        in  ( _hd_name : _tl_names,_hd_result : _tl_results,_self)
sem_IdentList_Nil :: (T_IdentList)
sem_IdentList_Nil  =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                []
        in  ( [],[],_self)
-- IdentStatus -------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for IdentStatus.LogicIdent:
      self

-}
{-
   local variables for IdentStatus.ProgramVar:
      self

-}
{-
   local variables for IdentStatus.UnknownIdentStatus:
      self

-}
-- semantic domain
type T_IdentStatus = ( (IdentStatus))
-- cata
sem_IdentStatus :: (IdentStatus) ->
                   (T_IdentStatus)
sem_IdentStatus ((LogicIdent )) =
    (sem_IdentStatus_LogicIdent )
sem_IdentStatus ((ProgramVar )) =
    (sem_IdentStatus_ProgramVar )
sem_IdentStatus ((UnknownIdentStatus )) =
    (sem_IdentStatus_UnknownIdentStatus )
sem_IdentStatus_LogicIdent :: (T_IdentStatus)
sem_IdentStatus_LogicIdent  =
    let (_self) =
            LogicIdent
    in  ( _self)
sem_IdentStatus_ProgramVar :: (T_IdentStatus)
sem_IdentStatus_ProgramVar  =
    let (_self) =
            ProgramVar
    in  ( _self)
sem_IdentStatus_UnknownIdentStatus :: (T_IdentStatus)
sem_IdentStatus_UnknownIdentStatus  =
    let (_self) =
            UnknownIdentStatus
    in  ( _self)
-- ListGenerator -----------------------------------------------
{-
   inherited attributes:
      collisionNames       : StringList
      renames              : RenamePairList

   chained attributes:

   synthesised attributes:
      bvar                 : String
      result               : ListGenerator
      self                 : SELF

-}
{-
   local variables for ListGenerator.ListGenerator:
      self

-}
-- semantic domain
type T_ListGenerator = (StringList) ->
                       (RenamePairList) ->
                       ( (String),(ListGenerator),(ListGenerator))
-- cata
sem_ListGenerator :: (ListGenerator) ->
                     (T_ListGenerator)
sem_ListGenerator ((ListGenerator (_pos) (_bvar) (_gen))) =
    (sem_ListGenerator_ListGenerator (_pos) ((sem_Ident (_bvar))) ((sem_Expr (_gen))))
sem_ListGenerator_ListGenerator :: (Pos) ->
                                   (T_Ident) ->
                                   (T_Expr) ->
                                   (T_ListGenerator)
sem_ListGenerator_ListGenerator (_pos) (_bvar) (_gen) =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                ListGenerator _pos _bvar_self _gen_self
            ( _bvar_name,_bvar_result,_bvar_self) =
                (_bvar (_lhs_collisionNames) (_lhs_renames))
            ( _gen_result,_gen_self) =
                (_gen (_lhs_collisionNames) (_lhs_renames))
        in  ( _bvar_name
             ,ListGenerator
                    _pos
                    _bvar_result
                    _gen_result
             ,_self
             )
-- ListGeneratorList -------------------------------------------
{-
   inherited attributes:
      collisionNames       : StringList
      renames              : RenamePairList

   chained attributes:

   synthesised attributes:
      bvars                : StringList
      results              : ListGeneratorList
      self                 : SELF

-}
{-
   local variables for ListGeneratorList.Cons:
      self

-}
{-
   local variables for ListGeneratorList.Nil:
      self

-}
-- semantic domain
type T_ListGeneratorList = (StringList) ->
                           (RenamePairList) ->
                           ( (StringList),(ListGeneratorList),(ListGeneratorList))
-- cata
sem_ListGeneratorList :: (ListGeneratorList) ->
                         (T_ListGeneratorList)
sem_ListGeneratorList (list) =
    (foldr (sem_ListGeneratorList_Cons) (sem_ListGeneratorList_Nil) ((map sem_ListGenerator list)))
sem_ListGeneratorList_Cons :: (T_ListGenerator) ->
                              (T_ListGeneratorList) ->
                              (T_ListGeneratorList)
sem_ListGeneratorList_Cons (_hd) (_tl) =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                (:) _hd_self _tl_self
            ( _hd_bvar,_hd_result,_hd_self) =
                (_hd (_lhs_collisionNames) (_lhs_renames))
            ( _tl_bvars,_tl_results,_tl_self) =
                (_tl (_lhs_collisionNames) (_lhs_renames))
        in  ( _hd_bvar : _tl_bvars,_hd_result : _tl_results,_self)
sem_ListGeneratorList_Nil :: (T_ListGeneratorList)
sem_ListGeneratorList_Nil  =
    \ _lhs_collisionNames
      _lhs_renames ->
        let (_self) =
                []
        in  ( [],[],_self)
-- Literal -----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Literal.LitBool:
      self

-}
{-
   local variables for Literal.LitChar:
      self

-}
{-
   local variables for Literal.LitInt:
      self

-}
{-
   local variables for Literal.LitString:
      self

-}
-- semantic domain
type T_Literal = ( (Literal))
-- cata
sem_Literal :: (Literal) ->
               (T_Literal)
sem_Literal ((LitBool (_value) (_pos))) =
    (sem_Literal_LitBool (_value) (_pos))
sem_Literal ((LitChar (_value) (_pos))) =
    (sem_Literal_LitChar (_value) (_pos))
sem_Literal ((LitInt (_value) (_pos))) =
    (sem_Literal_LitInt (_value) (_pos))
sem_Literal ((LitString (_value) (_pos))) =
    (sem_Literal_LitString (_value) (_pos))
sem_Literal_LitBool :: (Bool) ->
                       (Pos) ->
                       (T_Literal)
sem_Literal_LitBool (_value) (_pos) =
    let (_self) =
            LitBool _value _pos
    in  ( _self)
sem_Literal_LitChar :: (Char) ->
                       (Pos) ->
                       (T_Literal)
sem_Literal_LitChar (_value) (_pos) =
    let (_self) =
            LitChar _value _pos
    in  ( _self)
sem_Literal_LitInt :: (Int) ->
                      (Pos) ->
                      (T_Literal)
sem_Literal_LitInt (_value) (_pos) =
    let (_self) =
            LitInt _value _pos
    in  ( _self)
sem_Literal_LitString :: (String) ->
                         (Pos) ->
                         (T_Literal)
sem_Literal_LitString (_value) (_pos) =
    let (_self) =
            LitString _value _pos
    in  ( _self)
-- Marker ------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Marker.Cons:
      self

-}
{-
   local variables for Marker.Nil:
      self

-}
-- semantic domain
type T_Marker = ( (Marker))
-- cata
sem_Marker :: (Marker) ->
              (T_Marker)
sem_Marker (list) =
    (foldr (sem_Marker_Cons) (sem_Marker_Nil) (list))
sem_Marker_Cons :: (String) ->
                   (T_Marker) ->
                   (T_Marker)
sem_Marker_Cons (_hd) (_tl) =
    let (_self) =
            (:) _hd _tl_self
        ( _tl_self) =
            (_tl )
    in  ( _self)
sem_Marker_Nil :: (T_Marker)
sem_Marker_Nil  =
    let (_self) =
            []
    in  ( _self)

