-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.2
-- //
-- //===========================================================================
-- //
-- do not edit; automatically generated by UU.AG
module SEQ_typechecker where

import Lang.TYPE.PCKG
import Lang.EXPR.PCKG
import Lang.STMT.PCKG
import Lang.SEQ.PCKG

import Engine.TypeChecker.Basic
import Engine.TypeChecker.Bridge2CSolver
import Engine.TypeChecker.ErrorMsg 

import PrimitiveConcepts.Position
import PrimitiveConcepts.ErrorMsg
import PrimitiveConcepts.LC
import PrimitiveConcepts.Name

import UU.Pretty
import Etcetera.PCKG
import Configuration.Lang



tc p = (p',errors)  where  (p',_,errors) = sem_SeqProg p

--
-- Looking up in the identifier context
--
lookUP name context = tyscheme
	where
	tyscheme = case lookup name context of
	   Just t 	-> t
	   Nothing 	-> internalError 
				(name ++ " cannot be found in context.")
				"EXPR_typechecker"

construct_inferRecTy (TyRecord fields) fname ty
	=
	if fieldFound
	then TyRecord (map f fields)
	else TyRecord (Field fname ty : fields)
	where
	f (Field fname' ty')
		= 
		if fname==fname'
		then Field fname ty
		else Field fname' ty'

	fieldFound = not . null . filter p $ fields
		where
		p (Field fn _ ) = fn == fname


get_cvar (JUST (Ident (Identifier name _ _ _))) = Just name
get_cvar _ = Nothing


--
-- Important: when a logical constant is added to a context,
-- its typescheme should be ForAllTy
--
get_name_tyscheme userdef_lconst 
	= 
	(lc_name userdef_lconst, toTypeScheme (lc_type userdef_lconst))

predefined_lconst_cx 
	=
	map get_name_tyscheme
		(default_EXPR_prefixes
		 ++ default_EXPR_unaries
		 ++ default_EXPR_infixes
		 ++ default_EXPR_quantors )



--
-- Important! When a parameter or a local variable is added 
-- to the context, its typescheme should remain flat!
--

--
-- Important! No multiply declared variable is assumed.
-- (this should have been detected during the earlier
-- syntax checking phase)
--

add_locals_to_context names ty old_context 
	=
	map f names ++ old_context

 	where

	f (Name pos name) = (name, FlatTy ty)	



type TypeSubstitutionFunction = Type->Type


fromTypeScheme (FlatTy ty)   = ty
fromTypeScheme (ForAllTy ty) = ty
-- Decl --------------------------------------------------------
{-
   inherited attributes:
      lvars                : StringList
      tySubst              : TypeSubstitutionFunction
      vcx                  : IdentContext

   chained attributes:
      freshTyVarName       : Int

   synthesised attributes:
      cl                   : Constraint__List
      new                  : Decl
      postTypeErrors       : TypeConstraintErrorList
      pv_cx                : IdentContext
      self                 : SELF

-}
{-
   local variables for Decl.Decl:
      cl_
      self

-}
-- semantic domain
type T_Decl = (Int) ->
              (StringList) ->
              (TypeSubstitutionFunction) ->
              (IdentContext) ->
              ( (Constraint__List),(Int),(Decl),(TypeConstraintErrorList),(IdentContext),(Decl))
-- cata
sem_Decl :: (Decl) ->
            (T_Decl)
sem_Decl ((Decl (_auxVarFlag) (_names) (_ty) (_size))) =
    (sem_Decl_Decl (_auxVarFlag) (_names) (_ty) ((sem_ExprList (_size))))
sem_Decl_Decl :: (AuxVarFlag) ->
                 (NameList) ->
                 (Type) ->
                 (T_ExprList) ->
                 (T_Decl)
sem_Decl_Decl (_auxVarFlag) (_names) (_ty) (_size) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                Decl _auxVarFlag _names _ty _size_self
            (_cl_) =
                map
                  (\(n,ty)-> (ty <==> intTy) (typeError_notInt n ty))
                  (zip _size_self _size_retTys)
            ( _size_cl,_size_freshTyVarName,_size_new,_size_postTypeErrors,_size_retTys,_size_self) =
                (_size (_lhs_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( _size_cl ++ _cl_
             ,_size_freshTyVarName
             ,Decl
                    _auxVarFlag
                    _names
                    _ty
                    _size_new
             ,_size_postTypeErrors
             ,add_locals_to_context
                    _names
                    _ty
                    []
             ,_self
             )
-- DeclList ----------------------------------------------------
{-
   inherited attributes:
      lvars                : StringList
      tySubst              : TypeSubstitutionFunction
      vcx                  : IdentContext

   chained attributes:
      freshTyVarName       : Int

   synthesised attributes:
      cl                   : Constraint__List
      new                  : DeclList
      postTypeErrors       : TypeConstraintErrorList
      pv_cx                : IdentContext
      self                 : SELF

-}
{-
   local variables for DeclList.Cons:
      self

-}
{-
   local variables for DeclList.Nil:
      self

-}
-- semantic domain
type T_DeclList = (Int) ->
                  (StringList) ->
                  (TypeSubstitutionFunction) ->
                  (IdentContext) ->
                  ( (Constraint__List),(Int),(DeclList),(TypeConstraintErrorList),(IdentContext),(DeclList))
-- cata
sem_DeclList :: (DeclList) ->
                (T_DeclList)
sem_DeclList (list) =
    (foldr (sem_DeclList_Cons) (sem_DeclList_Nil) ((map sem_Decl list)))
sem_DeclList_Cons :: (T_Decl) ->
                     (T_DeclList) ->
                     (T_DeclList)
sem_DeclList_Cons (_hd) (_tl) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                (:) _hd_self _tl_self
            ( _hd_cl,_hd_freshTyVarName,_hd_new,_hd_postTypeErrors,_hd_pv_cx,_hd_self) =
                (_hd (_lhs_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
            ( _tl_cl,_tl_freshTyVarName,_tl_new,_tl_postTypeErrors,_tl_pv_cx,_tl_self) =
                (_tl (_hd_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( _hd_cl ++ _tl_cl,_tl_freshTyVarName,_hd_new : _tl_new,_hd_postTypeErrors ++ _tl_postTypeErrors,_hd_pv_cx ++ _tl_pv_cx,_self)
sem_DeclList_Nil :: (T_DeclList)
sem_DeclList_Nil  =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                []
        in  ( [],_lhs_freshTyVarName,[],[],[],_self)
-- Expr --------------------------------------------------------
{-
   inherited attributes:
      lvars                : StringList
      tySubst              : TypeSubstitutionFunction
      vcx                  : IdentContext

   chained attributes:
      freshTyVarName       : Int

   synthesised attributes:
      cl                   : Constraint__List
      new                  : Expr
      postTypeErrors       : TypeConstraintErrorList
      retTy                : Type
      self                 : SELF

-}
{-
   local variables for Expr.App:
      co2
      co1
      func_inferty
      funret_ty
      funarg_ty
      freshTyVarName_
      new_tyvar
      ermsg
      self

-}
{-
   local variables for Expr.ArrayApp:
      co_i
      co_a
      array_inferty
      array_el_ty
      freshTyVarName_
      new_tyvar
      ermsg_i
      ermsg_a
      self

-}
{-
   local variables for Expr.ArrayUpdate:
      self

-}
{-
   local variables for Expr.Binary:
      co2
      co1
      co0
      ermsg2
      ermsg1
      ermsg0
      op_inferty
      new_tyvar
      freshTyVarName_
      op_retty_
      arg2_ty_
      arg1_ty_
      op_ty_
      op_ty
      lookup_
      self

-}
{-
   local variables for Expr.Cond:
      co2
      co1
      ermsg2
      ermsg1
      self

-}
{-
   local variables for Expr.FromTo:
      co_ranger
      co_ri
      co_le
      infer_ty
      freshTyVarName_
      new_tyvar
      errmsg_ri
      errmsg_le
      errmsg_ranger
      self

-}
{-
   local variables for Expr.Ident:
      retTy
      lookup_
      realname
      revName
      self

-}
{-
   local variables for Expr.List:
      cl_elems
      mk_co_elem
      list_inferty
      el_inferty
      freshTyVarName_
      new_tyvar
      mk_errmsg_elem
      self

-}
{-
   local variables for Expr.Lit:
      self

-}
{-
   local variables for Expr.Marker:
      self

-}
{-
   local variables for Expr.Quantor:
      lvars
      co_quant
      co_body
      co_dom
      ermsg_quant
      ermsg_body
      ermsg_dom
      vcx
      quant_inferty
      new_tyvar
      freshTyVarName__
      vcx_updates
      new_tyvars
      freshTyVarName_
      quant_retty_
      body_ty_
      quant_ty_
      quant_ty
      lookup_
      self

-}
{-
   local variables for Expr.Record:
      record_inferty
      self

-}
{-
   local variables for Expr.RecordApp:
      errMsg_f
      errMsg_f_
      final_inferFieldTy
      final_fieldTy
      final_inferRecTy
      final_recTy
      retTy
      co
      record_inferty
      freshTyVarName_
      new_tyvar
      ermsg_r
      self

-}
{-
   local variables for Expr.RecordUpdate:
      self

-}
{-
   local variables for Expr.SQLSelect:
      lvars
      co_filter
      ermsg_filter
      vcx
      freshTyVarName_
      vcx_updates
      new_tyvars
      self

-}
{-
   local variables for Expr.Unary:
      co1
      co0
      ermsg1
      ermsg0
      op_inferty
      new_tyvar
      freshTyVarName_
      op_retty_
      arg_ty_
      op_ty_
      op_ty
      lookup_
      self

-}
-- semantic domain
type T_Expr = (Int) ->
              (StringList) ->
              (TypeSubstitutionFunction) ->
              (IdentContext) ->
              ( (Constraint__List),(Int),(Expr),(TypeConstraintErrorList),(Type),(Expr))
-- cata
sem_Expr :: (Expr) ->
            (T_Expr)
sem_Expr ((App (_func) (_arg))) =
    (sem_Expr_App ((sem_Expr (_func))) ((sem_Expr (_arg))))
sem_Expr ((ArrayApp (_pos) (_array) (_element))) =
    (sem_Expr_ArrayApp (_pos) ((sem_Expr (_array))) ((sem_Expr (_element))))
sem_Expr ((ArrayUpdate (_target) (_at) (_with))) =
    (sem_Expr_ArrayUpdate ((sem_Expr (_target))) ((sem_ExprList (_at))) ((sem_Expr (_with))))
sem_Expr ((Binary (_op) (_arg1) (_arg2))) =
    (sem_Expr_Binary ((sem_Ident (_op))) ((sem_Expr (_arg1))) ((sem_Expr (_arg2))))
sem_Expr ((Cond (_pos) (_guard) (_val1) (_val2))) =
    (sem_Expr_Cond (_pos) ((sem_Expr (_guard))) ((sem_Expr (_val1))) ((sem_Expr (_val2))))
sem_Expr ((FromTo (_pos) (_ranger) (_left) (_right))) =
    (sem_Expr_FromTo (_pos) ((sem_Expr (_ranger))) ((sem_Expr (_left))) ((sem_Expr (_right))))
sem_Expr ((Ident (_ident))) =
    (sem_Expr_Ident ((sem_Ident (_ident))))
sem_Expr ((List (_pos) (_exprlist))) =
    (sem_Expr_List (_pos) ((sem_ExprList (_exprlist))))
sem_Expr ((Lit (_value))) =
    (sem_Expr_Lit ((sem_Literal (_value))))
sem_Expr ((Marker (_marker) (_expr))) =
    (sem_Expr_Marker ((sem_Marker (_marker))) ((sem_Expr (_expr))))
sem_Expr ((Quantor (_op) (_varl) (_domain) (_body))) =
    (sem_Expr_Quantor ((sem_Ident (_op))) ((sem_IdentList (_varl))) ((sem_Expr (_domain))) ((sem_Expr (_body))))
sem_Expr ((Record (_pos) (_fields))) =
    (sem_Expr_Record (_pos) ((sem_FieldAssignmentList (_fields))))
sem_Expr ((RecordApp (_pos) (_record) (_field))) =
    (sem_Expr_RecordApp (_pos) ((sem_Expr (_record))) (_field))
sem_Expr ((RecordUpdate (_target) (_at) (_with) (_ty))) =
    (sem_Expr_RecordUpdate ((sem_Expr (_target))) (_at) ((sem_Expr (_with))) (_ty))
sem_Expr ((SQLSelect (_pos) (_generators) (_filter) (_map))) =
    (sem_Expr_SQLSelect (_pos) ((sem_ListGeneratorList (_generators))) ((sem_Expr (_filter))) ((sem_Expr (_map))))
sem_Expr ((Unary (_op) (_arg))) =
    (sem_Expr_Unary ((sem_Ident (_op))) ((sem_Expr (_arg))))
sem_Expr_App :: (T_Expr) ->
                (T_Expr) ->
                (T_Expr)
sem_Expr_App (_func) (_arg) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                App _func_self _arg_self
            (_ermsg) =
                typeError_App
                      _func_self
                      _self
                      _func_retTy
                      _func_inferty
            (_new_tyvar) =
                mk_freshTyVar $ _lhs_freshTyVarName
            (_freshTyVarName_) =
                _lhs_freshTyVarName + 1
            (_funarg_ty) =
                fst . dest_FunTy $ _func_retTy
            (_funret_ty) =
                snd . dest_FunTy $ _func_retTy
            (_func_inferty) =
                _arg_retTy ->> _new_tyvar
            (_co1) =
                (_funarg_ty <==> _arg_retTy) _ermsg
            (_co2) =
                (_func_retTy <==> _func_inferty) _ermsg
            ( _func_cl,_func_freshTyVarName,_func_new,_func_postTypeErrors,_func_retTy,_func_self) =
                (_func (_freshTyVarName_) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
            ( _arg_cl,_arg_freshTyVarName,_arg_new,_arg_postTypeErrors,_arg_retTy,_arg_self) =
                (_arg (_func_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( if is_FunTy _func_retTy
              then _func_cl ++ _arg_cl ++ [_co1]
              else _func_cl ++ _arg_cl ++ [_co2]
             ,_arg_freshTyVarName
             ,App
                    _func_new
                    _arg_new
             ,_func_postTypeErrors
              ++ _arg_postTypeErrors
             ,if is_FunTy _func_retTy
              then _funret_ty
              else _new_tyvar
             ,_self
             )
sem_Expr_ArrayApp :: (Pos) ->
                     (T_Expr) ->
                     (T_Expr) ->
                     (T_Expr)
sem_Expr_ArrayApp (_pos) (_array) (_element) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                ArrayApp _pos _array_self _element_self
            (_ermsg_a) =
                typeError_ArrayApp
                      _array_self
                      _self
                      _array_retTy
                      _array_inferty
            (_ermsg_i) =
                typeError_notInt
                      _element_self
                      _element_retTy
            (_new_tyvar) =
                mk_freshTyVar $ _lhs_freshTyVarName
            (_freshTyVarName_) =
                _lhs_freshTyVarName + 1
            (_array_el_ty) =
                get_ArrayElTy _array_retTy
            (_array_inferty) =
                mk_ArrayTy _new_tyvar
            (_co_a) =
                (_array_retTy <==> _array_inferty) _ermsg_a
            (_co_i) =
                (_element_retTy <==> intTy) _ermsg_i
            ( _array_cl,_array_freshTyVarName,_array_new,_array_postTypeErrors,_array_retTy,_array_self) =
                (_array (_freshTyVarName_) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
            ( _element_cl,_element_freshTyVarName,_element_new,_element_postTypeErrors,_element_retTy,_element_self) =
                (_element (_array_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( if is_ArrayTy _array_retTy
              then _array_cl ++ _element_cl ++ [_co_i]
              else _array_cl ++ _element_cl ++ [_co_a,_co_i]
             ,_element_freshTyVarName
             ,ArrayApp
                    _pos
                    _array_new
                    _element_new
             ,_array_postTypeErrors
              ++ _element_postTypeErrors
             ,if is_ArrayTy _array_retTy
              then _array_el_ty
              else _new_tyvar
             ,_self
             )
sem_Expr_ArrayUpdate :: (T_Expr) ->
                        (T_ExprList) ->
                        (T_Expr) ->
                        (T_Expr)
sem_Expr_ArrayUpdate (_target) (_at) (_with) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                ArrayUpdate _target_self _at_self _with_self
            ( _target_cl,_target_freshTyVarName,_target_new,_target_postTypeErrors,_target_retTy,_target_self) =
                (_target (_lhs_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
            ( _at_cl,_at_freshTyVarName,_at_new,_at_postTypeErrors,_at_retTys,_at_self) =
                (_at (_target_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
            ( _with_cl,_with_freshTyVarName,_with_new,_with_postTypeErrors,_with_retTy,_with_self) =
                (_with (_at_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( _with_cl,_with_freshTyVarName,_with_new,_with_postTypeErrors,_with_retTy,_self)
sem_Expr_Binary :: (T_Ident) ->
                   (T_Expr) ->
                   (T_Expr) ->
                   (T_Expr)
sem_Expr_Binary (_op) (_arg1) (_arg2) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                Binary _op_self _arg1_self _arg2_self
            (_lookup_) =
                freshInstantiateTy _lhs_freshTyVarName
                . lookUP _op_name
                $ _lhs_vcx
            (_op_ty) =
                snd _lookup_
            (_op_ty_) =
                dest_Fun2Ty _op_ty
            (_arg1_ty_) =
                pj_1_3 _op_ty_
            (_arg2_ty_) =
                pj_2_3 _op_ty_
            (_op_retty_) =
                pj_3_3 _op_ty_
            (_freshTyVarName_) =
                fst _lookup_
            (_new_tyvar) =
                mk_freshTyVar $ _freshTyVarName_
            (_op_inferty) =
                _arg1_retTy ->> _arg2_retTy ->> _new_tyvar
            (_ermsg0) =
                typeError
                      _op_self
                      _self
                      _op_ty
                      _op_inferty
                      (text "Also possible: operator's type specififation is incorrect.")
            (_ermsg1) =
                typeError_BinaryL
                      _op_self
                      _self
                      _op_ty
                      _op_inferty
            (_ermsg2) =
                typeError_BinaryR
                      _op_self
                      _self
                      _op_ty
                      _op_inferty
            (_co0) =
                (_op_ty <==> _op_inferty) _ermsg0
            (_co1) =
                (_arg1_ty_ <==> _arg1_retTy) _ermsg1
            (_co2) =
                (_arg2_ty_ <==> _arg2_retTy) _ermsg2
            ( _op_name,_op_new,_op_self) =
                (_op (_op_ty) (_lhs_lvars) (_lhs_tySubst))
            ( _arg1_cl,_arg1_freshTyVarName,_arg1_new,_arg1_postTypeErrors,_arg1_retTy,_arg1_self) =
                (_arg1 (_freshTyVarName_ + 1) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
            ( _arg2_cl,_arg2_freshTyVarName,_arg2_new,_arg2_postTypeErrors,_arg2_retTy,_arg2_self) =
                (_arg2 (_arg1_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( if is_Fun2Ty _op_ty
              then _arg1_cl ++ _arg2_cl ++ [_co1,_co2]
              else _arg1_cl ++ _arg2_cl ++ [_co0]
             ,_arg2_freshTyVarName
             ,Binary
                    _op_new
                    _arg1_new
                    _arg2_new
             ,_arg1_postTypeErrors
              ++ _arg2_postTypeErrors
             ,if is_Fun2Ty _op_ty
              then _op_retty_
              else _new_tyvar
             ,_self
             )
sem_Expr_Cond :: (Pos) ->
                 (T_Expr) ->
                 (T_Expr) ->
                 (T_Expr) ->
                 (T_Expr)
sem_Expr_Cond (_pos) (_guard) (_val1) (_val2) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                Cond _pos _guard_self _val1_self _val2_self
            (_ermsg1) =
                typeError_notBool _guard_self _guard_retTy
            (_ermsg2) =
                typeError_thenelse
                      _val1_self
                      _self
                      _val1_retTy
                      _val2_retTy
            (_co1) =
                (_guard_retTy <==> boolTy) _ermsg1
            (_co2) =
                (_val1_retTy <==> _val2_retTy) _ermsg2
            ( _guard_cl,_guard_freshTyVarName,_guard_new,_guard_postTypeErrors,_guard_retTy,_guard_self) =
                (_guard (_lhs_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
            ( _val1_cl,_val1_freshTyVarName,_val1_new,_val1_postTypeErrors,_val1_retTy,_val1_self) =
                (_val1 (_guard_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
            ( _val2_cl,_val2_freshTyVarName,_val2_new,_val2_postTypeErrors,_val2_retTy,_val2_self) =
                (_val2 (_val1_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( _guard_cl
              ++ _val1_cl
              ++ _val2_cl
              ++ [_co1,_co2]
             ,_val2_freshTyVarName
             ,Cond
                    _pos
                    _guard_new
                    _val1_new
                    _val2_new
             ,_guard_postTypeErrors
              ++ _val1_postTypeErrors
              ++ _val2_postTypeErrors
             ,_val1_retTy
             ,_self
             )
sem_Expr_FromTo :: (Pos) ->
                   (T_Expr) ->
                   (T_Expr) ->
                   (T_Expr) ->
                   (T_Expr)
sem_Expr_FromTo (_pos) (_ranger) (_left) (_right) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                FromTo _pos _ranger_self _left_self _right_self
            (_errmsg_ranger) =
                typeError_FromTo
                      _ranger_self
                      _self
                      _ranger_retTy
                      intTy
            (_errmsg_le) =
                typeError_notInt
                      _left_self
                      _left_retTy
            (_errmsg_ri) =
                typeError_notInt
                      _right_self
                      _right_retTy
            (_new_tyvar) =
                mk_freshTyVar $ _lhs_freshTyVarName
            (_freshTyVarName_) =
                _lhs_freshTyVarName + 1
            (_infer_ty) =
                if is_IntTy _ranger_retTy
                then boolTy
                else if is_ArrayTy _ranger_retTy
                then mk_ListTy (get_ArrayElTy _ranger_retTy)
                else _new_tyvar
            (_co_le) =
                (_left_retTy  <==> intTy) _errmsg_le
            (_co_ri) =
                (_right_retTy <==> intTy) _errmsg_ri
            (_co_ranger) =
                if (is_IntTy _ranger_retTy
                    ||
                    is_ArrayTy _ranger_retTy)
                then []
                else [(_ranger_retTy <==> intTy) _errmsg_ranger]
            ( _ranger_cl,_ranger_freshTyVarName,_ranger_new,_ranger_postTypeErrors,_ranger_retTy,_ranger_self) =
                (_ranger (_freshTyVarName_) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
            ( _left_cl,_left_freshTyVarName,_left_new,_left_postTypeErrors,_left_retTy,_left_self) =
                (_left (_ranger_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
            ( _right_cl,_right_freshTyVarName,_right_new,_right_postTypeErrors,_right_retTy,_right_self) =
                (_right (_left_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( _ranger_cl
              ++ _left_cl
              ++ _right_cl
              ++ _co_ranger
              ++ [_co_le,_co_ri]
             ,_right_freshTyVarName
             ,FromTo
                    _pos
                    _ranger_self
                    _left_self
                    _right_self
             ,_ranger_postTypeErrors
              ++ _left_postTypeErrors
              ++ _right_postTypeErrors
             ,_infer_ty
             ,_self
             )
sem_Expr_Ident :: (T_Ident) ->
                  (T_Expr)
sem_Expr_Ident (_ident) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                Ident _ident_self
            (_revName) =
                reverse _ident_name
            (_realname) =
                if (_ident_name `elem` _lhs_lvars)
                   ||
                   ("0__" /= take 3 _revName)
                then _ident_name
                else reverse (drop 3 _revName)
            (_lookup_) =
                freshInstantiateTy _lhs_freshTyVarName
                . lookUP _realname
                $ _lhs_vcx
            (_retTy) =
                snd _lookup_
            ( _ident_name,_ident_new,_ident_self) =
                (_ident (_retTy) (_lhs_lvars) (_lhs_tySubst))
        in  ( [],fst _lookup_,Ident _ident_new,[],_retTy,_self)
sem_Expr_List :: (Pos) ->
                 (T_ExprList) ->
                 (T_Expr)
sem_Expr_List (_pos) (_exprlist) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                List _pos _exprlist_self
            (_mk_errmsg_elem) =
                (\(element,el_ty) -> typeError_ListElement
                      element
                      _self
                      el_ty
                      _el_inferty)
            (_new_tyvar) =
                mk_freshTyVar $ _lhs_freshTyVarName
            (_freshTyVarName_) =
                _lhs_freshTyVarName + 1
            (_el_inferty) =
                if null _exprlist_retTys
                then _new_tyvar
                else head _exprlist_retTys
            (_list_inferty) =
                mk_ListTy _el_inferty
            (_mk_co_elem) =
                (\(element,el_ty) ->
                      (el_ty <==> _el_inferty)
                      (_mk_errmsg_elem (element,el_ty)))
            (_cl_elems) =
                map _mk_co_elem (zip _exprlist_self _exprlist_retTys)
            ( _exprlist_cl,_exprlist_freshTyVarName,_exprlist_new,_exprlist_postTypeErrors,_exprlist_retTys,_exprlist_self) =
                (_exprlist (_freshTyVarName_) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( _exprlist_cl  ++ _cl_elems
             ,_exprlist_freshTyVarName
             ,List
                    _pos
                    _exprlist_new
             ,_exprlist_postTypeErrors
             ,_list_inferty
             ,_self
             )
sem_Expr_Lit :: (T_Literal) ->
                (T_Expr)
sem_Expr_Lit (_value) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                Lit _value_self
            ( _value_retTy,_value_self) =
                (_value )
        in  ( [],_lhs_freshTyVarName,Lit _value_self,[],_value_retTy,_self)
sem_Expr_Marker :: (T_Marker) ->
                   (T_Expr) ->
                   (T_Expr)
sem_Expr_Marker (_marker) (_expr) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                Marker _marker_self _expr_self
            ( _marker_self) =
                (_marker )
            ( _expr_cl,_expr_freshTyVarName,_expr_new,_expr_postTypeErrors,_expr_retTy,_expr_self) =
                (_expr (_lhs_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( _expr_cl,_expr_freshTyVarName,_expr_new,_expr_postTypeErrors,_expr_retTy,_self)
sem_Expr_Quantor :: (T_Ident) ->
                    (T_IdentList) ->
                    (T_Expr) ->
                    (T_Expr) ->
                    (T_Expr)
sem_Expr_Quantor (_op) (_varl) (_domain) (_body) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                Quantor _op_self _varl_self _domain_self _body_self
            (_lookup_) =
                freshInstantiateTy _lhs_freshTyVarName
                . lookUP _op_name
                $ _lhs_vcx
            (_quant_ty) =
                snd _lookup_
            (_quant_ty_) =
                dest_FunTy _quant_ty
            (_body_ty_) =
                fst _quant_ty_
            (_quant_retty_) =
                snd _quant_ty_
            (_freshTyVarName_) =
                fst _lookup_
            (_new_tyvars) =
                map (FlatTy . mk_freshTyVar) [_freshTyVarName_ ..]
            (_vcx_updates) =
                zip _varl_names _new_tyvars
            (_freshTyVarName__) =
                _freshTyVarName_ + length _varl_names
            (_new_tyvar) =
                mk_freshTyVar _freshTyVarName__
            (_quant_inferty) =
                _body_retTy ->> _new_tyvar
            (_vcx) =
                updateContext _vcx_updates _lhs_vcx
            (_ermsg_dom) =
                typeError_notBool _domain_self _domain_retTy
            (_ermsg_body) =
                typeError _body_self _self _body_ty_ _body_retTy empty
            (_ermsg_quant) =
                typeError
                      _op_self
                      _self
                      _quant_ty
                      _quant_inferty
                      (text "Also possible: quantor's type specififation is incorrect.")
            (_co_dom) =
                (_domain_retTy <==> boolTy) _ermsg_dom
            (_co_body) =
                (_body_ty_ <==> _body_retTy) _ermsg_body
            (_co_quant) =
                (_quant_ty <==> _quant_inferty) _ermsg_quant
            (_lvars) =
                _varl_names ++ _lhs_lvars
            ( _op_name,_op_new,_op_self) =
                (_op (_quant_ty) (_lvars) (_lhs_tySubst))
            ( _varl_names,_varl_new,_varl_self) =
                (_varl (map (fromTypeScheme . snd) _vcx_updates) (_lvars) (_lhs_tySubst))
            ( _domain_cl,_domain_freshTyVarName,_domain_new,_domain_postTypeErrors,_domain_retTy,_domain_self) =
                (_domain (_freshTyVarName__ + 1) (_lvars) (_lhs_tySubst) (_vcx))
            ( _body_cl,_body_freshTyVarName,_body_new,_body_postTypeErrors,_body_retTy,_body_self) =
                (_body (_domain_freshTyVarName) (_lvars) (_lhs_tySubst) (_vcx))
        in  ( if is_FunTy _quant_ty
              then _domain_cl ++ _body_cl ++ [_co_dom,_co_body]
              else _domain_cl ++ _body_cl ++ [_co_quant,_co_dom]
             ,_body_freshTyVarName
             ,Quantor
                    _op_new
                    _varl_new
                    _domain_new
                    _body_new
             ,_domain_postTypeErrors
              ++ _body_postTypeErrors
             ,if is_FunTy _quant_ty
              then _quant_retty_
              else _new_tyvar
             ,_self
             )
sem_Expr_Record :: (Pos) ->
                   (T_FieldAssignmentList) ->
                   (T_Expr)
sem_Expr_Record (_pos) (_fields) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                Record _pos _fields_self
            (_record_inferty) =
                mk_RecordTy (zip _fields_fieldNames _fields_retTys)
            ( _fields_cl,_fields_fieldNames,_fields_freshTyVarName,_fields_new,_fields_postTypeErrors,_fields_retTys,_fields_self) =
                (_fields (_lhs_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( _fields_cl
             ,_fields_freshTyVarName
             ,Record
                    _pos
                    _fields_new
             ,_fields_postTypeErrors
             ,_record_inferty
             ,_self
             )
sem_Expr_RecordApp :: (Pos) ->
                      (T_Expr) ->
                      (String) ->
                      (T_Expr)
sem_Expr_RecordApp (_pos) (_record) (_field) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                RecordApp _pos _record_self _field
            (_ermsg_r) =
                typeError_Record
                      _record_self
                      _self
                      _record_retTy
                      _record_inferty
            (_new_tyvar) =
                mk_freshTyVar $ _lhs_freshTyVarName
            (_freshTyVarName_) =
                _lhs_freshTyVarName + 1
            (_record_inferty) =
                if is_RecordTy _record_retTy
                then construct_inferRecTy
                              _record_retTy
                              _field
                              _new_tyvar
                else if is_TyVar _record_retTy
                then _record_retTy
                else mk_RecordTy [(_field,_new_tyvar)]
            (_co) =
                (_record_retTy <==> _record_inferty) _ermsg_r
            (_retTy) =
                _new_tyvar
            (_final_recTy) =
                _lhs_tySubst _record_retTy
            (_final_inferRecTy) =
                _lhs_tySubst _record_inferty
            (_final_fieldTy) =
                case lookup _field (dest_RecordTy _final_recTy) of
                Just ty  -> ty
            (_final_inferFieldTy) =
                _lhs_tySubst _retTy
            (_errMsg_f_) =
                typeError_Record_2
                      _self
                      _final_fieldTy
                      _final_inferFieldTy
            (_errMsg_f) =
                if (not (is_RecordTy _final_recTy)
                    ||
                    ((_final_recTy == _final_inferRecTy)
                     &&
                     (_final_fieldTy == _final_inferFieldTy)))
                then []
                else [ _errMsg_f_ ]
            ( _record_cl,_record_freshTyVarName,_record_new,_record_postTypeErrors,_record_retTy,_record_self) =
                (_record (_freshTyVarName_) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( if is_TyVar _record_retTy
              then _record_cl
              else _record_cl ++ [_co]
             ,_record_freshTyVarName
             ,RecordApp
                    _pos
                    _record_new
                    _field
             ,_record_postTypeErrors ++ _errMsg_f
             ,_retTy
             ,_self
             )
sem_Expr_RecordUpdate :: (T_Expr) ->
                         (StringList) ->
                         (T_Expr) ->
                         (Type) ->
                         (T_Expr)
sem_Expr_RecordUpdate (_target) (_at) (_with) (_ty) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                RecordUpdate _target_self _at _with_self _ty
            ( _target_cl,_target_freshTyVarName,_target_new,_target_postTypeErrors,_target_retTy,_target_self) =
                (_target (_lhs_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
            ( _with_cl,_with_freshTyVarName,_with_new,_with_postTypeErrors,_with_retTy,_with_self) =
                (_with (_target_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( _with_cl,_with_freshTyVarName,_with_new,_with_postTypeErrors,_with_retTy,_self)
sem_Expr_SQLSelect :: (Pos) ->
                      (T_ListGeneratorList) ->
                      (T_Expr) ->
                      (T_Expr) ->
                      (T_Expr)
sem_Expr_SQLSelect (_pos) (_generators) (_filter) (_map) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                SQLSelect _pos _generators_self _filter_self _map_self
            (_new_tyvars) =
                map mk_freshTyVar [_lhs_freshTyVarName ..]
            (_vcx_updates) =
                zip _generators_bvars (map FlatTy _new_tyvars)
            (_freshTyVarName_) =
                _lhs_freshTyVarName + length _generators_bvars
            (_vcx) =
                updateContext _vcx_updates _lhs_vcx
            (_ermsg_filter) =
                typeError_notBool _filter_self _filter_retTy
            (_co_filter) =
                (_filter_retTy <==> boolTy) _ermsg_filter
            (_lvars) =
                _generators_bvars ++ _lhs_lvars
            ( _generators_bvars,_generators_cl,_generators_freshTyVarName,_generators_new,_generators_postTypeErrors,_generators_retTys,_generators_self) =
                (_generators (_freshTyVarName_) (map (fromTypeScheme . snd) _vcx_updates) (_lvars) (_lhs_tySubst) (_vcx))
            ( _filter_cl,_filter_freshTyVarName,_filter_new,_filter_postTypeErrors,_filter_retTy,_filter_self) =
                (_filter (_generators_freshTyVarName) (_lvars) (_lhs_tySubst) (_vcx))
            ( _map_cl,_map_freshTyVarName,_map_new,_map_postTypeErrors,_map_retTy,_map_self) =
                (_map (_filter_freshTyVarName) (_lvars) (_lhs_tySubst) (_vcx))
        in  ( _map_cl
              ++ _generators_cl
              ++ _filter_cl
              ++ [_co_filter]
             ,_map_freshTyVarName
             ,SQLSelect
                    _pos
                    _generators_new
                    _filter_new
                    _map_new
             ,_generators_postTypeErrors
              ++ _filter_postTypeErrors
              ++ _map_postTypeErrors
             ,mk_ListTy _map_retTy
             ,_self
             )
sem_Expr_Unary :: (T_Ident) ->
                  (T_Expr) ->
                  (T_Expr)
sem_Expr_Unary (_op) (_arg) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                Unary _op_self _arg_self
            (_lookup_) =
                freshInstantiateTy _lhs_freshTyVarName
                . lookUP _op_name
                $ _lhs_vcx
            (_op_ty) =
                snd _lookup_
            (_op_ty_) =
                dest_FunTy _op_ty
            (_arg_ty_) =
                fst _op_ty_
            (_op_retty_) =
                snd _op_ty_
            (_freshTyVarName_) =
                fst _lookup_
            (_new_tyvar) =
                mk_freshTyVar $ _freshTyVarName_
            (_op_inferty) =
                _arg_retTy ->> _new_tyvar
            (_ermsg0) =
                typeError
                      _op_self
                      _self
                      _op_ty
                      _op_inferty
                      (text "Also possible: operator's type specififation is incorrect.")
            (_ermsg1) =
                typeError
                      _op_self
                      _self
                      _op_ty
                      _op_inferty
                      (text "Perhaps the operator is applied to an argument of a wrong type.")
            (_co0) =
                (_op_ty <==> _op_inferty) _ermsg0
            (_co1) =
                (_arg_ty_ <==> _arg_retTy) _ermsg1
            ( _op_name,_op_new,_op_self) =
                (_op (_op_ty) (_lhs_lvars) (_lhs_tySubst))
            ( _arg_cl,_arg_freshTyVarName,_arg_new,_arg_postTypeErrors,_arg_retTy,_arg_self) =
                (_arg (_freshTyVarName_ + 1) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( if is_FunTy _op_ty
              then _arg_cl ++ [_co1]
              else _arg_cl ++ [_co0]
             ,_arg_freshTyVarName
             ,Unary
                    _op_new
                    _arg_new
             ,_arg_postTypeErrors
             ,if is_FunTy _op_ty
              then _op_retty_
              else _new_tyvar
             ,_self
             )
-- ExprList ----------------------------------------------------
{-
   inherited attributes:
      lvars                : StringList
      tySubst              : TypeSubstitutionFunction
      vcx                  : IdentContext

   chained attributes:
      freshTyVarName       : Int

   synthesised attributes:
      cl                   : Constraint__List
      new                  : ExprList
      postTypeErrors       : TypeConstraintErrorList
      retTys               : TypeList
      self                 : SELF

-}
{-
   local variables for ExprList.Cons:
      self

-}
{-
   local variables for ExprList.Nil:
      self

-}
-- semantic domain
type T_ExprList = (Int) ->
                  (StringList) ->
                  (TypeSubstitutionFunction) ->
                  (IdentContext) ->
                  ( (Constraint__List),(Int),(ExprList),(TypeConstraintErrorList),(TypeList),(ExprList))
-- cata
sem_ExprList :: (ExprList) ->
                (T_ExprList)
sem_ExprList (list) =
    (foldr (sem_ExprList_Cons) (sem_ExprList_Nil) ((map sem_Expr list)))
sem_ExprList_Cons :: (T_Expr) ->
                     (T_ExprList) ->
                     (T_ExprList)
sem_ExprList_Cons (_hd) (_tl) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                (:) _hd_self _tl_self
            ( _hd_cl,_hd_freshTyVarName,_hd_new,_hd_postTypeErrors,_hd_retTy,_hd_self) =
                (_hd (_lhs_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
            ( _tl_cl,_tl_freshTyVarName,_tl_new,_tl_postTypeErrors,_tl_retTys,_tl_self) =
                (_tl (_hd_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( _hd_cl ++ _tl_cl,_tl_freshTyVarName,_hd_new : _tl_new,_hd_postTypeErrors ++ _tl_postTypeErrors,_hd_retTy : _tl_retTys,_self)
sem_ExprList_Nil :: (T_ExprList)
sem_ExprList_Nil  =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                []
        in  ( [],_lhs_freshTyVarName,[],[],[],_self)
-- FieldAssignment ---------------------------------------------
{-
   inherited attributes:
      lvars                : StringList
      tySubst              : TypeSubstitutionFunction
      vcx                  : IdentContext

   chained attributes:
      freshTyVarName       : Int

   synthesised attributes:
      cl                   : Constraint__List
      field                : String
      new                  : FieldAssignment
      postTypeErrors       : TypeConstraintErrorList
      retTy                : Type
      self                 : SELF

-}
{-
   local variables for FieldAssignment.FieldAssignment:
      self

-}
-- semantic domain
type T_FieldAssignment = (Int) ->
                         (StringList) ->
                         (TypeSubstitutionFunction) ->
                         (IdentContext) ->
                         ( (Constraint__List),(String),(Int),(FieldAssignment),(TypeConstraintErrorList),(Type),(FieldAssignment))
-- cata
sem_FieldAssignment :: (FieldAssignment) ->
                       (T_FieldAssignment)
sem_FieldAssignment ((FieldAssignment (_pos) (_field) (_value))) =
    (sem_FieldAssignment_FieldAssignment (_pos) (_field) ((sem_Expr (_value))))
sem_FieldAssignment_FieldAssignment :: (Pos) ->
                                       (String) ->
                                       (T_Expr) ->
                                       (T_FieldAssignment)
sem_FieldAssignment_FieldAssignment (_pos) (_field) (_value) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                FieldAssignment _pos _field _value_self
            ( _value_cl,_value_freshTyVarName,_value_new,_value_postTypeErrors,_value_retTy,_value_self) =
                (_value (_lhs_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( _value_cl
             ,_field
             ,_value_freshTyVarName
             ,FieldAssignment
                    _pos
                    _field
                    _value_new
             ,_value_postTypeErrors
             ,_value_retTy
             ,_self
             )
-- FieldAssignmentList -----------------------------------------
{-
   inherited attributes:
      lvars                : StringList
      tySubst              : TypeSubstitutionFunction
      vcx                  : IdentContext

   chained attributes:
      freshTyVarName       : Int

   synthesised attributes:
      cl                   : Constraint__List
      fieldNames           : StringList
      new                  : FieldAssignmentList
      postTypeErrors       : TypeConstraintErrorList
      retTys               : TypeList
      self                 : SELF

-}
{-
   local variables for FieldAssignmentList.Cons:
      self

-}
{-
   local variables for FieldAssignmentList.Nil:
      self

-}
-- semantic domain
type T_FieldAssignmentList = (Int) ->
                             (StringList) ->
                             (TypeSubstitutionFunction) ->
                             (IdentContext) ->
                             ( (Constraint__List),(StringList),(Int),(FieldAssignmentList),(TypeConstraintErrorList),(TypeList),(FieldAssignmentList))
-- cata
sem_FieldAssignmentList :: (FieldAssignmentList) ->
                           (T_FieldAssignmentList)
sem_FieldAssignmentList (list) =
    (foldr (sem_FieldAssignmentList_Cons) (sem_FieldAssignmentList_Nil) ((map sem_FieldAssignment list)))
sem_FieldAssignmentList_Cons :: (T_FieldAssignment) ->
                                (T_FieldAssignmentList) ->
                                (T_FieldAssignmentList)
sem_FieldAssignmentList_Cons (_hd) (_tl) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                (:) _hd_self _tl_self
            ( _hd_cl,_hd_field,_hd_freshTyVarName,_hd_new,_hd_postTypeErrors,_hd_retTy,_hd_self) =
                (_hd (_lhs_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
            ( _tl_cl,_tl_fieldNames,_tl_freshTyVarName,_tl_new,_tl_postTypeErrors,_tl_retTys,_tl_self) =
                (_tl (_hd_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( _hd_cl ++ _tl_cl,_hd_field : _tl_fieldNames,_tl_freshTyVarName,_hd_new : _tl_new,_hd_postTypeErrors ++ _tl_postTypeErrors,_hd_retTy : _tl_retTys,_self)
sem_FieldAssignmentList_Nil :: (T_FieldAssignmentList)
sem_FieldAssignmentList_Nil  =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                []
        in  ( [],[],_lhs_freshTyVarName,[],[],[],_self)
-- Ident -------------------------------------------------------
{-
   inherited attributes:
      guessedTy            : Type
      lvars                : StringList
      tySubst              : TypeSubstitutionFunction

   chained attributes:

   synthesised attributes:
      name                 : String
      new                  : Ident
      self                 : SELF

-}
{-
   local variables for Ident.Identifier:
      the_status
      guessedTy
      self

-}
-- semantic domain
type T_Ident = (Type) ->
               (StringList) ->
               (TypeSubstitutionFunction) ->
               ( (String),(Ident),(Ident))
-- cata
sem_Ident :: (Ident) ->
             (T_Ident)
sem_Ident ((Identifier (_name) (_status) (_ty) (_pos))) =
    (sem_Ident_Identifier (_name) ((sem_IdentStatus (_status))) (_ty) (_pos))
sem_Ident_Identifier :: (String) ->
                        (T_IdentStatus) ->
                        (Type) ->
                        (Pos) ->
                        (T_Ident)
sem_Ident_Identifier (_name) (_status) (_ty) (_pos) =
    \ _lhs_guessedTy
      _lhs_lvars
      _lhs_tySubst ->
        let (_self) =
                Identifier _name _status_self _ty _pos
            (_guessedTy) =
                _lhs_tySubst _lhs_guessedTy
            (_the_status) =
                if _name `elem` _lhs_lvars
                then LogicIdent
                else ProgramVar
            ( _status_self) =
                (_status )
        in  ( _name
             ,Identifier
                    _name
                    _the_status
                    _guessedTy
                    _pos
             ,_self
             )
-- IdentList ---------------------------------------------------
{-
   inherited attributes:
      guessedTys           : TypeList
      lvars                : StringList
      tySubst              : TypeSubstitutionFunction

   chained attributes:

   synthesised attributes:
      names                : StringList
      new                  : IdentList
      self                 : SELF

-}
{-
   local variables for IdentList.Cons:
      self

-}
{-
   local variables for IdentList.Nil:
      self

-}
-- semantic domain
type T_IdentList = (TypeList) ->
                   (StringList) ->
                   (TypeSubstitutionFunction) ->
                   ( (StringList),(IdentList),(IdentList))
-- cata
sem_IdentList :: (IdentList) ->
                 (T_IdentList)
sem_IdentList (list) =
    (foldr (sem_IdentList_Cons) (sem_IdentList_Nil) ((map sem_Ident list)))
sem_IdentList_Cons :: (T_Ident) ->
                      (T_IdentList) ->
                      (T_IdentList)
sem_IdentList_Cons (_hd) (_tl) =
    \ _lhs_guessedTys
      _lhs_lvars
      _lhs_tySubst ->
        let (_self) =
                (:) _hd_self _tl_self
            ( _hd_name,_hd_new,_hd_self) =
                (_hd (head _lhs_guessedTys) (_lhs_lvars) (_lhs_tySubst))
            ( _tl_names,_tl_new,_tl_self) =
                (_tl (tail _lhs_guessedTys) (_lhs_lvars) (_lhs_tySubst))
        in  ( _hd_name : _tl_names,_hd_new : _tl_new,_self)
sem_IdentList_Nil :: (T_IdentList)
sem_IdentList_Nil  =
    \ _lhs_guessedTys
      _lhs_lvars
      _lhs_tySubst ->
        let (_self) =
                []
        in  ( [],[],_self)
-- IdentStatus -------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for IdentStatus.LogicIdent:
      self

-}
{-
   local variables for IdentStatus.ProgramVar:
      self

-}
{-
   local variables for IdentStatus.UnknownIdentStatus:
      self

-}
-- semantic domain
type T_IdentStatus = ( (IdentStatus))
-- cata
sem_IdentStatus :: (IdentStatus) ->
                   (T_IdentStatus)
sem_IdentStatus ((LogicIdent )) =
    (sem_IdentStatus_LogicIdent )
sem_IdentStatus ((ProgramVar )) =
    (sem_IdentStatus_ProgramVar )
sem_IdentStatus ((UnknownIdentStatus )) =
    (sem_IdentStatus_UnknownIdentStatus )
sem_IdentStatus_LogicIdent :: (T_IdentStatus)
sem_IdentStatus_LogicIdent  =
    let (_self) =
            LogicIdent
    in  ( _self)
sem_IdentStatus_ProgramVar :: (T_IdentStatus)
sem_IdentStatus_ProgramVar  =
    let (_self) =
            ProgramVar
    in  ( _self)
sem_IdentStatus_UnknownIdentStatus :: (T_IdentStatus)
sem_IdentStatus_UnknownIdentStatus  =
    let (_self) =
            UnknownIdentStatus
    in  ( _self)
-- ListGenerator -----------------------------------------------
{-
   inherited attributes:
      guessedBvarTy        : Type
      lvars                : StringList
      tySubst              : TypeSubstitutionFunction
      vcx                  : IdentContext

   chained attributes:
      freshTyVarName       : Int

   synthesised attributes:
      bvar                 : String
      cl                   : Constraint__List
      new                  : ListGenerator
      postTypeErrors       : TypeConstraintErrorList
      retTy                : Type
      self                 : SELF

-}
{-
   local variables for ListGenerator.ListGenerator:
      co
      errmsg
      gen_inferty
      bvar_ty
      self

-}
-- semantic domain
type T_ListGenerator = (Int) ->
                       (Type) ->
                       (StringList) ->
                       (TypeSubstitutionFunction) ->
                       (IdentContext) ->
                       ( (String),(Constraint__List),(Int),(ListGenerator),(TypeConstraintErrorList),(Type),(ListGenerator))
-- cata
sem_ListGenerator :: (ListGenerator) ->
                     (T_ListGenerator)
sem_ListGenerator ((ListGenerator (_pos) (_bvar) (_gen))) =
    (sem_ListGenerator_ListGenerator (_pos) ((sem_Ident (_bvar))) ((sem_Expr (_gen))))
sem_ListGenerator_ListGenerator :: (Pos) ->
                                   (T_Ident) ->
                                   (T_Expr) ->
                                   (T_ListGenerator)
sem_ListGenerator_ListGenerator (_pos) (_bvar) (_gen) =
    \ _lhs_freshTyVarName
      _lhs_guessedBvarTy
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                ListGenerator _pos _bvar_self _gen_self
            (_bvar_ty) =
                case lookup _bvar_name _lhs_vcx of
                Just (FlatTy ty) -> ty
            (_gen_inferty) =
                mk_ListTy _bvar_ty
            (_errmsg) =
                typeError_Generator
                              _self
                              _gen_retTy
                              _gen_inferty
            (_co) =
                (_gen_retTy <==> _gen_inferty) _errmsg
            ( _bvar_name,_bvar_new,_bvar_self) =
                (_bvar (_lhs_guessedBvarTy) (_lhs_lvars) (_lhs_tySubst))
            ( _gen_cl,_gen_freshTyVarName,_gen_new,_gen_postTypeErrors,_gen_retTy,_gen_self) =
                (_gen (_lhs_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( _bvar_name
             ,_gen_cl ++ [_co]
             ,_gen_freshTyVarName
             ,ListGenerator
                    _pos
                    _bvar_new
                    _gen_new
             ,_gen_postTypeErrors
             ,_gen_retTy
             ,_self
             )
-- ListGeneratorList -------------------------------------------
{-
   inherited attributes:
      guessedBvarTys       : TypeList
      lvars                : StringList
      tySubst              : TypeSubstitutionFunction
      vcx                  : IdentContext

   chained attributes:
      freshTyVarName       : Int

   synthesised attributes:
      bvars                : StringList
      cl                   : Constraint__List
      new                  : ListGeneratorList
      postTypeErrors       : TypeConstraintErrorList
      retTys               : TypeList
      self                 : SELF

-}
{-
   local variables for ListGeneratorList.Cons:
      self

-}
{-
   local variables for ListGeneratorList.Nil:
      self

-}
-- semantic domain
type T_ListGeneratorList = (Int) ->
                           (TypeList) ->
                           (StringList) ->
                           (TypeSubstitutionFunction) ->
                           (IdentContext) ->
                           ( (StringList),(Constraint__List),(Int),(ListGeneratorList),(TypeConstraintErrorList),(TypeList),(ListGeneratorList))
-- cata
sem_ListGeneratorList :: (ListGeneratorList) ->
                         (T_ListGeneratorList)
sem_ListGeneratorList (list) =
    (foldr (sem_ListGeneratorList_Cons) (sem_ListGeneratorList_Nil) ((map sem_ListGenerator list)))
sem_ListGeneratorList_Cons :: (T_ListGenerator) ->
                              (T_ListGeneratorList) ->
                              (T_ListGeneratorList)
sem_ListGeneratorList_Cons (_hd) (_tl) =
    \ _lhs_freshTyVarName
      _lhs_guessedBvarTys
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                (:) _hd_self _tl_self
            ( _hd_bvar,_hd_cl,_hd_freshTyVarName,_hd_new,_hd_postTypeErrors,_hd_retTy,_hd_self) =
                (_hd (_lhs_freshTyVarName) (head _lhs_guessedBvarTys) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
            ( _tl_bvars,_tl_cl,_tl_freshTyVarName,_tl_new,_tl_postTypeErrors,_tl_retTys,_tl_self) =
                (_tl (_hd_freshTyVarName) (tail _lhs_guessedBvarTys) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( _hd_bvar : _tl_bvars,_hd_cl ++ _tl_cl,_tl_freshTyVarName,_hd_new : _tl_new,_hd_postTypeErrors ++ _tl_postTypeErrors,_hd_retTy : _tl_retTys,_self)
sem_ListGeneratorList_Nil :: (T_ListGeneratorList)
sem_ListGeneratorList_Nil  =
    \ _lhs_freshTyVarName
      _lhs_guessedBvarTys
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                []
        in  ( [],[],_lhs_freshTyVarName,[],[],[],_self)
-- Literal -----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      retTy                : Type
      self                 : SELF

-}
{-
   local variables for Literal.LitBool:
      self

-}
{-
   local variables for Literal.LitChar:
      self

-}
{-
   local variables for Literal.LitInt:
      self

-}
{-
   local variables for Literal.LitString:
      self

-}
-- semantic domain
type T_Literal = ( (Type),(Literal))
-- cata
sem_Literal :: (Literal) ->
               (T_Literal)
sem_Literal ((LitBool (_value) (_pos))) =
    (sem_Literal_LitBool (_value) (_pos))
sem_Literal ((LitChar (_value) (_pos))) =
    (sem_Literal_LitChar (_value) (_pos))
sem_Literal ((LitInt (_value) (_pos))) =
    (sem_Literal_LitInt (_value) (_pos))
sem_Literal ((LitString (_value) (_pos))) =
    (sem_Literal_LitString (_value) (_pos))
sem_Literal_LitBool :: (Bool) ->
                       (Pos) ->
                       (T_Literal)
sem_Literal_LitBool (_value) (_pos) =
    let (_self) =
            LitBool _value _pos
    in  ( boolTy,_self)
sem_Literal_LitChar :: (Char) ->
                       (Pos) ->
                       (T_Literal)
sem_Literal_LitChar (_value) (_pos) =
    let (_self) =
            LitChar _value _pos
    in  ( charTy,_self)
sem_Literal_LitInt :: (Int) ->
                      (Pos) ->
                      (T_Literal)
sem_Literal_LitInt (_value) (_pos) =
    let (_self) =
            LitInt _value _pos
    in  ( intTy,_self)
sem_Literal_LitString :: (String) ->
                         (Pos) ->
                         (T_Literal)
sem_Literal_LitString (_value) (_pos) =
    let (_self) =
            LitString _value _pos
    in  ( stringTy,_self)
-- Marker ------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Marker.Cons:
      self

-}
{-
   local variables for Marker.Nil:
      self

-}
-- semantic domain
type T_Marker = ( (Marker))
-- cata
sem_Marker :: (Marker) ->
              (T_Marker)
sem_Marker (list) =
    (foldr (sem_Marker_Cons) (sem_Marker_Nil) (list))
sem_Marker_Cons :: (String) ->
                   (T_Marker) ->
                   (T_Marker)
sem_Marker_Cons (_hd) (_tl) =
    let (_self) =
            (:) _hd _tl_self
        ( _tl_self) =
            (_tl )
    in  ( _self)
sem_Marker_Nil :: (T_Marker)
sem_Marker_Nil  =
    let (_self) =
            []
    in  ( _self)
-- MaybeExpr ---------------------------------------------------
{-
   inherited attributes:
      lvars                : StringList
      tySubst              : TypeSubstitutionFunction
      vcx                  : IdentContext

   chained attributes:
      freshTyVarName       : Int

   synthesised attributes:
      cl                   : Constraint__List
      new                  : MaybeExpr
      postTypeErrors       : TypeConstraintErrorList
      retTy                : TypeList
      self                 : SELF

-}
{-
   local variables for MaybeExpr.JUST:
      self

-}
{-
   local variables for MaybeExpr.NOTHING:
      self

-}
-- semantic domain
type T_MaybeExpr = (Int) ->
                   (StringList) ->
                   (TypeSubstitutionFunction) ->
                   (IdentContext) ->
                   ( (Constraint__List),(Int),(MaybeExpr),(TypeConstraintErrorList),(TypeList),(MaybeExpr))
-- cata
sem_MaybeExpr :: (MaybeExpr) ->
                 (T_MaybeExpr)
sem_MaybeExpr ((JUST (_expr))) =
    (sem_MaybeExpr_JUST ((sem_Expr (_expr))))
sem_MaybeExpr ((NOTHING )) =
    (sem_MaybeExpr_NOTHING )
sem_MaybeExpr_JUST :: (T_Expr) ->
                      (T_MaybeExpr)
sem_MaybeExpr_JUST (_expr) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                JUST _expr_self
            ( _expr_cl,_expr_freshTyVarName,_expr_new,_expr_postTypeErrors,_expr_retTy,_expr_self) =
                (_expr (_lhs_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( _expr_cl,_expr_freshTyVarName,JUST  _expr_new,_expr_postTypeErrors,[_expr_retTy],_self)
sem_MaybeExpr_NOTHING :: (T_MaybeExpr)
sem_MaybeExpr_NOTHING  =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                NOTHING
        in  ( [],_lhs_freshTyVarName,NOTHING,[],[],_self)
-- Parameter ---------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      pv_cx                : IdentContext
      self                 : SELF

-}
{-
   local variables for Parameter.Parameter:
      self

-}
-- semantic domain
type T_Parameter = ( (IdentContext),(Parameter))
-- cata
sem_Parameter :: (Parameter) ->
                 (T_Parameter)
sem_Parameter ((Parameter (_passingMode) (_accessMode) (_names) (_ty))) =
    (sem_Parameter_Parameter (_passingMode) (_accessMode) (_names) (_ty))
sem_Parameter_Parameter :: (ParamPassingMode) ->
                           (AccessMode) ->
                           (NameList) ->
                           (Type) ->
                           (T_Parameter)
sem_Parameter_Parameter (_passingMode) (_accessMode) (_names) (_ty) =
    let (_self) =
            Parameter _passingMode _accessMode _names _ty
    in  ( add_locals_to_context
                _names
                _ty
                []
         ,_self
         )
-- ParameterList -----------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      pv_cx                : IdentContext
      self                 : SELF

-}
{-
   local variables for ParameterList.Cons:
      self

-}
{-
   local variables for ParameterList.Nil:
      self

-}
-- semantic domain
type T_ParameterList = ( (IdentContext),(ParameterList))
-- cata
sem_ParameterList :: (ParameterList) ->
                     (T_ParameterList)
sem_ParameterList (list) =
    (foldr (sem_ParameterList_Cons) (sem_ParameterList_Nil) ((map sem_Parameter list)))
sem_ParameterList_Cons :: (T_Parameter) ->
                          (T_ParameterList) ->
                          (T_ParameterList)
sem_ParameterList_Cons (_hd) (_tl) =
    let (_self) =
            (:) _hd_self _tl_self
        ( _hd_pv_cx,_hd_self) =
            (_hd )
        ( _tl_pv_cx,_tl_self) =
            (_tl )
    in  ( _hd_pv_cx ++ _tl_pv_cx,_self)
sem_ParameterList_Nil :: (T_ParameterList)
sem_ParameterList_Nil  =
    let (_self) =
            []
    in  ( [],_self)
-- SeqProg -----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      new                  : SeqProg
      self                 : SELF
      typeErrors           : TypeConstraintErrorList

-}
{-
   local variables for SeqProg.SeqProg:
      postTypeErrors
      lvars
      tySubst
      lconst_cx
      typeErrors
      substitutions
      raw_typeErrors
      solver_result
      cl_
      nameTable
      cl
      vcx
      self

-}
-- semantic domain
type T_SeqProg = ( (SeqProg),(SeqProg),(TypeConstraintErrorList))
-- cata
sem_SeqProg :: (SeqProg) ->
               (T_SeqProg)
sem_SeqProg ((SeqProg (_name) (_header) (_decls) (_body) (_specs) (_lconsts))) =
    (sem_SeqProg_SeqProg (_name) ((sem_ParameterList (_header))) ((sem_DeclList (_decls))) ((sem_Stmt (_body))) ((sem_SpecificationList (_specs))) (_lconsts))
sem_SeqProg_SeqProg :: (Name) ->
                       (T_ParameterList) ->
                       (T_DeclList) ->
                       (T_Stmt) ->
                       (T_SpecificationList) ->
                       (UserDefinedLogicalConstantList) ->
                       (T_SeqProg)
sem_SeqProg_SeqProg (_name) (_header) (_decls) (_body) (_specs) (_lconsts) =
    let (_self) =
            SeqProg _name _header_self _decls_self _body_self _specs_self _lconsts
        (_vcx) =
            _lconst_cx
            ++ _header_pv_cx
            ++ _decls_pv_cx
        (_cl) =
            _decls_cl
            ++ _specs_cl
            ++ _body_cl
        (_nameTable) =
            mk_nameTable _cl
        (_cl_) =
            translateConstraints _nameTable _cl
        (_solver_result) =
            solveconstraints (length _cl_ + 1) _cl_
        (_raw_typeErrors) =
            reverse (fst _solver_result)
        (_substitutions) =
            snd _solver_result
        (_typeErrors) =
            map (applySubsToConstraint _nameTable _substitutions)
                 _raw_typeErrors
            ++ _postTypeErrors
        (_lconst_cx) =
            predefined_lconst_cx
            ++
            map (get_name_tyscheme . snd) _lconsts
        (_tySubst) =
            applySubs _nameTable _substitutions
        (_lvars) =
            map fst _lconst_cx
        (_postTypeErrors) =
            _decls_postTypeErrors
            ++ _body_postTypeErrors
            ++ _specs_postTypeErrors
        ( _header_pv_cx,_header_self) =
            (_header )
        ( _decls_cl,_decls_freshTyVarName,_decls_new,_decls_postTypeErrors,_decls_pv_cx,_decls_self) =
            (_decls (0) (_lvars) (_tySubst) (_vcx))
        ( _body_cl,_body_freshTyVarName,_body_new,_body_postTypeErrors,_body_self) =
            (_body (_decls_freshTyVarName) (_lvars) (_tySubst) (_vcx))
        ( _specs_cl,_specs_freshTyVarName,_specs_new,_specs_postTypeErrors,_specs_self) =
            (_specs (_body_freshTyVarName) (_lvars) (_tySubst) (_vcx))
    in  ( SeqProg
                _name
                _header_self
                _decls_new
                _body_new
                _specs_new
                _lconsts
         ,_self
         ,_typeErrors
         )
-- Specification -----------------------------------------------
{-
   inherited attributes:
      lvars                : StringList
      tySubst              : TypeSubstitutionFunction
      vcx                  : IdentContext

   chained attributes:
      freshTyVarName       : Int

   synthesised attributes:
      cl                   : Constraint__List
      new                  : Specification
      postTypeErrors       : TypeConstraintErrorList
      self                 : SELF

-}
{-
   local variables for Specification.Spec:
      co_post
      co_pre
      ermsg_post
      ermsg_pre
      self

-}
-- semantic domain
type T_Specification = (Int) ->
                       (StringList) ->
                       (TypeSubstitutionFunction) ->
                       (IdentContext) ->
                       ( (Constraint__List),(Int),(Specification),(TypeConstraintErrorList),(Specification))
-- cata
sem_Specification :: (Specification) ->
                     (T_Specification)
sem_Specification ((Spec (_pre) (_post))) =
    (sem_Specification_Spec ((sem_Expr (_pre))) ((sem_Expr (_post))))
sem_Specification_Spec :: (T_Expr) ->
                          (T_Expr) ->
                          (T_Specification)
sem_Specification_Spec (_pre) (_post) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                Spec _pre_self _post_self
            (_ermsg_pre) =
                typeError_notBool _pre_self _pre_retTy
            (_ermsg_post) =
                typeError_notBool _post_self _post_retTy
            (_co_pre) =
                (_pre_retTy <==> boolTy) _ermsg_pre
            (_co_post) =
                (_post_retTy <==> boolTy) _ermsg_post
            ( _pre_cl,_pre_freshTyVarName,_pre_new,_pre_postTypeErrors,_pre_retTy,_pre_self) =
                (_pre (_lhs_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
            ( _post_cl,_post_freshTyVarName,_post_new,_post_postTypeErrors,_post_retTy,_post_self) =
                (_post (_pre_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( _pre_cl ++ _post_cl ++ [_co_pre,_co_post],_post_freshTyVarName,Spec _pre_new _post_new,_pre_postTypeErrors ++ _post_postTypeErrors,_self)
-- SpecificationList -------------------------------------------
{-
   inherited attributes:
      lvars                : StringList
      tySubst              : TypeSubstitutionFunction
      vcx                  : IdentContext

   chained attributes:
      freshTyVarName       : Int

   synthesised attributes:
      cl                   : Constraint__List
      new                  : SpecificationList
      postTypeErrors       : TypeConstraintErrorList
      self                 : SELF

-}
{-
   local variables for SpecificationList.Cons:
      self

-}
{-
   local variables for SpecificationList.Nil:
      self

-}
-- semantic domain
type T_SpecificationList = (Int) ->
                           (StringList) ->
                           (TypeSubstitutionFunction) ->
                           (IdentContext) ->
                           ( (Constraint__List),(Int),(SpecificationList),(TypeConstraintErrorList),(SpecificationList))
-- cata
sem_SpecificationList :: (SpecificationList) ->
                         (T_SpecificationList)
sem_SpecificationList (list) =
    (foldr (sem_SpecificationList_Cons) (sem_SpecificationList_Nil) ((map sem_Specification list)))
sem_SpecificationList_Cons :: (T_Specification) ->
                              (T_SpecificationList) ->
                              (T_SpecificationList)
sem_SpecificationList_Cons (_hd) (_tl) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                (:) _hd_self _tl_self
            ( _hd_cl,_hd_freshTyVarName,_hd_new,_hd_postTypeErrors,_hd_self) =
                (_hd (_lhs_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
            ( _tl_cl,_tl_freshTyVarName,_tl_new,_tl_postTypeErrors,_tl_self) =
                (_tl (_hd_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( _hd_cl ++ _tl_cl,_tl_freshTyVarName,_hd_new : _tl_new,_hd_postTypeErrors ++ _tl_postTypeErrors,_self)
sem_SpecificationList_Nil :: (T_SpecificationList)
sem_SpecificationList_Nil  =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                []
        in  ( [],_lhs_freshTyVarName,[],[],_self)
-- Stmt --------------------------------------------------------
{-
   inherited attributes:
      lvars                : StringList
      tySubst              : TypeSubstitutionFunction
      vcx                  : IdentContext

   chained attributes:
      freshTyVarName       : Int

   synthesised attributes:
      cl                   : Constraint__List
      new                  : Stmt
      postTypeErrors       : TypeConstraintErrorList
      self                 : SELF

-}
{-
   local variables for Stmt.Asg:
      co0
      ermsg0
      self

-}
{-
   local variables for Stmt.ForLoop:
      co_m
      co_i
      co_incr
      co_ub
      co_lb
      ermsg_m
      ermsg_i
      ermsg_incr
      ermsg_ub
      ermsg_lb
      vcx
      ivar_
      cvar_
      self

-}
{-
   local variables for Stmt.IfElse:
      co0
      ermsg0
      self

-}
{-
   local variables for Stmt.Seq:
      self

-}
{-
   local variables for Stmt.Skip:
      self

-}
{-
   local variables for Stmt.While:
      co_m
      co_i
      co_g
      ermsg_m
      ermsg_i
      ermsg_g
      vcx
      cvar_
      self

-}
-- semantic domain
type T_Stmt = (Int) ->
              (StringList) ->
              (TypeSubstitutionFunction) ->
              (IdentContext) ->
              ( (Constraint__List),(Int),(Stmt),(TypeConstraintErrorList),(Stmt))
-- cata
sem_Stmt :: (Stmt) ->
            (T_Stmt)
sem_Stmt ((Asg (_pos) (_target) (_value))) =
    (sem_Stmt_Asg (_pos) ((sem_Expr (_target))) ((sem_Expr (_value))))
sem_Stmt ((ForLoop (_pos) (_inv) (_metric) (_cvar) (_lb) (_var) (_ub) (_incr) (_body))) =
    (sem_Stmt_ForLoop (_pos) ((sem_MaybeExpr (_inv))) ((sem_MaybeExpr (_metric))) ((sem_MaybeExpr (_cvar))) ((sem_Expr (_lb))) ((sem_Ident (_var))) ((sem_Expr (_ub))) ((sem_Expr (_incr))) ((sem_Stmt (_body))))
sem_Stmt ((IfElse (_pos) (_guard) (_stmt1) (_stmt2))) =
    (sem_Stmt_IfElse (_pos) ((sem_Expr (_guard))) ((sem_Stmt (_stmt1))) ((sem_Stmt (_stmt2))))
sem_Stmt ((Seq (_stmts))) =
    (sem_Stmt_Seq ((sem_StmtList (_stmts))))
sem_Stmt ((Skip )) =
    (sem_Stmt_Skip )
sem_Stmt ((While (_pos) (_inv) (_metric) (_cvar) (_guard) (_body))) =
    (sem_Stmt_While (_pos) ((sem_MaybeExpr (_inv))) ((sem_MaybeExpr (_metric))) ((sem_MaybeExpr (_cvar))) ((sem_Expr (_guard))) ((sem_Stmt (_body))))
sem_Stmt_Asg :: (Pos) ->
                (T_Expr) ->
                (T_Expr) ->
                (T_Stmt)
sem_Stmt_Asg (_pos) (_target) (_value) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                Asg _pos _target_self _value_self
            (_ermsg0) =
                typeError_SingleAssignment
                      _value_self
                      _self
                      _value_retTy
                      _target_retTy
            (_co0) =
                (_target_retTy <==> _value_retTy) _ermsg0
            ( _target_cl,_target_freshTyVarName,_target_new,_target_postTypeErrors,_target_retTy,_target_self) =
                (_target (_lhs_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
            ( _value_cl,_value_freshTyVarName,_value_new,_value_postTypeErrors,_value_retTy,_value_self) =
                (_value (_target_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( _target_cl ++ _value_cl ++ [_co0]
             ,_value_freshTyVarName
             ,Asg
                    _pos
                    _target_new
                    _value_new
             ,_target_postTypeErrors
              ++ _value_postTypeErrors
             ,_self
             )
sem_Stmt_ForLoop :: (Pos) ->
                    (T_MaybeExpr) ->
                    (T_MaybeExpr) ->
                    (T_MaybeExpr) ->
                    (T_Expr) ->
                    (T_Ident) ->
                    (T_Expr) ->
                    (T_Expr) ->
                    (T_Stmt) ->
                    (T_Stmt)
sem_Stmt_ForLoop (_pos) (_inv) (_metric) (_cvar) (_lb) (_var) (_ub) (_incr) (_body) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                ForLoop _pos _inv_self _metric_self _cvar_self _lb_self _var_self _ub_self _incr_self _body_self
            (_cvar_) =
                case get_cvar _cvar_self of
                Just c        -> [(c,FlatTy intTy)]
                _             -> []
            (_ivar_) =
                (_var_name,FlatTy intTy)
            (_vcx) =
                _ivar_ : _cvar_ ++ _lhs_vcx
            (_ermsg_lb) =
                typeError_notInt _lb_self _lb_retTy
            (_ermsg_ub) =
                typeError_notInt _ub_self _ub_retTy
            (_ermsg_incr) =
                typeError_notInt _incr_self _incr_retTy
            (_ermsg_i) =
                typeError_notBool _inv_self
            (_ermsg_m) =
                typeError_notInt _metric_self
            (_co_lb) =
                (_lb_retTy <==> intTy) _ermsg_lb
            (_co_ub) =
                (_ub_retTy <==> intTy) _ermsg_ub
            (_co_incr) =
                (_incr_retTy <==> intTy) _ermsg_incr
            (_co_i) =
                case _inv_retTy of
                [t] -> [(t <==> boolTy) (_ermsg_i t)]
                _   -> []
            (_co_m) =
                case _metric_retTy of
                [t] -> [(t <==> intTy) (_ermsg_m t)]
                _   -> []
            ( _inv_cl,_inv_freshTyVarName,_inv_new,_inv_postTypeErrors,_inv_retTy,_inv_self) =
                (_inv (_lhs_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_vcx))
            ( _metric_cl,_metric_freshTyVarName,_metric_new,_metric_postTypeErrors,_metric_retTy,_metric_self) =
                (_metric (_inv_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_vcx))
            ( _cvar_cl,_cvar_freshTyVarName,_cvar_new,_cvar_postTypeErrors,_cvar_retTy,_cvar_self) =
                (_cvar (_metric_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_vcx))
            ( _lb_cl,_lb_freshTyVarName,_lb_new,_lb_postTypeErrors,_lb_retTy,_lb_self) =
                (_lb (_cvar_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_vcx))
            ( _var_name,_var_new,_var_self) =
                (_var (intTy) (_lhs_lvars) (_lhs_tySubst))
            ( _ub_cl,_ub_freshTyVarName,_ub_new,_ub_postTypeErrors,_ub_retTy,_ub_self) =
                (_ub (_lb_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_vcx))
            ( _incr_cl,_incr_freshTyVarName,_incr_new,_incr_postTypeErrors,_incr_retTy,_incr_self) =
                (_incr (_ub_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_vcx))
            ( _body_cl,_body_freshTyVarName,_body_new,_body_postTypeErrors,_body_self) =
                (_body (_incr_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_vcx))
        in  ( _inv_cl
              ++ _metric_cl
              ++ _lb_cl ++ _ub_cl ++ _incr_cl
              ++ _body_cl
              ++ _co_i
              ++ _co_m
              ++ [_co_lb,_co_ub,_co_incr]
             ,_body_freshTyVarName
             ,ForLoop
                    _pos
                    _inv_new
                    _metric_new
                    _cvar_new
                    _lb_new
                    _var_new
                    _ub_new
                    _incr_new
                    _body_new
             ,_inv_postTypeErrors
              ++ _metric_postTypeErrors
              ++ _lb_postTypeErrors
              ++ _ub_postTypeErrors
              ++ _incr_postTypeErrors
              ++ _body_postTypeErrors
             ,_self
             )
sem_Stmt_IfElse :: (Pos) ->
                   (T_Expr) ->
                   (T_Stmt) ->
                   (T_Stmt) ->
                   (T_Stmt)
sem_Stmt_IfElse (_pos) (_guard) (_stmt1) (_stmt2) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                IfElse _pos _guard_self _stmt1_self _stmt2_self
            (_ermsg0) =
                typeError_notBool _guard_self _guard_retTy
            (_co0) =
                (_guard_retTy <==> boolTy) _ermsg0
            ( _guard_cl,_guard_freshTyVarName,_guard_new,_guard_postTypeErrors,_guard_retTy,_guard_self) =
                (_guard (_lhs_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
            ( _stmt1_cl,_stmt1_freshTyVarName,_stmt1_new,_stmt1_postTypeErrors,_stmt1_self) =
                (_stmt1 (_guard_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
            ( _stmt2_cl,_stmt2_freshTyVarName,_stmt2_new,_stmt2_postTypeErrors,_stmt2_self) =
                (_stmt2 (_stmt1_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( _guard_cl ++ _stmt1_cl ++ _stmt2_cl ++ [_co0]
             ,_stmt2_freshTyVarName
             ,IfElse
                    _pos
                    _guard_new
                    _stmt1_new
                    _stmt2_new
             ,_guard_postTypeErrors
              ++ _stmt1_postTypeErrors
              ++ _stmt2_postTypeErrors
             ,_self
             )
sem_Stmt_Seq :: (T_StmtList) ->
                (T_Stmt)
sem_Stmt_Seq (_stmts) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                Seq _stmts_self
            ( _stmts_cl,_stmts_freshTyVarName,_stmts_new,_stmts_postTypeErrors,_stmts_self) =
                (_stmts (_lhs_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( _stmts_cl,_stmts_freshTyVarName,Seq _stmts_new,_stmts_postTypeErrors,_self)
sem_Stmt_Skip :: (T_Stmt)
sem_Stmt_Skip  =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                Skip
        in  ( [],_lhs_freshTyVarName,Skip,[],_self)
sem_Stmt_While :: (Pos) ->
                  (T_MaybeExpr) ->
                  (T_MaybeExpr) ->
                  (T_MaybeExpr) ->
                  (T_Expr) ->
                  (T_Stmt) ->
                  (T_Stmt)
sem_Stmt_While (_pos) (_inv) (_metric) (_cvar) (_guard) (_body) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                While _pos _inv_self _metric_self _cvar_self _guard_self _body_self
            (_cvar_) =
                case get_cvar _cvar_self of
                Just c        -> [(c,FlatTy intTy)]
                _             -> []
            (_vcx) =
                _cvar_ ++ _lhs_vcx
            (_ermsg_g) =
                typeError_notBool _guard_self _guard_retTy
            (_ermsg_i) =
                typeError_notBool _inv_self
            (_ermsg_m) =
                typeError_notInt _metric_self
            (_co_g) =
                (_guard_retTy <==> boolTy) _ermsg_g
            (_co_i) =
                case _inv_retTy of
                [t] -> [(t <==> boolTy) (_ermsg_i t)]
                _   -> []
            (_co_m) =
                case _metric_retTy of
                [t] -> [(t <==> intTy) (_ermsg_m t)]
                _   -> []
            ( _inv_cl,_inv_freshTyVarName,_inv_new,_inv_postTypeErrors,_inv_retTy,_inv_self) =
                (_inv (_lhs_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_vcx))
            ( _metric_cl,_metric_freshTyVarName,_metric_new,_metric_postTypeErrors,_metric_retTy,_metric_self) =
                (_metric (_inv_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_vcx))
            ( _cvar_cl,_cvar_freshTyVarName,_cvar_new,_cvar_postTypeErrors,_cvar_retTy,_cvar_self) =
                (_cvar (_metric_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_vcx))
            ( _guard_cl,_guard_freshTyVarName,_guard_new,_guard_postTypeErrors,_guard_retTy,_guard_self) =
                (_guard (_cvar_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_vcx))
            ( _body_cl,_body_freshTyVarName,_body_new,_body_postTypeErrors,_body_self) =
                (_body (_guard_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_vcx))
        in  ( _inv_cl
              ++ _metric_cl
              ++ _guard_cl
              ++ _body_cl
              ++ _co_i ++ _co_m ++ [_co_g]
             ,_body_freshTyVarName
             ,While
                    _pos
                    _inv_new
                    _metric_new
                    _cvar_new
                    _guard_new
                    _body_new
             ,_inv_postTypeErrors
              ++ _metric_postTypeErrors
              ++ _guard_postTypeErrors
              ++ _body_postTypeErrors
             ,_self
             )
-- StmtList ----------------------------------------------------
{-
   inherited attributes:
      lvars                : StringList
      tySubst              : TypeSubstitutionFunction
      vcx                  : IdentContext

   chained attributes:
      freshTyVarName       : Int

   synthesised attributes:
      cl                   : Constraint__List
      new                  : StmtList
      postTypeErrors       : TypeConstraintErrorList
      self                 : SELF

-}
{-
   local variables for StmtList.Cons:
      self

-}
{-
   local variables for StmtList.Nil:
      self

-}
-- semantic domain
type T_StmtList = (Int) ->
                  (StringList) ->
                  (TypeSubstitutionFunction) ->
                  (IdentContext) ->
                  ( (Constraint__List),(Int),(StmtList),(TypeConstraintErrorList),(StmtList))
-- cata
sem_StmtList :: (StmtList) ->
                (T_StmtList)
sem_StmtList (list) =
    (foldr (sem_StmtList_Cons) (sem_StmtList_Nil) ((map sem_Stmt list)))
sem_StmtList_Cons :: (T_Stmt) ->
                     (T_StmtList) ->
                     (T_StmtList)
sem_StmtList_Cons (_hd) (_tl) =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                (:) _hd_self _tl_self
            ( _hd_cl,_hd_freshTyVarName,_hd_new,_hd_postTypeErrors,_hd_self) =
                (_hd (_lhs_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
            ( _tl_cl,_tl_freshTyVarName,_tl_new,_tl_postTypeErrors,_tl_self) =
                (_tl (_hd_freshTyVarName) (_lhs_lvars) (_lhs_tySubst) (_lhs_vcx))
        in  ( _hd_cl ++ _tl_cl,_tl_freshTyVarName,_hd_new : _tl_new,_hd_postTypeErrors ++ _tl_postTypeErrors,_self)
sem_StmtList_Nil :: (T_StmtList)
sem_StmtList_Nil  =
    \ _lhs_freshTyVarName
      _lhs_lvars
      _lhs_tySubst
      _lhs_vcx ->
        let (_self) =
                []
        in  ( [],_lhs_freshTyVarName,[],[],_self)

