structure x_ArrayTheory :> x_ArrayTheory =
struct
  open Type Term Thm
  infixr -->
  fun C s t ty = mk_thy_const{Name=s,Thy=t,Ty=ty}
  fun T s t A = mk_thy_type{Tyop=s, Thy=t,Args=A}
  fun V s q = mk_var(s,q)
  val U     = mk_vartype
  
  (*  Parents *)
  local open OmegaTheory int_arithTheory x_StdConstTheory
  in end;
  val _ = Theory.link_parents
          ("x_Array",11519161,0)
          [("Omega",6038800,0), ("int_arith",6038615,0),
           ("x_StdConst",11519139,0)];
  val _ = Theory.incorporate_types "x_Array" [];
  val _ = Theory.incorporate_consts "x_Array" [];
  
  local
  val share_table = Vector.fromList
  [C"=" "min" ((alpha --> (alpha --> bool))),
   C"ArrayApp" "x_StdConst"
    ((T"ARRAY" "x_StdConst" [alpha] --> (T"int" "integer" [] --> alpha))),
   C"ArrayUpdate" "x_StdConst"
    ((T"ARRAY" "x_StdConst" [alpha] -->
      (T"int" "integer" [] -->
       (alpha --> T"ARRAY" "x_StdConst" [alpha])))),
   V"a" (T"ARRAY" "x_StdConst" [alpha]), V"i" (T"int" "integer" []),
   V"x" (alpha), V"j" (T"int" "integer" []),
   C"COND" "bool" ((bool --> (alpha --> (alpha --> alpha)))),
   C"=" "min" ((T"int" "integer" [] --> (T"int" "integer" [] --> bool))),
   C"arraySize" "x_StdConst"
    ((T"ARRAY" "x_StdConst" [alpha] --> T"int" "integer" [])),
   C"=" "min"
    ((T"list" "list" [alpha] --> (T"list" "list" [alpha] --> bool))),
   C"ArrayDom" "x_StdConst"
    ((T"ARRAY" "x_StdConst" [alpha] -->
      (T"int" "integer" [] -->
       (T"int" "integer" [] --> T"list" "list" [alpha])))),
   C"NIL" "list" (T"list" "list" [alpha]),
   C"int_ge" "integer"
    ((T"int" "integer" [] --> (T"int" "integer" [] --> bool))),
   C"int_add" "integer"
    ((T"int" "integer" [] -->
      (T"int" "integer" [] --> T"int" "integer" []))),
   C"int_of_num" "integer" ((T"num" "num" [] --> T"int" "integer" [])),
   C"NUMERAL" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"NUMERAL_BIT1" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"ALT_ZERO" "arithmetic" (T"num" "num" []),
   C"CONS" "list"
    ((alpha --> (T"list" "list" [alpha] --> T"list" "list" [alpha]))),
   C"APPEND" "list"
    ((T"list" "list" [alpha] -->
      (T"list" "list" [alpha] --> T"list" "list" [alpha]))),
   C"int_le" "integer"
    ((T"int" "integer" [] --> (T"int" "integer" [] --> bool)))]
  val DT = Thm.disk_thm share_table
  in
  val ArrayUpdate_thm1 =
    DT("", [], `((%0 ((%1 (((%2 %3) %4) %5)) %4)) %5)`)
  val ArrayUpdate_thm2 =
    DT("", [],
       `((%0 ((%1 (((%2 %3) %4) %5)) %6)) (((%7 ((%8 %4) %6)) %5) ((%1 %3)
       %6)))`)
  val SizeOf_ArrayUpdate_thm =
    DT("", [], `((%8 (%9 (((%2 %3) %4) %5))) (%9 %3))`)
  val ArrayDom_thm1 =
    DT("ArrayDom_defora", [], `((%10 (((%11 %3) %4) %4)) %12)`)
  val ArrayDom_thm2 =
    DT("ArrayDom_defora", [`((%13 %4) %6)`],
       `((%10 (((%11 %3) %4) %6)) %12)`)
  val ArrayDom_thm3 =
    DT("ArrayDom_defora", [],
       `((%10 (((%11 %3) %4) ((%14 %4) (%15 (%16 (%17 %18)))))) ((%19 ((%1
       %3) %4)) %12))`)
  val ArrayDom_ora4 =
    DT("ArrayDom_ora4", [`((%21 %4) %6)`],
       `((%10 (((%11 %3) %4) ((%14 %6) (%15 (%16 (%17 %18)))))) ((%20
       (((%11 %3) %4) %6)) ((%19 ((%1 %3) %6)) %12)))`)
  end
  val _ = DB.bindl "x_Array"
  [("ArrayUpdate_thm1",ArrayUpdate_thm1,DB.Thm),
   ("ArrayUpdate_thm2",ArrayUpdate_thm2,DB.Thm),
   ("SizeOf_ArrayUpdate_thm",SizeOf_ArrayUpdate_thm,DB.Thm),
   ("ArrayDom_thm1",ArrayDom_thm1,DB.Thm),
   ("ArrayDom_thm2",ArrayDom_thm2,DB.Thm),
   ("ArrayDom_thm3",ArrayDom_thm3,DB.Thm),
   ("ArrayDom_ora4",ArrayDom_ora4,DB.Thm)]
  
  local open Portable GrammarSpecials Parse
  in
  val _ = mk_local_grms [("OmegaTheory.Omega_grammars",
                          OmegaTheory.Omega_grammars),
                         ("int_arithTheory.int_arith_grammars",
                          int_arithTheory.int_arith_grammars),
                         ("x_StdConstTheory.x_StdConst_grammars",
                          x_StdConstTheory.x_StdConst_grammars)]
  val _ = List.app (update_grms reveal) []
  
  val x_Array_grammars = Parse.current_lgrms()
  end
  
end
