signature x_StdConstTheory =
sig
  type thm = Thm.thm
  
  (*  Definitions  *)
    val APPEND__def : thm
    val ARRAY : thm
    val ARRAY_TY_DEF : thm
    val ARRAY_case_def : thm
    val ARRAY_repfns : thm
    val ARRAY_size_def : thm
    val ArrayApp_def : thm
    val ArrayUpdate_def : thm
    val COUNT_def : thm
    val FromTo_def : thm
    val LPROD_def : thm
    val MARKER_def : thm
    val MAXP_def : thm
    val MAX_primitive_def : thm
    val MEM__def : thm
    val MIN_primitive_def : thm
    val SQLSELECT_def : thm
    val SUM__def : thm
    val arraySize_def : thm
    val lprod__def : thm
    val max_def : thm
    val min_def : thm
    val notEqual_def : thm
    val x_StdConst0_def : thm
  
  (*  Theorems  *)
    val ARRAY_11 : thm
    val ARRAY_Axiom : thm
    val ARRAY_case_cong : thm
    val ARRAY_induction : thm
    val ARRAY_nchotomy : thm
    val ArrayDom_defora : thm
    val MAX_def : thm
    val MAX_ind : thm
    val MIN_def : thm
    val MIN_ind : thm
  
  val x_StdConst_grammars : type_grammar.grammar * term_grammar.grammar
(*
   [integer] Parent theory of "x_StdConst"
   
   [list] Parent theory of "x_StdConst"
   
   [APPEND__def]  Definition
      
      |- $APPEND_ = APPEND
   
   [ARRAY]  Definition
      
      |- ARRAY = x_StdConst0
   
   [ARRAY_TY_DEF]  Definition
      
      |- ?rep.
           TYPE_DEFINITION
             (\a0'.
                !'ARRAY'.
                  (!a0'.
                     (?a0 a1.
                        a0' =
                        (\a0 a1. CONSTR 0 (a0,a1) (\n. BOTTOM)) a0 a1) ==>
                     'ARRAY' a0') ==>
                  'ARRAY' a0') rep
   
   [ARRAY_case_def]  Definition
      
      |- !f a0 a1. case f (ARRAY a0 a1) = f a0 a1
   
   [ARRAY_repfns]  Definition
      
      |- (!a. mk_ARRAY (dest_ARRAY a) = a) /\
         !r.
           (\a0'.
              !'ARRAY'.
                (!a0'.
                   (?a0 a1.
                      a0' =
                      (\a0 a1. CONSTR 0 (a0,a1) (\n. BOTTOM)) a0 a1) ==>
                   'ARRAY' a0') ==>
                'ARRAY' a0') r =
           (dest_ARRAY (mk_ARRAY r) = r)
   
   [ARRAY_size_def]  Definition
      
      |- !f a0 a1. ARRAY_size f (ARRAY a0 a1) = 1
   
   [ArrayApp_def]  Definition
      
      |- !n c i. ARRAY n c ArrayApp i = c i
   
   [ArrayUpdate_def]  Definition
      
      |- !n c i x.
           ArrayUpdate (ARRAY n c) i x =
           ARRAY n (\j. (if j = i then x else c j))
   
   [COUNT_def]  Definition
      
      |- (COUNT [] = 0) /\ !x s. COUNT (x::s) = 1 + COUNT s
   
   [FromTo_def]  Definition
      
      |- !i left right. FromTo i left right = left <= i /\ i < right
   
   [LPROD_def]  Definition
      
      |- (!t. [] LPROD t = []) /\
         !x s t. x::s LPROD t = APPEND (lprod_ x t) (s LPROD t)
   
   [MARKER_def]  Definition
      
      |- !info x. MARKER info x = x
   
   [MAXP_def]  Definition
      
      |- (MAXP [] = 0) /\ !x s. MAXP (x::s) = x max MAXP s
   
   [MAX_primitive_def]  Definition
      
      |- MAX =
         WFREC (@R. WF R /\ !x v3 v2. R (v2::v3) (x::v2::v3))
           (\MAX a.
              case a of
                 [] -> ARB
              || v::v1 ->
                   case v1 of [] -> v || v4::v5 -> v max MAX (v4::v5))
   
   [MEM__def]  Definition
      
      |- $MEM_ = MEM
   
   [MIN_primitive_def]  Definition
      
      |- MIN =
         WFREC (@R. WF R /\ !x v3 v2. R (v2::v3) (x::v2::v3))
           (\MIN a.
              case a of
                 [] -> ARB
              || v::v1 ->
                   case v1 of [] -> v || v4::v5 -> v min MIN (v4::v5))
   
   [SQLSELECT_def]  Definition
      
      |- !f p joined_databases.
           SQLSELECT f p joined_databases =
           MAP f (FILTER p joined_databases)
   
   [SUM__def]  Definition
      
      |- (SUM_ [] = 0) /\ !x s. SUM_ (x::s) = x + SUM_ s
   
   [arraySize_def]  Definition
      
      |- !n c. arraySize (ARRAY n c) = n
   
   [lprod__def]  Definition
      
      |- (!x. lprod_ x [] = []) /\
         !x y t. lprod_ x (y::t) = (x,y)::lprod_ x t
   
   [max_def]  Definition
      
      |- $max = int_max
   
   [min_def]  Definition
      
      |- $min = int_min
   
   [notEqual_def]  Definition
      
      |- !a b. (a notEqual b) = ~(a = b)
   
   [x_StdConst0_def]  Definition
      
      |- x_StdConst0 =
         (\a0 a1. mk_ARRAY ((\a0 a1. CONSTR 0 (a0,a1) (\n. BOTTOM)) a0 a1))
   
   [ARRAY_11]  Theorem
      
      |- !a0 a1 a0' a1'.
           (ARRAY a0 a1 = ARRAY a0' a1') = (a0 = a0') /\ (a1 = a1')
   
   [ARRAY_Axiom]  Theorem
      
      |- !f. ?fn. !a0 a1. fn (ARRAY a0 a1) = f a0 a1
   
   [ARRAY_case_cong]  Theorem
      
      |- !M M' f.
           (M = M') /\
           (!a0 a1. (M' = ARRAY a0 a1) ==> (f a0 a1 = f' a0 a1)) ==>
           (case f M = case f' M')
   
   [ARRAY_induction]  Theorem
      
      |- !P. (!i f. P (ARRAY i f)) ==> !A. P A
   
   [ARRAY_nchotomy]  Theorem
      
      |- !A. ?i f. A = ARRAY i f
   
   [ArrayDom_defora]  Theorem
      
      [oracles: ArrayDom_defora] [axioms: ] []
      |- ArrayDom a lb ub =
         (if ub <= lb then [] else (a ArrayApp lb)::ArrayDom a (lb + 1) ub)
   
   [MAX_def]  Theorem
      
      |- (MAX [x] = x) /\ (MAX (x::v2::v3) = x max MAX (v2::v3))
   
   [MAX_ind]  Theorem
      
      |- !P.
           P [] /\ (!x. P [x]) /\
           (!x v2 v3. P (v2::v3) ==> P (x::v2::v3)) ==>
           !v. P v
   
   [MIN_def]  Theorem
      
      |- (MIN [x] = x) /\ (MIN (x::v2::v3) = x min MIN (v2::v3))
   
   [MIN_ind]  Theorem
      
      |- !P.
           P [] /\ (!x. P [x]) /\
           (!x v2 v3. P (v2::v3) ==> P (x::v2::v3)) ==>
           !v. P v
   
   
*)
end
