structure x_StdConstTheory :> x_StdConstTheory =
struct
  open Type Term Thm
  infixr -->
  fun C s t ty = mk_thy_const{Name=s,Thy=t,Ty=ty}
  fun T s t A = mk_thy_type{Tyop=s, Thy=t,Args=A}
  fun V s q = mk_var(s,q)
  val U     = mk_vartype
  
  (*  Parents *)
  local open integerTheory listTheory
  in end;
  val _ = Theory.link_parents
          ("x_StdConst",11519139,0)
          [("list",6037691,0), ("integer",6038418,0)];
  val _ = Theory.incorporate_types "x_StdConst" [("ARRAY",1)];
  val _ = Theory.incorporate_consts "x_StdConst"
     [("COUNT",((T"list" "list" [alpha] --> T"int" "integer" []))),
      ("ArrayUpdate",
       ((T"ARRAY" "x_StdConst" [alpha] -->
         (T"int" "integer" [] -->
          (alpha --> T"ARRAY" "x_StdConst" [alpha]))))),
      ("ArrayDom",
       ((T"ARRAY" "x_StdConst" [alpha] -->
         (T"int" "integer" [] -->
          (T"int" "integer" [] --> T"list" "list" [alpha]))))),
      ("ArrayApp",
       ((T"ARRAY" "x_StdConst" [alpha] -->
         (T"int" "integer" [] --> alpha)))),
      ("MIN",
       ((T"list" "list" [T"int" "integer" []] --> T"int" "integer" []))),
      ("MAX",
       ((T"list" "list" [T"int" "integer" []] --> T"int" "integer" []))),
      ("ARRAY",
       ((T"int" "integer" [] -->
         ((T"int" "integer" [] --> alpha) -->
          T"ARRAY" "x_StdConst" [alpha])))),
      ("dest_ARRAY",
       ((T"ARRAY" "x_StdConst" [alpha] -->
         T"recspace" "ind_type"
          [T"prod" "pair"
            [T"int" "integer" [], (T"int" "integer" [] --> alpha)]]))),
      ("SUM_",
       ((T"list" "list" [T"int" "integer" []] --> T"int" "integer" []))),
      ("ARRAY_case",
       (((T"int" "integer" [] -->
          ((T"int" "integer" [] --> alpha) --> beta)) -->
         (T"ARRAY" "x_StdConst" [alpha] --> beta)))),
      ("lprod_",
       ((alpha -->
         (T"list" "list" [beta] -->
          T"list" "list" [T"prod" "pair" [alpha, beta]])))),
      ("APPEND_",
       ((T"list" "list" [alpha] -->
         (T"list" "list" [alpha] --> T"list" "list" [alpha])))),
      ("SQLSELECT",
       (((beta --> alpha) -->
         ((beta --> bool) -->
          (T"list" "list" [beta] --> T"list" "list" [alpha]))))),
      ("MEM_",((alpha --> (T"list" "list" [alpha] --> bool)))),
      ("MAXP",
       ((T"list" "list" [T"int" "integer" []] --> T"int" "integer" []))),
      ("MARKER",((beta --> (alpha --> alpha)))),
      ("LPROD",
       ((T"list" "list" [alpha] -->
         (T"list" "list" [beta] -->
          T"list" "list" [T"prod" "pair" [alpha, beta]])))),
      ("min",
       ((T"int" "integer" [] -->
         (T"int" "integer" [] --> T"int" "integer" [])))),
      ("max",
       ((T"int" "integer" [] -->
         (T"int" "integer" [] --> T"int" "integer" [])))),
      ("FromTo",
       ((T"int" "integer" [] -->
         (T"int" "integer" [] --> (T"int" "integer" [] --> bool))))),
      ("ARRAY_size",
       (((alpha --> T"num" "num" []) -->
         (T"ARRAY" "x_StdConst" [alpha] --> T"num" "num" [])))),
      ("x_StdConst0",
       ((T"int" "integer" [] -->
         ((T"int" "integer" [] --> alpha) -->
          T"ARRAY" "x_StdConst" [alpha])))),
      ("notEqual",((alpha --> (alpha --> bool)))),
      ("mk_ARRAY",
       ((T"recspace" "ind_type"
          [T"prod" "pair"
            [T"int" "integer" [], (T"int" "integer" [] --> alpha)]] -->
         T"ARRAY" "x_StdConst" [alpha]))),
      ("arraySize",
       ((T"ARRAY" "x_StdConst" [alpha] --> T"int" "integer" [])))];
  
  local
  val share_table = Vector.fromList
  [C"!" "bool" (((alpha --> bool) --> bool)), V"a" (alpha), V"b" (alpha),
   C"=" "min" ((bool --> (bool --> bool))),
   C"notEqual" "x_StdConst" ((alpha --> (alpha --> bool))),
   C"~" "bool" ((bool --> bool)),
   C"=" "min" ((alpha --> (alpha --> bool))),
   C"=" "min"
    (((T"int" "integer" [] -->
       (T"int" "integer" [] --> T"int" "integer" [])) -->
      ((T"int" "integer" [] -->
        (T"int" "integer" [] --> T"int" "integer" [])) --> bool))),
   C"max" "x_StdConst"
    ((T"int" "integer" [] -->
      (T"int" "integer" [] --> T"int" "integer" []))),
   C"int_max" "integer"
    ((T"int" "integer" [] -->
      (T"int" "integer" [] --> T"int" "integer" []))),
   C"min" "x_StdConst"
    ((T"int" "integer" [] -->
      (T"int" "integer" [] --> T"int" "integer" []))),
   C"int_min" "integer"
    ((T"int" "integer" [] -->
      (T"int" "integer" [] --> T"int" "integer" []))),
   C"=" "min"
    (((alpha --> (T"list" "list" [alpha] --> bool)) -->
      ((alpha --> (T"list" "list" [alpha] --> bool)) --> bool))),
   C"MEM_" "x_StdConst" ((alpha --> (T"list" "list" [alpha] --> bool))),
   C"MEM" "list" ((alpha --> (T"list" "list" [alpha] --> bool))),
   C"=" "min"
    (((T"list" "list" [alpha] -->
       (T"list" "list" [alpha] --> T"list" "list" [alpha])) -->
      ((T"list" "list" [alpha] -->
        (T"list" "list" [alpha] --> T"list" "list" [alpha])) --> bool))),
   C"APPEND_" "x_StdConst"
    ((T"list" "list" [alpha] -->
      (T"list" "list" [alpha] --> T"list" "list" [alpha]))),
   C"APPEND" "list"
    ((T"list" "list" [alpha] -->
      (T"list" "list" [alpha] --> T"list" "list" [alpha]))),
   C"/\\" "bool" ((bool --> (bool --> bool))),
   C"=" "min" ((T"int" "integer" [] --> (T"int" "integer" [] --> bool))),
   C"SUM_" "x_StdConst"
    ((T"list" "list" [T"int" "integer" []] --> T"int" "integer" [])),
   C"NIL" "list" (T"list" "list" [T"int" "integer" []]),
   C"int_of_num" "integer" ((T"num" "num" [] --> T"int" "integer" [])),
   C"0" "num" (T"num" "num" []),
   C"!" "bool" (((T"int" "integer" [] --> bool) --> bool)),
   V"x" (T"int" "integer" []),
   C"!" "bool"
    (((T"list" "list" [T"int" "integer" []] --> bool) --> bool)),
   V"s" (T"list" "list" [T"int" "integer" []]),
   C"CONS" "list"
    ((T"int" "integer" [] -->
      (T"list" "list" [T"int" "integer" []] -->
       T"list" "list" [T"int" "integer" []]))),
   C"int_add" "integer"
    ((T"int" "integer" [] -->
      (T"int" "integer" [] --> T"int" "integer" []))),
   C"COUNT" "x_StdConst"
    ((T"list" "list" [alpha] --> T"int" "integer" [])),
   C"NIL" "list" (T"list" "list" [alpha]), V"x" (alpha),
   C"!" "bool" (((T"list" "list" [alpha] --> bool) --> bool)),
   V"s" (T"list" "list" [alpha]),
   C"CONS" "list"
    ((alpha --> (T"list" "list" [alpha] --> T"list" "list" [alpha]))),
   C"NUMERAL" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"NUMERAL_BIT1" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"ALT_ZERO" "arithmetic" (T"num" "num" []),
   C"=" "min"
    (((T"list" "list" [T"int" "integer" []] --> T"int" "integer" []) -->
      ((T"list" "list" [T"int" "integer" []] --> T"int" "integer" []) -->
       bool))),
   C"MAX" "x_StdConst"
    ((T"list" "list" [T"int" "integer" []] --> T"int" "integer" [])),
   C"WFREC" "relation"
    (((T"list" "list" [T"int" "integer" []] -->
       (T"list" "list" [T"int" "integer" []] --> bool)) -->
      (((T"list" "list" [T"int" "integer" []] --> T"int" "integer" []) -->
        (T"list" "list" [T"int" "integer" []] --> T"int" "integer" [])) -->
       (T"list" "list" [T"int" "integer" []] --> T"int" "integer" [])))),
   C"@" "min"
    ((((T"list" "list" [T"int" "integer" []] -->
        (T"list" "list" [T"int" "integer" []] --> bool)) --> bool) -->
      (T"list" "list" [T"int" "integer" []] -->
       (T"list" "list" [T"int" "integer" []] --> bool)))),
   V"R"
    ((T"list" "list" [T"int" "integer" []] -->
      (T"list" "list" [T"int" "integer" []] --> bool))),
   C"WF" "relation"
    (((T"list" "list" [T"int" "integer" []] -->
       (T"list" "list" [T"int" "integer" []] --> bool)) --> bool)),
   V"v3" (T"list" "list" [T"int" "integer" []]),
   V"v2" (T"int" "integer" []),
   V"MAX'"
    ((T"list" "list" [T"int" "integer" []] --> T"int" "integer" [])),
   V"a" (T"list" "list" [T"int" "integer" []]),
   C"list_case" "list"
    ((T"int" "integer" [] -->
      ((T"int" "integer" [] -->
        (T"list" "list" [T"int" "integer" []] --> T"int" "integer" [])) -->
       (T"list" "list" [T"int" "integer" []] --> T"int" "integer" [])))),
   C"ARB" "bool" (T"int" "integer" []), V"v" (T"int" "integer" []),
   V"v1" (T"list" "list" [T"int" "integer" []]),
   V"v4" (T"int" "integer" []),
   V"v5" (T"list" "list" [T"int" "integer" []]),
   C"MIN" "x_StdConst"
    ((T"list" "list" [T"int" "integer" []] --> T"int" "integer" [])),
   V"MIN'"
    ((T"list" "list" [T"int" "integer" []] --> T"int" "integer" [])),
   C"MAXP" "x_StdConst"
    ((T"list" "list" [T"int" "integer" []] --> T"int" "integer" [])),
   C"?" "bool"
    ((((T"ARRAY" "x_StdConst" [alpha] -->
        T"recspace" "ind_type"
         [T"prod" "pair"
           [T"int" "integer" [], (T"int" "integer" [] --> alpha)]]) -->
       bool) --> bool)),
   V"rep"
    ((T"ARRAY" "x_StdConst" [alpha] -->
      T"recspace" "ind_type"
       [T"prod" "pair"
         [T"int" "integer" [], (T"int" "integer" [] --> alpha)]])),
   C"TYPE_DEFINITION" "bool"
    (((T"recspace" "ind_type"
        [T"prod" "pair"
          [T"int" "integer" [], (T"int" "integer" [] --> alpha)]] --> bool)
      -->
      ((T"ARRAY" "x_StdConst" [alpha] -->
        T"recspace" "ind_type"
         [T"prod" "pair"
           [T"int" "integer" [], (T"int" "integer" [] --> alpha)]]) -->
       bool))),
   V"a0'"
    (T"recspace" "ind_type"
      [T"prod" "pair"
        [T"int" "integer" [], (T"int" "integer" [] --> alpha)]]),
   C"!" "bool"
    ((((T"recspace" "ind_type"
         [T"prod" "pair"
           [T"int" "integer" [], (T"int" "integer" [] --> alpha)]] -->
        bool) --> bool) --> bool)),
   V"'ARRAY'"
    ((T"recspace" "ind_type"
       [T"prod" "pair"
         [T"int" "integer" [], (T"int" "integer" [] --> alpha)]] -->
      bool)), C"==>" "min" ((bool --> (bool --> bool))),
   C"!" "bool"
    (((T"recspace" "ind_type"
        [T"prod" "pair"
          [T"int" "integer" [], (T"int" "integer" [] --> alpha)]] --> bool)
      --> bool)), C"?" "bool" (((T"int" "integer" [] --> bool) --> bool)),
   V"a0" (T"int" "integer" []),
   C"?" "bool" ((((T"int" "integer" [] --> alpha) --> bool) --> bool)),
   V"a1" ((T"int" "integer" [] --> alpha)),
   C"=" "min"
    ((T"recspace" "ind_type"
       [T"prod" "pair"
         [T"int" "integer" [], (T"int" "integer" [] --> alpha)]] -->
      (T"recspace" "ind_type"
        [T"prod" "pair"
          [T"int" "integer" [], (T"int" "integer" [] --> alpha)]] -->
       bool))),
   C"CONSTR" "ind_type"
    ((T"num" "num" [] -->
      (T"prod" "pair"
        [T"int" "integer" [], (T"int" "integer" [] --> alpha)] -->
       ((T"num" "num" [] -->
         T"recspace" "ind_type"
          [T"prod" "pair"
            [T"int" "integer" [], (T"int" "integer" [] --> alpha)]]) -->
        T"recspace" "ind_type"
         [T"prod" "pair"
           [T"int" "integer" [], (T"int" "integer" [] --> alpha)]])))),
   C"," "pair"
    ((T"int" "integer" [] -->
      ((T"int" "integer" [] --> alpha) -->
       T"prod" "pair"
        [T"int" "integer" [], (T"int" "integer" [] --> alpha)]))),
   V"n" (T"num" "num" []),
   C"BOTTOM" "ind_type"
    (T"recspace" "ind_type"
      [T"prod" "pair"
        [T"int" "integer" [], (T"int" "integer" [] --> alpha)]]),
   C"!" "bool" (((T"ARRAY" "x_StdConst" [alpha] --> bool) --> bool)),
   V"a" (T"ARRAY" "x_StdConst" [alpha]),
   C"=" "min"
    ((T"ARRAY" "x_StdConst" [alpha] -->
      (T"ARRAY" "x_StdConst" [alpha] --> bool))),
   C"mk_ARRAY" "x_StdConst"
    ((T"recspace" "ind_type"
       [T"prod" "pair"
         [T"int" "integer" [], (T"int" "integer" [] --> alpha)]] -->
      T"ARRAY" "x_StdConst" [alpha])),
   C"dest_ARRAY" "x_StdConst"
    ((T"ARRAY" "x_StdConst" [alpha] -->
      T"recspace" "ind_type"
       [T"prod" "pair"
         [T"int" "integer" [], (T"int" "integer" [] --> alpha)]])),
   V"r"
    (T"recspace" "ind_type"
      [T"prod" "pair"
        [T"int" "integer" [], (T"int" "integer" [] --> alpha)]]),
   C"=" "min"
    (((T"int" "integer" [] -->
       ((T"int" "integer" [] --> alpha) --> T"ARRAY" "x_StdConst" [alpha]))
      -->
      ((T"int" "integer" [] -->
        ((T"int" "integer" [] --> alpha) -->
         T"ARRAY" "x_StdConst" [alpha])) --> bool))),
   C"x_StdConst0" "x_StdConst"
    ((T"int" "integer" [] -->
      ((T"int" "integer" [] --> alpha) -->
       T"ARRAY" "x_StdConst" [alpha]))),
   C"ARRAY" "x_StdConst"
    ((T"int" "integer" [] -->
      ((T"int" "integer" [] --> alpha) -->
       T"ARRAY" "x_StdConst" [alpha]))),
   C"!" "bool"
    ((((T"int" "integer" [] --> ((T"int" "integer" [] --> alpha) --> beta))
       --> bool) --> bool)),
   V"f"
    ((T"int" "integer" [] --> ((T"int" "integer" [] --> alpha) --> beta))),
   C"!" "bool" ((((T"int" "integer" [] --> alpha) --> bool) --> bool)),
   C"=" "min" ((beta --> (beta --> bool))),
   C"ARRAY_case" "x_StdConst"
    (((T"int" "integer" [] --> ((T"int" "integer" [] --> alpha) --> beta))
      --> (T"ARRAY" "x_StdConst" [alpha] --> beta))),
   C"!" "bool" ((((alpha --> T"num" "num" []) --> bool) --> bool)),
   V"f" ((alpha --> T"num" "num" [])),
   C"=" "min" ((T"num" "num" [] --> (T"num" "num" [] --> bool))),
   C"ARRAY_size" "x_StdConst"
    (((alpha --> T"num" "num" []) -->
      (T"ARRAY" "x_StdConst" [alpha] --> T"num" "num" []))),
   V"n" (T"int" "integer" []), V"c" ((T"int" "integer" [] --> alpha)),
   C"arraySize" "x_StdConst"
    ((T"ARRAY" "x_StdConst" [alpha] --> T"int" "integer" [])),
   V"i" (T"int" "integer" []),
   C"ArrayApp" "x_StdConst"
    ((T"ARRAY" "x_StdConst" [alpha] --> (T"int" "integer" [] --> alpha))),
   C"ArrayUpdate" "x_StdConst"
    ((T"ARRAY" "x_StdConst" [alpha] -->
      (T"int" "integer" [] -->
       (alpha --> T"ARRAY" "x_StdConst" [alpha])))),
   V"j" (T"int" "integer" []),
   C"COND" "bool" ((bool --> (alpha --> (alpha --> alpha)))),
   V"left" (T"int" "integer" []), V"right" (T"int" "integer" []),
   C"FromTo" "x_StdConst"
    ((T"int" "integer" [] -->
      (T"int" "integer" [] --> (T"int" "integer" [] --> bool)))),
   C"int_le" "integer"
    ((T"int" "integer" [] --> (T"int" "integer" [] --> bool))),
   C"int_lt" "integer"
    ((T"int" "integer" [] --> (T"int" "integer" [] --> bool))),
   C"!" "bool" (((beta --> bool) --> bool)), V"info" (beta),
   C"MARKER" "x_StdConst" ((beta --> (alpha --> alpha))),
   C"=" "min"
    ((T"list" "list" [T"prod" "pair" [alpha, beta]] -->
      (T"list" "list" [T"prod" "pair" [alpha, beta]] --> bool))),
   C"lprod_" "x_StdConst"
    ((alpha -->
      (T"list" "list" [beta] -->
       T"list" "list" [T"prod" "pair" [alpha, beta]]))),
   C"NIL" "list" (T"list" "list" [beta]),
   C"NIL" "list" (T"list" "list" [T"prod" "pair" [alpha, beta]]),
   V"y" (beta), C"!" "bool" (((T"list" "list" [beta] --> bool) --> bool)),
   V"t" (T"list" "list" [beta]),
   C"CONS" "list"
    ((beta --> (T"list" "list" [beta] --> T"list" "list" [beta]))),
   C"CONS" "list"
    ((T"prod" "pair" [alpha, beta] -->
      (T"list" "list" [T"prod" "pair" [alpha, beta]] -->
       T"list" "list" [T"prod" "pair" [alpha, beta]]))),
   C"," "pair" ((alpha --> (beta --> T"prod" "pair" [alpha, beta]))),
   C"LPROD" "x_StdConst"
    ((T"list" "list" [alpha] -->
      (T"list" "list" [beta] -->
       T"list" "list" [T"prod" "pair" [alpha, beta]]))),
   C"APPEND" "list"
    ((T"list" "list" [T"prod" "pair" [alpha, beta]] -->
      (T"list" "list" [T"prod" "pair" [alpha, beta]] -->
       T"list" "list" [T"prod" "pair" [alpha, beta]]))),
   C"!" "bool" ((((beta --> alpha) --> bool) --> bool)),
   V"f" ((beta --> alpha)),
   C"!" "bool" ((((beta --> bool) --> bool) --> bool)),
   V"p" ((beta --> bool)), V"joined_databases" (T"list" "list" [beta]),
   C"=" "min"
    ((T"list" "list" [alpha] --> (T"list" "list" [alpha] --> bool))),
   C"SQLSELECT" "x_StdConst"
    (((beta --> alpha) -->
      ((beta --> bool) -->
       (T"list" "list" [beta] --> T"list" "list" [alpha])))),
   C"MAP" "list"
    (((beta --> alpha) -->
      (T"list" "list" [beta] --> T"list" "list" [alpha]))),
   C"FILTER" "list"
    (((beta --> bool) -->
      (T"list" "list" [beta] --> T"list" "list" [beta]))),
   C"!" "bool"
    ((((T"list" "list" [T"int" "integer" []] --> bool) --> bool) -->
      bool)), V"P" ((T"list" "list" [T"int" "integer" []] --> bool)),
   V"v" (T"list" "list" [T"int" "integer" []]),
   V"a0'" (T"int" "integer" []), V"a1'" ((T"int" "integer" [] --> alpha)),
   C"=" "min"
    (((T"int" "integer" [] --> alpha) -->
      ((T"int" "integer" [] --> alpha) --> bool))),
   V"M" (T"ARRAY" "x_StdConst" [alpha]),
   V"M'" (T"ARRAY" "x_StdConst" [alpha]),
   V"f'"
    ((T"int" "integer" [] --> ((T"int" "integer" [] --> alpha) --> beta))),
   V"A" (T"ARRAY" "x_StdConst" [alpha]),
   V"f" ((T"int" "integer" [] --> alpha)),
   C"?" "bool"
    ((((T"ARRAY" "x_StdConst" [alpha] --> beta) --> bool) --> bool)),
   V"fn" ((T"ARRAY" "x_StdConst" [alpha] --> beta)),
   C"!" "bool"
    ((((T"ARRAY" "x_StdConst" [alpha] --> bool) --> bool) --> bool)),
   V"P" ((T"ARRAY" "x_StdConst" [alpha] --> bool)),
   C"ArrayDom" "x_StdConst"
    ((T"ARRAY" "x_StdConst" [alpha] -->
      (T"int" "integer" [] -->
       (T"int" "integer" [] --> T"list" "list" [alpha])))),
   V"lb" (T"int" "integer" []), V"ub" (T"int" "integer" []),
   C"COND" "bool"
    ((bool -->
      (T"list" "list" [alpha] -->
       (T"list" "list" [alpha] --> T"list" "list" [alpha]))))]
  val DT = Thm.disk_thm share_table
  in
  val notEqual_def =
    DT("", [],
       `(%0 (\%1. (%0 (\%2. ((%3 ((%4 $1) $0)) (%5 ((%6 $1) $0)))))))`)
  val max_def = DT("", [], `((%7 %8) %9)`)
  val min_def = DT("", [], `((%7 %10) %11)`)
  val MEM__def = DT("", [], `((%12 %13) %14)`)
  val APPEND__def = DT("", [], `((%15 %16) %17)`)
  val SUM__def =
    DT("", [],
       `((%18 ((%19 (%20 %21)) (%22 %23))) (%24 (\%25. (%26 (\%27. ((%19
       (%20 ((%28 $1) $0))) ((%29 $1) (%20 $0))))))))`)
  val COUNT_def =
    DT("", [],
       `((%18 ((%19 (%30 %31)) (%22 %23))) (%0 (\%32. (%33 (\%34. ((%19
       (%30 ((%35 $1) $0))) ((%29 (%22 (%36 (%37 %38)))) (%30 $0))))))))`)
  val MAX_primitive_def =
    DT("", [],
       `((%39 %40) ((%41 (%42 (\%43. ((%18 (%44 $0)) (%24 (\%25. (%26
       (\%45. (%24 (\%46. (($3 ((%28 $0) $1)) ((%28 $2) ((%28 $0)
       $1))))))))))))) (\%47. (\%48. (((%49 %50) (\%51. (\%52. (((%49 $1)
       (\%53. (\%54. ((%8 $3) ($5 ((%28 $1) $0)))))) $0)))) $0)))))`)
  val MIN_primitive_def =
    DT("", [],
       `((%39 %55) ((%41 (%42 (\%43. ((%18 (%44 $0)) (%24 (\%25. (%26
       (\%45. (%24 (\%46. (($3 ((%28 $0) $1)) ((%28 $2) ((%28 $0)
       $1))))))))))))) (\%56. (\%48. (((%49 %50) (\%51. (\%52. (((%49 $1)
       (\%53. (\%54. ((%10 $3) ($5 ((%28 $1) $0)))))) $0)))) $0)))))`)
  val MAXP_def =
    DT("", [],
       `((%18 ((%19 (%57 %21)) (%22 %23))) (%24 (\%25. (%26 (\%27. ((%19
       (%57 ((%28 $1) $0))) ((%8 $1) (%57 $0))))))))`)
  val ARRAY_TY_DEF =
    DT("", [],
       `(%58 (\%59. ((%60 (\%61. (%62 (\%63. ((%64 (%65 (\%61. ((%64 (%66
       (\%67. (%68 (\%69. ((%70 $2) (((\%67. (\%69. (((%71 %23) ((%72 $1)
       $0)) (\%73. %74)))) $1) $0))))))) ($1 $0))))) ($0 $1)))))) $0)))`)
  val ARRAY_repfns =
    DT("", [],
       `((%18 (%75 (\%76. ((%77 (%78 (%79 $0))) $0)))) (%65 (\%80. ((%3
       ((\%61. (%62 (\%63. ((%64 (%65 (\%61. ((%64 (%66 (\%67. (%68 (\%69.
       ((%70 $2) (((\%67. (\%69. (((%71 %23) ((%72 $1) $0)) (\%73. %74))))
       $1) $0))))))) ($1 $0))))) ($0 $1))))) $0)) ((%70 (%79 (%78 $0)))
       $0)))))`)
  val x_StdConst0_def =
    DT("", [],
       `((%81 %82) (\%67. (\%69. (%78 (((\%67. (\%69. (((%71 %23) ((%72 $1)
       $0)) (\%73. %74)))) $1) $0)))))`)
  val ARRAY = DT("", [], `((%81 %83) %82)`)
  val ARRAY_case_def =
    DT("", [],
       `(%84 (\%85. (%24 (\%67. (%86 (\%69. ((%87 ((%88 $2) ((%83 $1) $0)))
       (($2 $1) $0))))))))`)
  val ARRAY_size_def =
    DT("", [],
       `(%89 (\%90. (%24 (\%67. (%86 (\%69. ((%91 ((%92 $2) ((%83 $1) $0)))
       (%36 (%37 %38)))))))))`)
  val arraySize_def =
    DT("", [],
       `(%24 (\%93. (%86 (\%94. ((%19 (%95 ((%83 $1) $0))) $1)))))`)
  val ArrayApp_def =
    DT("", [],
       `(%24 (\%93. (%86 (\%94. (%24 (\%96. ((%6 ((%97 ((%83 $2) $1)) $0))
       ($1 $0))))))))`)
  val ArrayUpdate_def =
    DT("", [],
       `(%24 (\%93. (%86 (\%94. (%24 (\%96. (%0 (\%32. ((%77 (((%98 ((%83
       $3) $2)) $1) $0)) ((%83 $3) (\%99. (((%100 ((%19 $0) $2)) $1) ($3
       $0)))))))))))))`)
  val FromTo_def =
    DT("", [],
       `(%24 (\%96. (%24 (\%101. (%24 (\%102. ((%3 (((%103 $2) $1) $0))
       ((%18 ((%104 $1) $2)) ((%105 $2) $0)))))))))`)
  val MARKER_def =
    DT("", [], `(%106 (\%107. (%0 (\%32. ((%6 ((%108 $1) $0)) $0)))))`)
  val lprod__def =
    DT("", [],
       `((%18 (%0 (\%32. ((%109 ((%110 $0) %111)) %112)))) (%0 (\%32. (%106
       (\%113. (%114 (\%115. ((%109 ((%110 $2) ((%116 $1) $0))) ((%117
       ((%118 $2) $1)) ((%110 $2) $0))))))))))`)
  val LPROD_def =
    DT("", [],
       `((%18 (%114 (\%115. ((%109 ((%119 %31) $0)) %112)))) (%0 (\%32.
       (%33 (\%34. (%114 (\%115. ((%109 ((%119 ((%35 $2) $1)) $0)) ((%120
       ((%110 $2) $0)) ((%119 $1) $0))))))))))`)
  val SQLSELECT_def =
    DT("", [],
       `(%121 (\%122. (%123 (\%124. (%114 (\%125. ((%126 (((%127 $2) $1)
       $0)) ((%128 $2) ((%129 $1) $0)))))))))`)
  val MAX_ind =
    DT("", [],
       `(%130 (\%131. ((%64 ((%18 ($0 %21)) ((%18 (%24 (\%25. ($1 ((%28 $0)
       %21))))) (%24 (\%25. (%24 (\%46. (%26 (\%45. ((%64 ($3 ((%28 $1)
       $0))) ($3 ((%28 $2) ((%28 $1) $0))))))))))))) (%26 (\%132. ($1
       $0))))))`)
  val MAX_def =
    DT("", [],
       `((%18 ((%19 (%40 ((%28 %25) %21))) %25)) ((%19 (%40 ((%28 %25)
       ((%28 %46) %45)))) ((%8 %25) (%40 ((%28 %46) %45)))))`)
  val MIN_ind =
    DT("", [],
       `(%130 (\%131. ((%64 ((%18 ($0 %21)) ((%18 (%24 (\%25. ($1 ((%28 $0)
       %21))))) (%24 (\%25. (%24 (\%46. (%26 (\%45. ((%64 ($3 ((%28 $1)
       $0))) ($3 ((%28 $2) ((%28 $1) $0))))))))))))) (%26 (\%132. ($1
       $0))))))`)
  val MIN_def =
    DT("", [],
       `((%18 ((%19 (%55 ((%28 %25) %21))) %25)) ((%19 (%55 ((%28 %25)
       ((%28 %46) %45)))) ((%10 %25) (%55 ((%28 %46) %45)))))`)
  val ARRAY_11 =
    DT("", [],
       `(%24 (\%67. (%86 (\%69. (%24 (\%133. (%86 (\%134. ((%3 ((%77 ((%83
       $3) $2)) ((%83 $1) $0))) ((%18 ((%19 $3) $1)) ((%135 $2)
       $0)))))))))))`)
  val ARRAY_case_cong =
    DT("", [],
       `(%75 (\%136. (%75 (\%137. (%84 (\%85. ((%64 ((%18 ((%77 $2) $1))
       (%24 (\%67. (%86 (\%69. ((%64 ((%77 $3) ((%83 $1) $0))) ((%87 (($2
       $1) $0)) ((%138 $1) $0))))))))) ((%87 ((%88 $0) $2)) ((%88 %138)
       $1)))))))))`)
  val ARRAY_nchotomy =
    DT("", [],
       `(%75 (\%139. (%66 (\%96. (%68 (\%140. ((%77 $2) ((%83 $1)
       $0))))))))`)
  val ARRAY_Axiom =
    DT("", [],
       `(%84 (\%85. (%141 (\%142. (%24 (\%67. (%86 (\%69. ((%87 ($2 ((%83
       $1) $0))) (($3 $1) $0))))))))))`)
  val ARRAY_induction =
    DT("", [],
       `(%143 (\%144. ((%64 (%24 (\%96. (%86 (\%140. ($2 ((%83 $1)
       $0))))))) (%75 (\%139. ($1 $0))))))`)
  val ArrayDom_defora =
    DT("ArrayDom_defora", [],
       `((%126 (((%145 %76) %146) %147)) (((%148 ((%104 %147) %146)) %31)
       ((%35 ((%97 %76) %146)) (((%145 %76) ((%29 %146) (%22 (%36 (%37
       %38))))) %147))))`)
  end
  val _ = DB.bindl "x_StdConst"
  [("notEqual_def",notEqual_def,DB.Def), ("max_def",max_def,DB.Def),
   ("min_def",min_def,DB.Def), ("MEM__def",MEM__def,DB.Def),
   ("APPEND__def",APPEND__def,DB.Def), ("SUM__def",SUM__def,DB.Def),
   ("COUNT_def",COUNT_def,DB.Def),
   ("MAX_primitive_def",MAX_primitive_def,DB.Def),
   ("MIN_primitive_def",MIN_primitive_def,DB.Def),
   ("MAXP_def",MAXP_def,DB.Def), ("ARRAY_TY_DEF",ARRAY_TY_DEF,DB.Def),
   ("ARRAY_repfns",ARRAY_repfns,DB.Def),
   ("x_StdConst0_def",x_StdConst0_def,DB.Def), ("ARRAY",ARRAY,DB.Def),
   ("ARRAY_case_def",ARRAY_case_def,DB.Def),
   ("ARRAY_size_def",ARRAY_size_def,DB.Def),
   ("arraySize_def",arraySize_def,DB.Def),
   ("ArrayApp_def",ArrayApp_def,DB.Def),
   ("ArrayUpdate_def",ArrayUpdate_def,DB.Def),
   ("FromTo_def",FromTo_def,DB.Def), ("MARKER_def",MARKER_def,DB.Def),
   ("lprod__def",lprod__def,DB.Def), ("LPROD_def",LPROD_def,DB.Def),
   ("SQLSELECT_def",SQLSELECT_def,DB.Def), ("MAX_ind",MAX_ind,DB.Thm),
   ("MAX_def",MAX_def,DB.Thm), ("MIN_ind",MIN_ind,DB.Thm),
   ("MIN_def",MIN_def,DB.Thm), ("ARRAY_11",ARRAY_11,DB.Thm),
   ("ARRAY_case_cong",ARRAY_case_cong,DB.Thm),
   ("ARRAY_nchotomy",ARRAY_nchotomy,DB.Thm),
   ("ARRAY_Axiom",ARRAY_Axiom,DB.Thm),
   ("ARRAY_induction",ARRAY_induction,DB.Thm),
   ("ArrayDom_defora",ArrayDom_defora,DB.Thm)]
  
  local open Portable GrammarSpecials Parse
  in
  val _ = mk_local_grms [("listTheory.list_grammars",
                          listTheory.list_grammars),
                         ("integerTheory.integer_grammars",
                          integerTheory.integer_grammars)]
  val _ = List.app (update_grms reveal) []
  val _ = update_grms
       (temp_overload_on_by_nametype "notEqual")
        {Name = "notEqual", Thy = "x_StdConst"}
  val _ = update_grms
       (temp_overload_on_by_nametype "max")
        {Name = "max", Thy = "x_StdConst"}
  val _ = update_grms
       (temp_overload_on_by_nametype "min")
        {Name = "min", Thy = "x_StdConst"}
  val _ = update_grms
       (temp_overload_on_by_nametype "MEM_")
        {Name = "MEM_", Thy = "x_StdConst"}
  val _ = update_grms
       (temp_overload_on_by_nametype "APPEND_")
        {Name = "APPEND_", Thy = "x_StdConst"}
  val _ = update_grms
       temp_add_infix
       ("notEqual", 100, HOLgrammars.NONASSOC)
  val _ = update_grms temp_add_infix ("max", 300, HOLgrammars.RIGHT)
  val _ = update_grms temp_add_infix ("min", 300, HOLgrammars.RIGHT)
  val _ = update_grms temp_add_infix ("MEM_", 100, HOLgrammars.NONASSOC)
  val _ = update_grms temp_add_infix ("APPEND_", 110, HOLgrammars.RIGHT)
  val _ = update_grms
       (temp_overload_on_by_nametype "SUM_")
        {Name = "SUM_", Thy = "x_StdConst"}
  val _ = update_grms
       (temp_overload_on_by_nametype "COUNT")
        {Name = "COUNT", Thy = "x_StdConst"}
  val _ = update_grms
       (temp_overload_on_by_nametype "MAX")
        {Name = "MAX", Thy = "x_StdConst"}
  val _ = update_grms
       (temp_overload_on_by_nametype "MIN")
        {Name = "MIN", Thy = "x_StdConst"}
  val _ = update_grms
       (temp_overload_on_by_nametype "MAXP")
        {Name = "MAXP", Thy = "x_StdConst"}
  val _ = update_grms temp_add_type "ARRAY"
  val _ = update_grms
       (temp_overload_on_by_nametype "mk_ARRAY")
        {Name = "mk_ARRAY", Thy = "x_StdConst"}
  val _ = update_grms
       (temp_overload_on_by_nametype "dest_ARRAY")
        {Name = "dest_ARRAY", Thy = "x_StdConst"}
  val _ = update_grms
       (temp_overload_on_by_nametype "x_StdConst0")
        {Name = "x_StdConst0", Thy = "x_StdConst"}
  val _ = update_grms
       (temp_overload_on_by_nametype "ARRAY")
        {Name = "ARRAY", Thy = "x_StdConst"}
  val _ = update_grms
       (temp_overload_on_by_nametype "ARRAY_case")
        {Name = "ARRAY_case", Thy = "x_StdConst"}
  val _ = update_grms
       (temp_overload_on_by_nametype "ARRAY_size")
        {Name = "ARRAY_size", Thy = "x_StdConst"}
  val _ = update_grms
       (temp_overload_on_by_nametype "case")
        {Name = "ARRAY_case", Thy = "x_StdConst"}
  val _ = update_grms
       (temp_overload_on_by_nametype "arraySize")
        {Name = "arraySize", Thy = "x_StdConst"}
  val _ = update_grms
       (temp_overload_on_by_nametype "ArrayApp")
        {Name = "ArrayApp", Thy = "x_StdConst"}
  val _ = update_grms temp_add_infix ("ArrayApp", 310, HOLgrammars.LEFT)
  val _ = update_grms
       (temp_overload_on_by_nametype "ArrayUpdate")
        {Name = "ArrayUpdate", Thy = "x_StdConst"}
  val _ = update_grms
       (temp_overload_on_by_nametype "FromTo")
        {Name = "FromTo", Thy = "x_StdConst"}
  val _ = update_grms
       (temp_overload_on_by_nametype "ArrayDom")
        {Name = "ArrayDom", Thy = "x_StdConst"}
  val _ = update_grms
       (temp_overload_on_by_nametype "MARKER")
        {Name = "MARKER", Thy = "x_StdConst"}
  val _ = update_grms
       (temp_overload_on_by_nametype "lprod_")
        {Name = "lprod_", Thy = "x_StdConst"}
  val _ = update_grms
       (temp_overload_on_by_nametype "LPROD")
        {Name = "LPROD", Thy = "x_StdConst"}
  val _ = update_grms temp_add_infix ("LPROD", 110, HOLgrammars.RIGHT)
  val _ = update_grms
       (temp_overload_on_by_nametype "SQLSELECT")
        {Name = "SQLSELECT", Thy = "x_StdConst"}
  val x_StdConst_grammars = Parse.current_lgrms()
  end
  
  
  val _ = computeLib.add_funs [notEqual_def];  
  
  val _ = computeLib.add_funs [max_def];  
  
  val _ = computeLib.add_funs [min_def];  
  
  val _ = computeLib.add_funs [MEM__def];  
  
  val _ = computeLib.add_funs [APPEND__def];  
  
  val _ = computeLib.add_funs [SUM__def];  
  
  val _ = computeLib.add_funs [COUNT_def];  
  
  val _ = computeLib.add_funs [MAX_def];  
  
  val _ = computeLib.add_funs [MIN_def];  
  
  val _ = computeLib.add_funs [MAXP_def];  
  
  val _ =
     let open TypeBasePure 
         val tyinfo0 = mk_tyinfo
          {ax=ORIG ARRAY_Axiom,
           case_def=ARRAY_case_def,
           case_cong=ARRAY_case_cong,
           induction=ORIG ARRAY_induction,
           nchotomy=ARRAY_nchotomy,
           size=SOME(Parse.Term`(ARRAY_size) :('a -> num) -> 'a ARRAY -> num`,
                     ORIG ARRAY_size_def),
           boolify = NONE,
  
           one_one=SOME ARRAY_11,
           distinct=NONE}
     in
      TypeBase.write  tyinfo0;
      computeLib.write_datatype_info tyinfo0
     end;
  
  
  val _ = computeLib.add_funs [arraySize_def];  
  
  val _ = computeLib.add_funs [ArrayApp_def];  
  
  val _ = computeLib.add_funs [ArrayUpdate_def];  
  
  val _ = computeLib.add_funs [FromTo_def];  
  
  val _ = computeLib.add_funs [MARKER_def];  
  
  val _ = computeLib.add_funs [lprod__def];  
  
  val _ = computeLib.add_funs [LPROD_def];  
  
  val _ = computeLib.add_funs [SQLSELECT_def];  
end
