(* //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.2
-- //
-- //======================================================================== *)
(* // *)
local 
open Parse HolKernel boolLib bossLib x_StdConstTheory x_ArrayTheory
in

(* List of pseudo constants *)

val xmech_pseudo_consts_defs 
	=
	[notEqual_def
	,max_def
	,min_def
	,MEM__def
	,APPEND__def
	,FromTo_def
	] ;

val ArrayDom_def = ArrayDom_defora ;
  
val array_thms
	=
	[ArrayUpdate_thm1
	,ArrayUpdate_thm2
	,SizeOf_ArrayUpdate_thm
	,ArrayDom_thm1
	,ArrayDom_thm2
	,ArrayDom_thm3
	,ArrayDom_ora4
	] ;
	
val REMOVE_MARKER_TAC = REWRITE_TAC [MARKER_def] ;
val REMOVE_PSEUDO_CONST_TAC = REWRITE_TAC xmech_pseudo_consts_defs  ;
val RW_ARRAY_TAC = RW_TAC std_ss array_thms ;

end
