-------------------------------------------------------------------------------
--
--   *** The Helium Compiler : Static Analysis ***
--               ( Bastiaan Heeren )
--
-- Utils.hs : Utility functions
--
-------------------------------------------------------------------------------

module Utils where

import ST

internalError :: String -> String -> String -> a
internalError moduleName functionName message =
   error . unlines $
           [ ""
           , "INTERNAL ERROR - " ++ message
           , "** Module   : " ++ moduleName
           , "** Function : " ++ functionName
           ]

doubleSizeOfSTArray :: a -> STArray state Int a -> ST state (STArray state Int a)
doubleSizeOfSTArray unit starray = 
   do let (lower,upper) = boundsSTArray starray
      newarray <- newSTArray (lower,2 * upper - lower) unit
      let f i = do value <- readSTArray starray i            
                   writeSTArray newarray i value
      mapM_ f [lower..upper]
      return newarray
