-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.2
-- //
-- //===========================================================================
-- //
module Configuration.DefaultEXPRconsts

where

import PrimitiveConcepts.LC

--
-- This file lists the default constants of EXPR,
-- and specifies their types, fixity, and translation
-- to the back-end prover (so far this back-end prover
-- is HOL).
--

prefixes =
	[ ("sum"	,"[Int]->Int"		,"SUM_"),
	  ("cnt"	,"[a]->Int"		,"COUNT"),
	  ("maximum"	,"[Int]->Int"		,"MAX"),
	  ("minimum"	,"[Int]->Int"		,"MIN"),
	  ("maximump"	,"[Int]->Int"		,"MAXP")
	]

unaries =
	[
	  ("~"		,"Bool->Bool"		,"~"),
	  ("#"		,"a[]->Int"		,"arraySize")
	]

infixes =
	[ ("="		,"a->a->Bool"	,NonAssoc 0	,"="),
	  ("<>"		,"a->a->Bool"	,NonAssoc 0	,"notEqual"),

	  ("==>"	,"Bool->Bool->Bool"	,Righty	10	,"==>"),
	  ("\\/"	,"Bool->Bool->Bool"	,Righty	20	,"\\/"),
	  ("/\\"	,"Bool->Bool->Bool"	,Righty 30	,"/\\"),

  	  ("in"		,"a->[a]->Bool"	,NonAssoc 100	,"MEM_"),
	  ("++"		,"[a]->[a]->[a]"	,Righty	110	,"APPEND_"),
	  (":"		,"a->[a]->[a]"	,Righty	120	,"::"),

	  ("<"		,"Int->Int->Bool"	,NonAssoc 210	,"<"),
	  ("<="		,"Int->Int->Bool"	,NonAssoc 210	,"<="),
	  (">"		,"Int->Int->Bool"	,NonAssoc 210	,">"),
	  (">="		,"Int->Int->Bool"	,NonAssoc 210	,">="),

	  ("+"		,"Int->Int->Int"	,Righty	310	,"+"),
	  ("-"		,"Int->Int->Int"	,Lefty	310	,"-"),
	  ("*"		,"Int->Int->Int"	,Righty	320	,"*"),
	  ("/"		,"Int->Int->Int"	,Lefty	320	,"/"),

	  ("max"	,"Int->Int->Int"	,Righty	300	,"max"),
	  ("min"	,"Int->Int->Int"	,Righty	300	,"min"),
	  ("mod"	,"Int->Int->Int"	,NonAssoc 300	,"%"),
	  ("div"	,"Int->Int->Int"	,NonAssoc 300	,"/")
	]

quantors =
	[ ("!"		,"Bool->Bool"	,"!"),
	  ("?"		,"Bool->Bool"	,"?") ]

--
-- Specify which operators are allowed in the simple EXPR mode.
--
simple_ = 
	["=","<>","\\/","/\\","<","<=",">",">=","+",
	 "-","*","/","max","min","mod","div","~","#"
	]
