-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.2
-- //
-- //===========================================================================
-- //
module DevTest.ParserTestLib


where

import Configuration.Face
import SupportLib.MoreIO
import SupportLib.MoreParser
import UU.Pretty(disp)

--
-- testParser : testing parser. The result is echoed back 
-- and optionally stored to a log-file.
--

testParser 
	parser
	showErrorMode
	ppResult	-- pp to display the result
	logFile		
	inputs
	=
	do { println "BEGIN TEST" ;
	     sequence . map tester . zip [0..] $ inputs ;
	     println "END TEST"
	   }

	where

	print   s = logStr logFile s
	println s = print ('\n' : s) 

	showErrors errors = disp (pp_ParseErrors showErrorMode errors)
				  std_PageWidth
				  ""

	showResult r = disp (ppResult r) std_PageWidth ""
	
	tester (i,s) = do
		{ (result,errors) <- parser s 
		  ; println ("INPUT " ++ show i) 
		  ; println hline 
		  ; println (show s) 
		  ; println (showErrors errors)
		  ; if null errors
		    then do { println "ECHOING RESULT:" 
			      ; println  ( showResult result) }
		    else return ()
		}


