-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.2
-- //
-- //===========================================================================
-- //
module DevTest.SCTestLib


where

import Configuration.Face
import SupportLib.MoreIO
import SupportLib.MoreParser
import UU.Pretty
import Engine.SyntaxChecker.PCKG

--
-- testSC : test the syntax checker. The result is echoed back 
-- and optionally stored to a log-file.
--

testSC
	seqparser
	showParseErrorMode
	seq_parsing_mode
	logFile		
	inputs
	=
	do { println "BEGIN TEST" ;
	     sequence . map tester . zip [0..] $ inputs ;
	     println "END TEST"
	   }

	where

	print   s = logStr logFile s
	println s = print ('\n' : s) 

	showParseErrors errors = disp (pp_ParseErrors showParseErrorMode errors)
				  std_PageWidth
				  ""

	showSyntaxErrors serrors = disp (pp serrors) std_PageWidth ""

	tester (i,s) = do
		{   (p,parseerrors)   <- seqparser s 
		  ; syntaxerrors      <- return (sc seq_parsing_mode p)
		  ; println ("INPUT " ++ show i) 
		  ; println hline 
		  ; if null parseerrors
		    then println (showSyntaxErrors syntaxerrors)
		    else println (showParseErrors parseerrors)
		}


