-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.2
-- //
-- //===========================================================================
-- //
module DevTest.TCTestLib


where

import Configuration.Face
import SupportLib.MoreIO
import SupportLib.MoreParser
import UU.Pretty
import Engine.TypeChecker.PCKG

--
-- testTC : test the type checker. The result is echoed back 
-- and optionally stored to a log-file.
--

testTC
	seqparser
	showParseErrorMode
	logFile		
	inputs
	=
	do { println "BEGIN TEST" ;
	     sequence . map tester . zip [0..] $ inputs ;
	     println "END TEST"
	   }

	where

	print   s = logStr logFile s
	println s = print ('\n' : s) 

	showParseErrors errors = disp (pp_ParseErrors showParseErrorMode errors)
				  std_PageWidth
				  ""

	showTypeErrors tyerrors = disp (pp tyerrors) std_PageWidth ""

	tester (i,s) = do
		{   (p,parseerrors)   <- seqparser s 
		  ; (_,tyerrors) <- return (tc p)
		  ; println ("INPUT " ++ show i) 
		  ; println hline 
		  ; if null parseerrors
		    then println (showTypeErrors tyerrors)
		    else println (showParseErrors parseerrors)
		}


