-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.2
-- //
-- //===========================================================================
-- //
module Engine.VCG.Marker

where

import Lang.EXPR.PCKG

data StandardMarker = 
	  SC  		--start condition
	| EC 		--exit condition
	| IC 		--invariance condition
	| TC1 		--termination 1
	| TC2 		--termination 2
	| AOC 		--array-overflow-free condition
	| DZC 		--division-by-0-free condition
--
-- these two are not implemented yet!
--
--	| EFC 		--exception-free condition
--	| ECC		--exception convergence (only forward exception!)
--
	deriving (Eq,Show)

--
-- Remove (top) marker
--
unmark (Marker _ e) = e
unmark e = e

--
-- add a marker
--
mark m (Marker ms e) = Marker (show m : ms) e
mark m e = Marker [show m] e 

--
-- IMP constructor that keeps the marker from right hand side
-- to stick to the root
--
mIMP (Lit (LitBool True _)) q = q
mIMP  p (Marker m q)        = Marker m (p `imp_` q)
mIMP  p q                   = p `imp_` q

markersOf (Marker ms _) = ms
markersOf _             = []

markedBy m e = show m `elem` (markersOf e)

notMarkedBy ms  e = all (`notElem` ms') (markersOf e)
	where
	ms' = map show ms

