-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.2
-- //
-- //===========================================================================
-- //

module Lang.EXPR.Parser_Full(pExpr)

where

--
-- full EXPR parser
--

import UU.Parsing 
import UU.Scanner hiding (pKey,pSpec)
import qualified UU.Scanner (pKey,pSpec)
import Configuration.Lang
import Lang.EXPR.PCKG
import Lang.TYPE.PCKG
import Lang.EXPR.Common_Parser
import PrimitiveConcepts.LC
import SupportLib.MoreParserBasic

fullParserParameter 
	=
	EXPR_ParserParameter
		default_EXPR_unaries
		(order_infixes default_EXPR_infixes)
		default_EXPR_quantors

opsTable = fullParserParameter

pExpr = pLev0 

--
-- Level 0 : quantor, conditional, select
--

pLev0 = 
	    p_Quantor opsTable p_Identifier pLev0 
	<|> p_Cond pLev0 
	<|> p_Select p_Identifier pLev0
	<|> pLev1 

--
-- Level 1 : infix
--

pLev1 = p_Binary opsTable pLev2 

--
-- Level 2: function application, from-to
--

pLev2 =
	p_FromTo pLev3 pLev3
	<|> 	
	p_FunApp pLev3 

--
-- Level 3: concrete list, concrete record, 
--          array and record application
--

pLev3 = 
	    p_List pLev0
	<|> p_Record pLev0 
	<|> p_UnaryString opsTable pLev4 
	<|> p_ArrayRecordApp pLev4 pLev0

--
-- Level 4 (atomic level) : literal, identifier, paranthesized
--

pLev4 =
	    pParensIR pLev0
	<|> p_Literal
	<|> p_Ident



