-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.2
-- //
-- //===========================================================================
-- //

module Lang.EXPR.Parser_PL(pExpr,pLHSAssign)

where

--
-- A more restricted EXPR parser for (simple) expressions in 
-- Prowl's statements: lit,var,rec,array-app,rec-app,
-- unary, binary.
--

import UU.Parsing 
import UU.Scanner hiding (pKey,pSpec)
import qualified UU.Scanner (pKey,pSpec)
import PrimitiveConcepts.LC
import Configuration.Lang
import Lang.EXPR.PCKG
import Lang.TYPE.PCKG
import Lang.EXPR.Common_Parser
import SupportLib.MoreParserBasic

parserParameter =
	EXPR_ParserParameter
		default_simple_EXPR_unaries
		(order_infixes default_simple_EXPR_infixes)
		default_simple_EXPR_quantors

pExpr :: ParserExpr
pExpr = pLev0 

--
-- Level 0 : infixes
--

pLev0 = p_Binary parserParameter pLev1

--
-- Level 1: concrete record, array and record application
--

pLev1 = 
	    p_Record pLev0 
	<|> p_UnaryString parserParameter pLev2
	<|> p_ArrayRecordApp pLev2  pLev0

--
-- Level 2 (atomic level) : literal, identifier, paranthesized
--

pLev2 =
	    pParensIR pLev0
	<|> p_Literal
	<|> p_Ident



--
-- to parse left hand side of an assignment
--
pLHSAssign = p_ArrayRecordApp (p_Ident <|> pParens pLHSAssign) pLev0
