-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.2
-- //
-- //===========================================================================
-- //

module Lang.EXPR.Parser_QL(pExpr)

where

--
-- EXPR parser for (simple) expressions in uPL program with SQL-like
-- extension. This is as Parser_PL, plus function application and
-- queries.
--

import UU.Parsing 
import UU.Scanner hiding (pKey,pSpec)
import qualified UU.Scanner (pKey,pSpec)
import PrimitiveConcepts.LC
import Configuration.Lang
import Lang.EXPR.PCKG
import Lang.TYPE.PCKG
import Lang.EXPR.Common_Parser
import SupportLib.MoreParserBasic

parserParameter =
	EXPR_ParserParameter
		default_simple_EXPR_unaries
		(order_infixes default_simple_EXPR_infixes)
		default_simple_EXPR_quantors

pExpr :: ParserExpr
pExpr = pLev0 

--
-- Level 0 : select and infixes
--

pLev0 =     p_Select p_Identifier pLev0
	<|> p_Binary parserParameter pLev1

--
-- Level 1: function application
--

pLev1 = p_FunApp pLev2

--
-- Level 2: concrete record, array and record application
--

pLev2 = 
	    p_Record pLev0 
	<|> p_UnaryString parserParameter pLev3
	<|> p_ArrayRecordApp pLev3  pLev0

--
-- Level 3 (atomic level) : literal, identifier, paranthesized
--

pLev3 =
	    pParensIR pLev0
	<|> p_Literal
	<|> p_Ident



