-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.2
-- //
-- //===========================================================================
-- //
module Lang.SEQ.Util

where

import SEQ_data
import UU.Pretty
import PrimitiveConcepts.Position
import qualified SEQ_tree
import SEQ_pp
import Configuration.Face
import Lang.EXPR.PCKG

ppParameterTree = SEQ_tree.ppParameter

instance Show Parameter where
  showsPrec _ par s = disp (ppParameterTree False par) std_PageWidth s

instance PP Parameter where
  pp = ppParameter 

ppDeclTree = SEQ_tree.ppDecl

instance Show Decl where
  showsPrec _ decl s = disp (ppDeclTree False decl) std_PageWidth s

instance PP Decl where
  pp = ppDecl 

ppSeqProgTree = SEQ_tree.ppSeqProg 

instance Show SeqProg where
  showsPrec _ prog s = disp (ppSeqProgTree False prog) std_PageWidth s   

instance PP SeqProg where
  pp = ppSeqProg 

instance ContainPos Decl where
  getPos (Decl _ (x:_) _ _) = getPos x
  getPos _                  = dummyPos

instance ContainPos Parameter where
  getPos (Parameter _ _ (x:_) _) = getPos x
  getPos _                       = dummyPos

  

