-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.2
-- //
-- //===========================================================================
-- //
module Lang.STMT.Util

where

import STMT_data
import UU.Pretty
import qualified STMT_tree
import STMT_pp
import Configuration.Face
import Lang.EXPR.PCKG
import PrimitiveConcepts.ErrorMsg
import PrimitiveConcepts.Position

instance Show MaybeExpr
  where
  showsPrec _ e s = disp (STMT_tree.ppMaybeExpr False e)  std_PageWidth s

instance Show Stmt
  where
  showsPrec _ stmt s = disp (STMT_tree.ppStmt False stmt)  std_PageWidth s

ppMaybeExprTree = STMT_tree.ppMaybeExpr

instance PP MaybeExpr
  where
  pp = ppMaybeExpr 

ppStmtTree = STMT_tree.ppStmt

instance PP Stmt
  where
  pp = ppStmt 

instance ContainPos Stmt where
  getPos stmt = case stmt of
	Skip			-> internalError "getPos on skip" "STMT.Util"
	Asg p _ _		-> p
	Seq (s:_)		-> getPos s
	IfElse p _ _ _		-> p
	While p _ _ _ _ _ 	-> p
	ForLoop p _ _ _ _ _ _ _ _ -> p

instance ContainPos MaybeExpr where
   getPos (JUST e) = getPos e
   getPos _ = internalError "getPos on NOTHING" "STMT.Util"
