-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.2
-- //
-- //===========================================================================
-- //
--
-- For parsing arbitrary type expression. 
-- Primitive types: Char,Bool,Int,String.
-- Available type constructors: list,function,array,record.
-- 

module Lang.TYPE.Parser0(pType)

where

import UU.Parsing 
import UU.Scanner hiding (pKey,pSpec)
import Lang.TYPE.PCKG
import Lang.TYPE.Common_Parser

{- 
Note: User-defined types are allowed, but only 0-argument
user-types. I don't think it's a real problem to drop this
restriction, but substantial additional coding will be needed to add
for example arity checking and, if data type like specification is
allowed, to keep track of the types of the data constructors.  
-}

{- 
Because of the left-recursive syntax of TYPE specification, we
break it down to level-parsing as below.  
-}

pType      = pFuncType pListty
pListty    = pListType pArrayty <|> pArrayty
pArrayty   = pArrayType (pRecty <|> pTyApp)
pRecty     = pRecordType pType
--
-- For now pTyApp is just pAtom
--
-- pTyConsApp = pTyAtom <??> (lipat <$> pList1 pTyAtom)
--
pTyApp     = pAtomTy pType





