-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.2
-- //
-- //===========================================================================
-- //
--
-- more restricted TYPE parsers 
--
{-
pType_1		: primitive types, 0-arg user type, record, array
pType_1L	: 1 + list
pType_1LP	: 1L + tvar

pType_2		: as 1, but with only top level arrays 
pType_2_wSize	: as 2, but also parse and return size specs (of
                  top level array)
pType_2L	: as 2, but with list
pType_2L_wSize	: as 2L, but also parse size specs
-}

module Lang.TYPE.Parser1(
	 pType_1
	,pType_1L
	,pType_1LP
	,pType_2
	,pType_2_wSize
	,pType_2L
	,pType_2L_wSize
	)
where

import UU.Parsing 
import UU.Scanner hiding (pKey,pSpec)
import Lang.TYPE.PCKG
import Lang.TYPE.Common_Parser
import SupportLib.MoreParserBasic

--
-- atom without tyvar
--
pAtomTy_  pTop = pPrimType 		
		<|> (\tname-> TyCons tname []) <$> pConid  -- user defined type-constant
		<|> pParensIR pTop


pType_1		= pArrayType (pRecordType pType_1 <|> pAtomTy_ pType_1)

pType_1L	= pListType pType_1L
		  <|>
		  pArrayType (pRecordType pType_1L <|> pAtomTy_ pType_1L)

pType_1LP	= pListType pType_1LP
		  <|>
		  pArrayType (pRecordType pType_1LP <|> pAtomTy pType_1LP)

pType_2		= pArrayType (pRec <|> pAtom)
	where
	pRec  = pRecordType (pAtom <|> pRec)
	pAtom = pAtomTy_ pRec

pType_2_wSize pSize =  pArray_wSize_Type (pRec <|> pAtom) pSize
	where
	pRec  = pRecordType (pAtom <|> pRec)
	pAtom = pAtomTy_ pRec

pType_2L	= pList <|> pArrayType (pRec <|> pAtom)
	where
	pList = pListType pRec
	pRec  = pRecordType (pAtom <|> pRec)
	pAtom = pAtomTy_ (pRec <|> pList)

pType_2L_wSize pSize = f <$> pList <|> pArray_wSize_Type (pRec <|> pAtom) pSize
	where
	f ty  = (ty,[])
	pList = pListType pRec
	pRec  = pRecordType (pAtom <|> pRec)
	pAtom = pAtomTy_ (pRec <|> pList)

pArray_wSize_Type pElemTy pSize = lipat <$> pElemTy <*> pList p_brackets

	where
	p_brackets   = pSpec '[' *> pSize <* pSpecAI ']'
	lipat e dims = (foldr (const mk_ArrayTy) e dims, dims)

