-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.2
-- //
-- //===========================================================================
-- //
--
-- xMECH main's APIs to access syntax checker, type checker,
-- and vcg
--
module Main.LogicAPI(
	 syc
	,tyc
	,vcgen
	)

where

--
-- importing the checkers and the vcg
--
import Engine.PCKG

import UU.Pretty
import Lang.SEQ.PCKG(SeqProg)
import Lang.EXPR.PCKG(ExprList)
import Main.ParserAPI(ParsingMode(..))

max_num_of_errors = (10::Int)

--
-- API to syntax checker
-- 
-- Pass errors as is as a trick to avoid call from main to be
-- evaluated too eagerly.
--
syc :: ParsingMode -> SeqProg -> IO(SyntaxErrorList,PP_Doc)
syc mode prog = return (errors',pp errors')

	where

	errors  = sc mode' prog
	errors' = take max_num_of_errors errors

	mode'	= case mode of
			BASIC	-> "PL"
			QL	-> "QL"



--
-- API to type checker
--
tyc :: SeqProg -> IO(SeqProg,TypeConstraintErrorList,PP_Doc)
tyc prog = return (prog',errors',pp errors')

	where
	(prog',errors)	= tc prog
	errors'		= take max_num_of_errors errors

--
-- API to vcg
--
vcgen :: ReduceOption -> SeqProg -> IO (ExprList,PP_Doc)
vcgen reduceOption prg = return (vcs, pp_vcs vcs)
	where
	vcs = vcg0 reduceOption prg
