-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.2
-- //
-- //===========================================================================
-- //
--
-- Provide API to parser for xMECH main
--
module Main.ParserAPI(
	 parser
	,ParsingMode(..)
	)

where

--
-- importing parsers
--
import UU.Parsing
import MechScanner.PCKG
import SupportLib.MoreParser
import Lang.SEQ.Parsers


--
-- importing other stuffs
--
import UU.Pretty(PP_Doc)
import SEQ_data(SeqProg)

scanner = fileScanner scannerspec

data ParsingMode =
	  BASIC		--basic uPL
	| QL		--with Query Language extension
	deriving Show

--showErrorMode  = ShowErrorMode_SOME 5
showErrorMode  = ShowErrorMode_ALL

--
-- API to parser to parse programs
--
parser :: ParsingMode -> String -> IO(SeqProg,Maybe PP_Doc)
parser parsingmode inputfile 
	= 
	do 
	{ (ptree,errormessages) <- parseFile scanner pProg inputfile 

	; if null errormessages

	  then return (ptree,Nothing) 

	  else return (ptree, Just (pp_ParseErrors showErrorMode errormessages))

	}

	where
	pProg = case parsingmode of

		BASIC	-> pSeqProg_PL
	
		QL	-> pSeqProg_QL

