-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.2
-- //
-- //===========================================================================
-- //
module MechScanner.PCKG(
	 fileScanner
	,stringScanner
	,specialchars
	,opchars
	,ScannerSpec(..)
	,ss_MERGE
	)

where

import UU.Scanner(scan,scanFile,initPos)
import List(nub)

--
-- These are the special and characters used for all x-MECH LITE 
-- scanners. These sets are FIXED.
--

specialchars = "~;()[],.@&{}"			
opchars      = "+/*:\\/=><#!%?^|-"

--
-- Use this to parameterize a LITE scanner with the lists of
-- keywords
--

data ScannerSpec 
	= 
	ScannerSpec { keywordstxt,keywordsops :: [String] }
	
--
-- Some operators to merge scanner specs
--

ss_merge (ScannerSpec kws1 kwos1) (ScannerSpec kws2 kwos2)
	=
	ScannerSpec (kws1 ++ kws2) (kwos1 ++ kwos2)

ss_MERGE specs = ScannerSpec kws kwos
	where
	emptyspec = ScannerSpec [] []
	combospec = foldr ss_merge emptyspec specs
	kws  = nub . keywordstxt $ combospec
	kwos = nub . keywordsops $ combospec

--
-- LITE's file and string scanners
--

fileScanner scannerspec fileName 
	= scanFile
		(keywordstxt scannerspec)		
		(keywordsops scannerspec)
		specialchars
		opchars
		fileName

stringScanner scannerspec input
	= 
	scan
	(keywordstxt scannerspec)		
	(keywordsops scannerspec)
	specialchars
	opchars
	(initPos "dummy")
	input
