-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.2
-- //
-- //===========================================================================
-- //
module PrimitiveConcepts.ErrorMsg(
	 errorMsgBox
	,internalError
	)

where

import UU.Pretty 
import Configuration.Face
import PrimitiveConcepts.Position


hline  = text (replicate (std_PageWidth `div` 2) '~')

errorMsgBox :: Maybe Pos -> String -> PP_Doc -> PP_Doc
errorMsgBox pos header pp_error_msg 
	=
		(text header >#< pos_ )
		>-<
		hline
		>-<
		pp_error_msg
		>-<
		hline

	where

	pos_ = case pos of
		Just p	-> pp_parens (pp p)
		_	-> empty

internalError info source 
	= 
	error ("Application internal error.\n\nWhy: " ++ info ++ "\n\nLocation: "
		++ source 
		++ 
		"\n\nHelp the authors by mailing the above message to them.")
