-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.2
-- //
-- //===========================================================================
-- //
module PrimitiveConcepts.Position(
	 Pos(Pos)
	,dummyPos
	,ContainPos(..)
	)

where

import Char
import UU.Scanner(Pos(..),Position(..))
import UU.Pretty

instance PP Pos where
  pp p = text "line" 
	    >#< (text . show . line $ p)
	    >#< text "col." 
   	    >#< (text . show . column $ p)
	    >|< (if dummy_fname 
	         then empty
	         else text " file" >#< show fname 
	         )
 		where
		fname = file p
		dummy_fname = null fname || (map toLower fname == "dummy")

dummyPos = Pos (-1) (-1) ""

class ContainPos t where
  getPos :: t -> Pos
