-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.2
-- //
-- //===========================================================================
-- //
module SupportLib.MoreIO

where

import UU.Pretty
import Configuration.Face

skip :: IO()
skip     = return()

disp_ pp = disp pp std_PageWidth ""
dispW pp = disp pp wide_PageWidth ""

putPP  = putStr . disp_
putPPW = putStr . dispW

--
-- write and append to file, with optional echo to screen
--
writeStr :: Bool -> String -> String -> IO()
writeStr echoflag fname s 
	=
	if echoflag == True
	then do { putStr s ; writeFile fname s } 
	else writeFile fname s

writePP  flag fname = writeStr flag fname . disp_ 
writePPW flag fname = writeStr flag fname . dispW 

appendStr :: Bool -> String -> String -> IO()
appendStr echoflag fname s 
	=
	if echoflag == True
	then do { putStr s ; appendFile fname s } 
	else appendFile fname s

appendPP  flag fname = appendStr flag fname . disp_ 
appendPPW flag fname = appendStr flag fname . dispW 

--
-- these ones always echo to screen
--
writeStr_ = writeStr True
writePP_  = writePP  True
writePPW_ = writePPW True

appendStr_ = appendStr True
appendPP_  = appendPP  True
appendPPW_ = appendPPW True
 
hline = replicate std_PageWidth '-'

--
-- Print string to the screen, optionally echo to a log file.
--
logStr logfile s 
	=
	do { putStr s 
	   ; case logfile of
		Nothing	-> return()
		Just f  -> appendFile f s
	}

initializeLogFile logfile = case logfile of
	Nothing		-> return ()
	Just fname	-> writeFile fname ""

