-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.2
-- //
-- //===========================================================================
-- //
module SupportLib.MorePretty

where

import UU.Pretty
import Configuration.Face

type PP_Doc2 = (PP_Doc,PP_Doc)
type PP_Docs = [PP_Doc]

--
-- Making a horizontal list of items, with a separator
--
hlist_sep sep pps = foldr op empty pps
	where
	op pp r = pp >|< text sep >|< r

--
-- hvindent i pp pps will either format pp and pps horizontally,
-- or pp, newline, and then all elements of pps vertically, 
-- indented i spaces.
--

hvindent indentWidth pp pps = format1 >^< format2
	where
	format1 = pp >#< hlist_sp pps
	format2 = pp >-< indent indentWidth (vlist pps) 	

hvindent_ pp pps = hvindent std_indentWidth pp pps

hvindent__   []       = empty
hvindent__  (pp:pps)  = hvindent_ pp pps

insert_sep _ []         = []
insert_sep sep (pp:pps) = pp : map (text sep >|<) pps 

insert_sep_enc l r sep [  ]     = [text l, text r]
insert_sep_enc l r sep (pp:pps) = (insert_sep sep ((text l >|< pp) : pps)) ++ [text r]

vlist_ [] = empty
vlist_ (pp:pps)       = pp_parens (pp >#< vlist pps)

vlist_indent [] = empty
vlist_indent (pp:pps) = pp >-< indent std_indentWidth (vlist pps)
vlist_indent_ :: PP a => [a] -> PP_Doc
vlist_indent_ = pp_parens . vlist_indent

--
-- For showing parse-tree
--
pptree pp_constructor args_pps 
	=
	case args_pps of
	[] 	-> pp_constructor 
	[pp]	-> pp_parens (pp_constructor >#< pp)
	_	-> pp_parens (pp_constructor >-< pp_args)

	where
	pp_args = indent std_indentWidth . vlist $ args_pps

--
-- Showing list 
--
pplist_ w pps =
	if length pps <= w
	then hlist pps_
	else vlist pps_
	where
	pps_ = insert_sep_enc "[" "]" "," pps
