-- //===========================================================================
-- //
-- // AUTHOR(S): Wishnu Prasetya, Ade Azurat
-- // PACKAGE  : (c)xMECH, class LITE, version alpha 1.3.2
-- //
-- //===========================================================================
-- //
module UserInteraction.Screen(
	pp_mechBanner
	,pp_help
	,pp_credits
	)

where

import Configuration.Face
import UserInteraction.Banner
import UU.Pretty

--
-- ANSI things
--
--    xmech color: blood red on black back ground.
--

data ANSI_Toggle = ANSI_ON | ANSI_OFF deriving Eq

set_textColor_xmech = "\27[1;31;40m"
reset_textColor     = "\27[0m"

--
-- Utilities for showing text
--
--

hline w char = replicate w char

pp_inBox :: ANSI_Toggle -> Int -> Int -> Int -> [String] -> PP_Doc
pp_inBox
	ansi_toggle
	pageWidth
	borderWidth 
	padding
	contents
	= 
  	topborder
	>-< vlist (map enclose contents)
	>-< botborder

	where

	char_h  = '='
	char_v  = '='
	char_sp	= ' '

	border      = text (replicate borderWidth char_v)
	padding_    = text (replicate padding char_sp)
	leftborder  = border >|< padding_
	rightborder = padding_ >|< border

	hborder	    = addANSI . text $ (hline pageWidth '=')
	hborder_    = vlist
		      . replicate padding
		      . addANSI
		      $ (leftborder 
			 >|< text (hline innerWidth char_sp)
			 >|< rightborder)

	topborder  = hborder >-< hborder_
	botborder  = hborder_ >-< hborder

	enclose s  = addANSI (leftborder >|< text (fillRight s) >|< rightborder)

	fillRight s = take innerWidth (s ++ repeat char_sp)

	innerWidth = pageWidth - (2 * borderWidth) - (2 * padding)

	addANSI t = case ansi_toggle of 
			ANSI_OFF  -> t
			ANSI_ON   -> text set_textColor_xmech 
					>|< t
					>|< text reset_textColor


pp_mechBanner = pp_inBox ansi_toggle std_PageWidth 2 0 mechBanner
	where
	ansi_toggle = if ansiEnabled then ANSI_ON else ANSI_OFF

pp_help help_txt = pp_inBox ansi_toggle std_PageWidth 2 1 help_txt
	where
	ansi_toggle = if ansiEnabled then ANSI_ON else ANSI_OFF

pp_credits = pp_inBox ansi_toggle std_PageWidth 2 3 credit_txt
	where
	ansi_toggle = if ansiEnabled then ANSI_ON else ANSI_OFF

	credit_txt =
		["We would like to thank the following people:",
		 "" ]
		++
		map (tab ++) credits

	tab = replicate std_indentWidth ' '

